'use strict';
module.exports = {
    up: (queryInterface, Sequelize) => {
        return queryInterface.createTable('Groups', {
            id: {
                allowNull: false,
                autoIncrement: true,
                primaryKey: true,
                type: Sequelize.INTEGER
            },
            name: {
                type: Sequelize.STRING
            },
            parentId: {
                type: Sequelize.INTEGER
            },
            userCount: {
                type: Sequelize.INTEGER,
                defaultValue: 0
            },
            rootId: {
                type: Sequelize.INTEGER
            },
            status: {
                type: Sequelize.ENUM('pending', 'failed', 'completed'),
                defaultValue: 'pending'
            },
            companyId: {
                type: Sequelize.INTEGER,
                allowNull: false,
                references: {
                    model: 'Companies',
                    key: 'id'
                }
            },
            managerId: {
                type: Sequelize.INTEGER,
                allowNull: true,
                references: {
                    model: 'Members',
                    key: 'id'
                }
            },
            createdAt: {
                allowNull: false,
                type: Sequelize.DATE
            },
            updatedAt: {
                allowNull: false,
                type: Sequelize.DATE
            },
            deletedAt: {
                allowNull: true,
                type: Sequelize.DATE
            }
        });
    },
    down: (queryInterface, Sequelize) => {
        return queryInterface.dropTable('Groups');
    }
};