'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    try{
      return queryInterface.createTable('Contents', {
        id: {
          allowNull: false,
          autoIncrement: true,
          primaryKey: true,
          type: Sequelize.INTEGER
        },
        name: {
          type: Sequelize.STRING
        },
        originalName: {
          type: Sequelize.STRING
        },
        type: {
          type: Sequelize.STRING
        },
        key: {
          type: Sequelize.STRING
        },
        mimeType: {
          type: Sequelize.STRING
        },
        content: {
          type: Sequelize.TEXT
        },
        duration: {
          type: Sequelize.INTEGER,
          defaultValue: 0
        },
        thumbnail: {
          type: Sequelize.STRING
        },
        companyId: {
          type: Sequelize.INTEGER,
          allowNull: false,
          references: {
            model: 'Companies',
            key: 'id'
          }
        },
        createdAt: {
          allowNull: false,
          type: Sequelize.DATE
        },
        updatedAt: {
          allowNull: false,
          type: Sequelize.DATE
        },
        deletedAt: {
          allowNull: true,
          type: Sequelize.DATE
        }
      });
    }catch(e){
    console.log("TCL: e", e)
  
    }
    
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('Contents');
  }
};