'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return Promise.all([
        queryInterface.removeColumn( 'Members', 'companyId' ),
        queryInterface.removeColumn( 'MetaAuths', 'companyId' ),
        queryInterface.changeColumn('MetaAuths', 'attempt', {  type: Sequelize.INTEGER, defaultValue: 0 }),
        queryInterface.addColumn('MetaAuths', 'resetAttempt', {  type: Sequelize.INTEGER, defaultValue: 0,  after: "attempt" })
      ])
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
      queryInterface.addColumn( 'Members', 'companyId', { type: Sequelize.INTEGER } ),
      queryInterface.addColumn( 'MetaAuths', 'companyId', { type: Sequelize.INTEGER } ),
      queryInterface.changeColumn('MetaAuths', 'attempt', {  type: Sequelize.STRING, defaultValue: null }),
      queryInterface.removeColumn('MetaAuths', 'resetAttempt')
    ])
  }
};
