'use strict';
module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('CourseUserQuizAnswers', {
      id: {
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
        type: Sequelize.INTEGER
      },
      courseSectionLectureId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'CourseSectionLectures',
					key: 'id'
				}
      },
      courseQuizQuestionId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'CourseQuizQuestions',
					key: 'id'
				}
      },
      courseQuizQuestionOptionId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'CourseQuizQuestionOptions',
					key: 'id'
				}
      },
      sessionId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Sessions',
					key: 'id'
				}
      },
      courseId: {
        type: Sequelize.INTEGER,
        allowNull: false,
				references: {
					model: 'Courses',
					key: 'id'
				}
      },
      marks: {
        type: Sequelize.INTEGER
      },
      isCorrect: {
        type: Sequelize.INTEGER
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE
      },
      deletedAt: {
        allowNull: true,
				type: Sequelize.DATE
			}
    });
  },
  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('CourseUserQuizAnswers');
  }
};