"use strict";

var addCreatedAt = value => {
  value["createdAt"] = new Date();
  value["updatedAt"] = new Date();
};

module.exports = {
  up: (queryInterface, Sequelize) => {
    var data = [
      {
        name: "home-full-access",
        type: "managed"
      },
      {
        name: "course-full-access",
        type: "managed"
      }, 
      {
        name: "course-list-access",
        type: "managed"
      },
      {
        name: "course-read-access",
        type: "managed"
      },
      {
        name: "course-write-access",
        type: "managed"
      },
      {
        name:"course-delete-access",
        type: "managed"
      },
      {
        name: "department-full-access",
        type: "managed"
      },
      {
        name: "department-list-access",
        type: "managed"
      },
      {
        name: "department-read-access",
        type: "managed"
      },
      {
        name: "department-write-access",
        type: "managed"
      },
      {
        name: "department-delete-access",
        type: "managed"
      },
      {
        name: "skill-full-access",
        type: "managed"
      },
      {
        name: "skill-list-access",
        type: "managed"
      },
      {
        name: "skill-read-access",
        type: "managed"
      },
      {
        name: "skill-write-access",
        type: "managed"
      },
      {
        name: "skill-delete-access",
        type: "managed"
      },
      {
        name: "campaign-full-access",
        type: "managed"
      },
      {
        name: "campaign-read-access",
        type: "managed"
      },
      {
        name: "campaign-list-access",
        type: "managed"
      },
      {
        name: "campaign-write-access",
        type: "managed"
      },
      {
        name: "campaign-delete-access",
        type: "managed"
      },
      {
        name: "campaign-result-access",
        type: "managed"
      },
      {
        name: "analytic-full-access",
        type: "managed"
      },
      {
        name: "analytic-read-access",
        type: "managed"
      },
      {
        name: "analytic-write-access",
        type: "managed"
      },
      {
        name: "quiz-full-access",
        type: "managed"
      },
      {
        name: "quiz-list-access",
        type: "managed"
      },
      {
        name: "quiz-read-access",
        type: "managed"
      },
      {
        name: "quiz-write-access",
        type: "managed"
      },
      {
        name: "quiz-delete-access",
        type: "managed"
      },
      {
        name: "quiz-leaderboard-access",
        type: "managed"
      },
      {
        name:"report-full-access",
        type:"managed"
      },
      {
        name:"report-list-access",
        type:"managed"
      },
      {
        name:"report-read-access",
        type:"managed"
      },
      {
        name:"report-write-access",
        type:"managed"
      },
      {
        name:"report-delete-access",
        type:"managed"
      },
      {
        name: "setting-full-access",
        type: "managed"
      },
      {
        name: "setting-read-access",
        type: "managed"
      },
      {
        name: "setting-write-access",
        type: "managed"
      },
      {
        name:"policy-full-access",
        type: "managed"
      },
      {
        name:"policy-read-access",
        type: "managed"
      },
      {
        name:"policy-power-access",
        type: "managed"
      },
      {
        name:"policy-delete-access",
        type: "managed"
      },
      {
        name:"user-full-access",
        type: "managed"
      },
      {
        name:"user-power-access",
        type: "managed"
      },
      {
        name:"user-read-access",
        type: "managed"
      },
      {
        name:"user-delete-access",
        type: "managed"
      },
      {
        name:"user-policy-full-access",
        type: "managed"
      },
      {
        name:"user-policy-read-access",
        type: "managed"
      },
      {
        name:"user-policy-power-access",
        type: "managed"
      },
    ];
    data.reduce((p, value) => {
      return addCreatedAt(value);
    }, Promise.resolve());
    return queryInterface.bulkInsert("Policies", data, {});
  },
  down: (queryInterface, Sequelize) => {
    return Promise.all([
        queryInterface.sequelize.query("SELECT `id` FROM Policies", { type: queryInterface.sequelize.QueryTypes.SELECT})
    ])
    .then(r => {
        var policyIds = [];
        for(var i=0;i<r[0].length; i++){
            policyIds.push(r[0][i].id)
        }
        return policyIds;
    })
    .then(policyIds => {
        return queryInterface.bulkDelete('Policies', {id: policyIds}, {});
    })
  }
};
