"use strict";

var addCreatedAt = value => {
  value["createdAt"] = new Date();
  value["updatedAt"] = new Date();
};
module.exports = {
  up: (queryInterface, Sequelize) => {
    var data = [
      {
        name: "home-read",
        type: "read"
      },
      {
        name: "course-read",
        type: "read"
      },
      {
        name: "course-write",
        type: "write"
      },
      {
        name: "course-list",
        type: "list"
      },
      {
        name: "course-delete",
        type: "delete"
      },
      {
        name: "department-list",
        type: "list"
      },
      {
        name: "department-read",
        type: "read"
      },
      {
        name: "department-write",
        type: "write"
      },
      {
        name: "department-delete",
        type: "delete"
      },
      {
        name: "skill-list",
        type: "list"
      },
      {
        name: "skill-read",
        type: "read"
      },
      {
        name: "skill-write",
        type: "write"
      },
      {
        name: "skill-delete",
        type: "delete"
      },
      {
        name: "campaign-list",
        type: "list"
      },
      {
        name: "campaign-read",
        type: "read"
      },
      {
        name: "campaign-write",
        type: "write"
      },
      {
        name: "campaign-delete",
        type: "delete"
      },
      {
        name: "campaign-result-read",
        type: "read"
      },
      {
        name: "analytic-read",
        type: "read"
      },
      {
        name: "analytic-course-read",
        type: "read"
      },
      {
        name: "analytic-department-list-read",
        type: "read"
      },
      {
        name: "analytic-learner-list-read",
        type: "read"
      },
      {
        name: "analytic-write",
        type: "write"
      },
      {
        name: "quiz-list",
        type: "list"
      },
      {
        name: "quiz-read",
        type: "read"
      },
      {
        name: "quiz-write",
        type: "write"
      },
      {
        name: "quiz-delete",
        type: "delete"
      },
      {
        name: "quiz-leaderboard-read",
        type: "read"
      },
      {
        name:"report-read",
        type:"read"
      },
      {
        name:"report-list",
        type:"list"
      },
      {
        name:"report-write",
        type:"write"
      },
      {
        name:"report-delete",
        type:"delete"
      },
      {
        name:"setting-read",
        type:"read"
      },
      {
        name:"setting-write",
        type:"write",
      },
      {
        name:"policy-action-read",
        type:"read"
      },
      {
        name:"policy-read",
        type:"read"
      },
      {
        name:"policy-write",
        type:"write"
      },
      {
        name:"policy-delete",
        type:"delete"
      },
      {
        name:"user-write",
        type:"write",
      },
      {
        name:"user-read",
        type:"read"
      },
      {
        name:"user-delete",
        type:"delete",
      },
      {
        name:"user-policy-assign",
        type:"write"
      },
      {
        name: "user-policy-read",
        type:"read",
      },
      {
        name:"user-policy-delete",
        type:"delete",
      }
    ];
    data.reduce((p, value) => {
      return addCreatedAt(value);
    }, Promise.resolve());
    return queryInterface.bulkInsert("Actions", data, {});
  },

  down: (queryInterface, Sequelize) => {
    return Promise.all([
			queryInterface.sequelize.query("SELECT `id` FROM Actions", { type: queryInterface.sequelize.QueryTypes.SELECT})
        ])
		.then(r => {
			var actionIds = [];
			for(var i=0;i<r[0].length; i++){
				actionIds.push(r[0][i].id)
			}
			return actionIds;
		})
		.then(actionIds => {
			return queryInterface.bulkDelete('Actions', {id: actionIds}, {});
		})
  }
};