'use strict';

var getActionIds = (name, queryInterface) => {
	for (var i = 0; i < name.length; i++) {
		name[i] = '\'' + name[i] + '\'';
	}
	return queryInterface.sequelize.query("SELECT `id` FROM Actions WHERE `name` IN (" + name + ")", { type: queryInterface.sequelize.QueryTypes.SELECT });
}

var getPolicyId = (name, queryInterface) => {
	name = "\"" + name + "\"";
	return queryInterface.sequelize.query("SELECT `id` FROM Policies WHERE `name`=" + name, { type: queryInterface.sequelize.QueryTypes.SELECT });
}

var insertIntoPolicyAction = (policyName, actionName, queryInterface) => {
	return getPolicyId(policyName, queryInterface)
		.then(policyId => {
			return getActionIds(actionName, queryInterface).then(r => [r, policyId])
		})
		.then(([actionId, policyId]) => {
			var data = [];
			for (var i = 0; i < actionId.length; i++) {
				data.push({
					actionId: actionId[i].id,
					policyId: policyId[0].id,
					createdAt: new Date(),
					updatedAt: new Date(),
				})
			}
			return data;
		})
		.then(data => {
			if (data.length) return queryInterface.bulkInsert("PolicyActions", data, {});
		})
		.catch(err => {
			console.log(JSON.stringify(err));
		})
}

var policyData = {
	"home-full-access": [
		"home-read",
	],
	"course-full-access":[
		"course-read",
		"course-write",
		"course-list",
		"course-delete",
	],
	"course-list-access":[
		"course-list"
	],
	"course-read-access":[
		"course-list",
		"course-read"
	],
	"course-write-access":[
		"course-write"
	],
	"course-delete-access":[
		"course-delete"
	],
	"department-full-access":[
		"department-list",
		"department-read",
		"department-write",
		"department-delete",
	],
	"department-list-access":[
		"department-list",
	],
	"department-read-access":[
		"department-read",
		"department-list"
	],
	"department-write-access":[
		"department-write",
	],
	"department-delete-access":[
		"department-delete",
	],
	"skill-full-access":[
		"skill-list",
		"skill-read",
		"skill-write",
		"skill-delete",
	],
	"skill-list-access":[
		"skill-list",
	],
	"skill-read-access":[
		"skill-read",
		"skill-list"
	],
	"skill-write-access":[
		"skill-write",
	],
	"skill-delete-access":[
		"skill-delete",
	],
	"campaign-full-access":[
		"campaign-list",
		"campaign-read",
		"campaign-write",
		"campaign-delete",
	],
	"campaign-read-access":[
		"campaign-read",
		"campaign-list"
	],
	"campaign-list-access":[
		"campaign-list"
	],
	"campaign-write-access":[
		"campaign-write"
	],
	"campaign-delete-access":[
		"campaign-delete"
	],
	"campaign-result-access":[
		"campaign-result-read"
	],
	"analytic-full-access":[
		"analytic-read",
		"analytic-write",
		"analytic-course-read",
		"analytic-learner-list-read",
		"analytic-department-list-read",
	],
	"analytic-read-access":[
		"analytic-read",
		"analytic-course-read",
		"analytic-learner-list-read",
		"analytic-department-list-read",
	],
	"analytic-write-access":[
		"analytic-write"
	],
	"quiz-full-access":[
		"quiz-list",
		"quiz-read",
		"quiz-write",
		"quiz-delete",
	],
	"quiz-read-access":[
		"quiz-read",
		"quiz-list"
	],
	"quiz-list-access":[
		"quiz-list"
	],
	"quiz-write-access":[
		"quiz-write"
	],
	"quiz-delete-access":[
		"quiz-delete"
	],
	"quiz-leaderboard-access":[
		"quiz-leaderboard-read"
	],
	"report-full-access":[
		"report-read",
		"report-write",
		"report-list",
		"report-delete",
	],
	"report-list-access":[
		"report-list"
	],
	"report-read-access":[
		"report-list",
		"report-read"
	],
	"report-write-access":[
		"report-write"
	],
	"report-delete-access":[
		"report-delete"
	],
	"setting-full-access": [
		"setting-read",
		"setting-write",
	],
	"setting-read-access": [
		"setting-read",
	],
	"setting-write-access": [
		"setting-write",
	],
	"policy-full-access": [
		"policy-action-read",
		"policy-read",
		"policy-write",
		"policy-delete",
	],
	"policy-read-access": [
		"policy-action-read",
		"policy-read"
	],
	"policy-power-access": [
		"policy-action-read",
		"policy-read",
		"policy-write",
	],
	"policy-delete-access": [
		"policy-action-read",
		"policy-read",
		"policy-delete",
	],
	"user-full-access": [
		"user-write",
		"user-read",
		"user-policy-assign",
		"user-policy-delete",
		"user-delete",
	],
	"user-read-access": [
		"user-read",
	],
	"user-power-access":[
		"user-write",
		"user-read",
		"user-policy-assign"
	],
	"user-delete-access": [
		"user-read",
		"user-delete",
		"policy-delete"
	],
	"user-policy-full-access": [
		"user-read",
		"user-write",
		"user-policy-read",
		"user-policy-assign",
		"user-policy-delete",
	],
	"user-policy-read-access":[
		"user-policy-read",
		"user-read",
	],
	"user-policy-power-access":[
		"user-policy-read",
		"user-read",
		"user-write",
		"user-policy-assign",
	],

}

module.exports = {
	up: (queryInterface, Sequelize) => {
		return Object.keys(policyData).reduce((p, data) => {
			return insertIntoPolicyAction(data, policyData[data], queryInterface)
		}, Promise.resolve())
	},

	down: (queryInterface, Sequelize) => {
		return Promise.all([
			queryInterface.sequelize.query("SELECT `id` FROM Policies", { type: queryInterface.sequelize.QueryTypes.SELECT })
		])
			.then(r => {
				var policyIds = [];
				for (var i = 0; i < r[0].length; i++) {
					policyIds.push(r[0][i].id)
				}
				return policyIds;
			})
			.then(policyIds => {
				return queryInterface.bulkDelete('PolicyActions', { policyId: policyIds }, {});
			})
	}
};

