var packagePrices = {};
var packageFeatures = {};

var backToPlan = function() {
    $('#plansShow').hide();
    $('#fullBillWrap').show();
    $('#back-to-plan').hide();
}

var upgradePlan = function(){
    $('#plansShow').show();
    $('#fullBillWrap').hide();
    $('#back-to-plan').show();
    $('.step-main').removeClass('active');
    loadPackage();
    nextStep('step1');
}

var clearPackage = function(){
    $('#monthly-plans').html('');
    $('#annually-plans').html('');
    $('#pack-name').val('');
    $('#price-name').val('');
    $('#noofemail-toupgrade').val('');
    packagePrices = {};
    packageFeatures = {};
}

var validateQuery = function(){
    clearErrors();
    var data = new Object();
    data.name = $('#name').val();
    if(data.name.length == 0)
        addError('name', 'Please enter a name');
    data.email = $('#emailPrice').val();
    if(data.email.length == 0)
        addError('emailPrice', 'Please enter your email');
    else if(!validateEmail(data.email))
        addError('emailPrice1', 'Please enter your valid email');
    data.company = $('#companyname').val();
    if(data.company.length == 0)
        addError('company', 'Please Enter No. of Email Ids');
    data.noOfEmails = $('#noofemail').val();
    if(data.noOfEmails.length == 0)
        addError('noofemail', 'Please Enter No. of Email Ids');
    else if(data.noOfEmails <= 2000)
        addError('noofemail1', 'Please Enter No. of Email Ids above 2000');
    hasError() && showErrors();
    return data;
}

var saveQuery = function(){
    var data = validateQuery();
    if(data && !hasError()){
        api.billing.post(data, function(success) {
            if(success && success.success){
                $('#quoteModal').modal('hide');
                swal({ title: "", type: "success", text: success.msg, })
            }
        })
    }
}

var setFeatures = function(data){
    $('.feature-'+data.packageId).append('<li>'+data.name+'</li>');
}

var validatePack = function(){
    clearErrors();
    if($('#noofemail-toupgrade').val().length == 0)
        addError('er', 'Please Enter No. of Email Ids');
    hasError() && showErrors();
}

var fetchPack = function(){
    validatePack();
    if($('#noofemail-toupgrade').val() > 2000){
        $('#noEmail').modal('hide');
        $('#quoteModal').modal('show');
        $('#noofemail').val($('#noofemail-toupgrade').val());
        
    }else{
        var data = new Object();
        data.packageId = $('#pack-name').val();
        data.type = $('#price-name').val();
        data.noOfEmails = $('#noofemail-toupgrade').val();
        !hasError() && $('#spinner').show() && api.billing.step2( data, function(success) {
            $('#noEmail').modal('hide');
            $('.payment-wrap').html('').html('<iframe width="768" height="1100" src="'+ success.data+'" style="border:none;"></iframe>')
            $('html, body').animate({scrollTop:(0)}, '0');
            nextStep('step2');
            setTimeout(function(){$('#spinner').hide() },1000)
        },function(e){
            $('#spinner').hide() 
        })
    }
}

var getpackDetails = function(pId, type){
    $('#pack-name').val(pId);
    $('#price-name').val(type);
    $('#noofemail-toupgrade').val('');  
}

var setPackage = function(data, i){
    var monthlyPrice = annuallyPrice = 0; 
    var string1 = string2 = '';
    data.Prices.forEach(function(price) {
        if(price.name == 'monthly'){
            monthlyPrice = price.amount;
            string1 = 'Per Month';
        }
        if(price.name == 'annually'){
            annuallyPrice = price.amount;
            string2 = 'Per Month, Billed Annually';
        }
    })
    $('#monthly-plans').append('<div class="box_mont_yer"> <div class="card popular-price text-center single-pricing-pack"> <div class="pt-4"> <h5>'+data.name+'</h5> </div> <div class="pricing-img mt-2"> <img src="/static/assets/images/img/'+data.name.toLowerCase()+'.png" alt="pricing img" class="img-fluid"> </div> <div class="h1 text-center mb-0 head_sapn"> '+monthlyPrice+' <sup class="sup_cls">*</sup> <span class="per_user">Per User</span> </div> <p class="per_mont_css">'+string1+'</p> <div class="card-body"> <h6 class="m-2 head_package">'+(i == 1 ? 'Features Included' : (i == 2 ? 'All Features of Silver, Plus' : 'All Features of Gold, Plus'))+'</h6> <ul class="list-unstyled text-sm mb-4 pricing-feature-list feature-'+data.id+'">  </ul> </div> </div> <button type="button"  data-toggle="modal" data-target="#noEmail"  onclick="getpackDetails('+data.id+', '+"'monthly'"+')" class="btn btn-primary w-100 btn_position form-wizard-next-btn">Upgrade</button> </div>');
    $('#annually-plans').append('<div class="box_mont_yer"> <div class="card popular-price text-center single-pricing-pack"> <div class="pt-4"> <h5>'+data.name+'</h5> </div> <div class="pricing-img mt-2"> <img src="/static/assets/images/img/'+data.name.toLowerCase()+'.png" alt="pricing img" class="img-fluid"> </div> <div class="h1 text-center mb-0 head_sapn">'+annuallyPrice+' <sup class="sup_cls">*</sup> <span class="per_user">Per User</span> </div> <p class="per_mont_css">'+string2+'</p> <div class="card-body"> <h6 class="m-2 head_package">'+(i == 1 ? 'Features Included' : (i == 2 ? 'All Features of Silver, Plus' : 'All Features of Gold, Plus'))+'</h6> <ul class="list-unstyled text-sm mb-4 pricing-feature-list feature-'+data.id+'">  </ul> </div> </div> <button type="button"  data-toggle="modal" data-target="#noEmail" onclick="getpackDetails('+data.id+', '+"'annually'"+')" class="btn btn-primary w-100 btn_position form-wizard-next-btn">Upgrade</button> </div>');
    data.Features.forEach(function(fea)  {
        setFeatures(fea);
    })
}

var addFilter = function(){
    var users  = $('#select-users').val();
    var numbers = users.split("-");
    var data = new Object();
    data.minUsers = numbers[0];
    data.maxUsers = numbers[1];
    return data;
}

var loadPackage = function(){
    var data  = addFilter();
    api.billing.get(data,function(success){
        if(success && success.packages.length > 0){
            clearPackage();
            var i = 1;
            success.packages.forEach(function(pac)  {
                setPackage(pac, i);
                ++i;
            });
       }
    },function(error) {
        console.log(error);
    }, false);
}

var nextStep = function(step){
    var currentActiveStep = $('#'+step).parents('.form-wizard').find('.form-wizard-steps .active');
    var nextWizardStep = true;
    if( nextWizardStep) {
        $('.wizard-fieldset').removeClass('show');
        currentActiveStep.removeClass('active').addClass('activated').next().addClass('active',"400");
        $('#'+step).addClass('show');
        if(step == 'step3'){
            $('.step-main').addClass('activated');
            $('#m-'+step).removeClass('activated').addClass('active');
        }else  $('#m-'+step).addClass('active');
    }
}

// $('.form-wizard-previous-btn').click(function () {
//     var prev = $(this);
//     var currentActiveStep = $(this).parents('.form-wizard').find('.form-wizard-steps .active');
//     prev.parents('.wizard-fieldset').removeClass("show", "400");
//     prev.parents('.wizard-fieldset').prev('.wizard-fieldset').addClass("show", "400");
//     currentActiveStep.removeClass('active').prev().removeClass('activated').addClass('active', "400");
// });

var validateCode = function(){
    $('#error-code').html('');
    var err = 0;
    var data = new Object();
    data.code = $('#appsumoCode').val();
    if(data.code.length == 0){
        $('#error-code').html('Please Enter Code');
        err = 1;
    }
    if(err == 0) return data;
    else return false;

}

var checkRedeem = function(){
    var data = validateCode();
    if(data){
        api.billing.check({code: data.code },function(success){
            if(success){
                swal({
                    title: "Warning!",
                    type: "warning",
                    text: "Are you sure to upgrade a plan",
                    showCancelButton: true,
                })
                .then(function(){
                    api.billing.redeem({code: data.code }, function(success) {
                        if(success && success.status){
                            window.location = '/billing';
                        }
                    }, function(error) {
                        console.log(error);
                    })
                })
            }
        },function(error) {
            console.log(error);
            $('#error-code').html(error.errors[0]);
        });
    }

}

var clearFieldsAll = function(){
    $('#appsumo-code').html('');
    $('#appsumo-users').html('');
    $('#appsumo-storage').html('');
    $('#appsumo-datatransfer').html('');
    $('#data-appsumo').html('');
}

var load = function(){
    api.billing.fetch(undefined,function(success){
        if(success){
            clearFieldsAll();
            if(success.code == 4 && success.nextPack == false){
                $('#appsumo-code').html('You are on a <b> Code '+success.code+' Plan</b>.');
                $('#form-hide').hide();
            }else{
                $('#appsumo-code').html('You are on a <b> Code '+success.code+' Plan</b> and if you want to upgrade, follow the below instructions.');
                $('#form-hide').show();
            } 
            if(success.code)
                $('#appsumo-authors').html(success.r+'/'+success.code);
            success.userPack.forEach(function(up)  {
                if(up.name == 'users')
                    $('#appsumo-users').html(success.count+'/'+up.value);
                if(up.name == 'storage')
                    $('#appsumo-storage').html(up.value);
                // if(up.name == 'dataTransfer')
                //     $('#appsumo-datatransfer').html('9GB/'+up.value);
            });
            if(success.nextPack){
                $('#data-appsumo').append('<li>Users: '+ success.nextPack.users+'</li>');
                $('#data-appsumo').append('<li>Storage: '+ success.nextPack.storage+'</li>');
                $('#data-appsumo').append('<li>Admin(s): '+ success.nextPack.code+'</li>');
                // $('#data-appsumo').append('<li>Data Transfer: '+ success.nextPack.dataTransfer+'</li>');
            }
        }
    },function(error) {
        console.log(error);
    });
}

$(document).ready(function(){
    // let searchParams = new URLSearchParams(window.location.search);
    var verified = urlParam('success') == 'true' ? true: false;
    if(verified){
        $('#plansShow').show();
        $('#fullBillWrap').hide();
        $('#back-to-plan').hide();
        nextStep('step3');
    }else{
        $('#back-to-plan').show();
        $('#fullBillWrap').show();
    }  
    load();
});