var skillObject = {};
var id = undefined;

var setInCaseOfAddOrEdit = function(type) {
    if(type == 'add'){
        $('#heading-skill-update').hide();
        $('#heading-skill-add').show();
        $('#button-skill-update').hide().removeAttr('data-id');
        $('#button-skill-add').show();
    }else{
        $('#heading-skill-update').show();
        $('#heading-skill-add').hide();
        $('#button-skill-update').show();
        $('#button-skill-add').hide();
    }
    $('#add-update-skill').val('');
}

var deleteSkill = function(id) {
    swal({ title: 'Are you sure?',  text: "You won't be able to revert this!", type: 'warning', showCancelButton: true, confirmButtonClass: 'btn  btn-success', cancelButtonClass: 'btn btn-danger m-l-10',  confirmButtonText: 'Yes, delete it!'})
    .then(function () {
        api.skill.delete(id, undefined, function(success) {
            if(success && success.skill){
                load(page.skillId);
                swal('Deleted!', success.skill, 'success' );
            }
        });
    })
}

var validateAddOrUpdateSkill = function() {
    clearErrors();
    var data = new Object();
    data.parentId = page.skillId;
    if($('#button-skill-update').attr('data-id') != undefined)
        data.skillId = $('#button-skill-update').attr('data-id');
    data.name = sanitize($('#add-update-skill').val());
    if(data.name.length == 0)
        addError('name', 'Please enter your skill!');   
    hasError() && showErrors();
    return data;
}

var updateSkill = function(id) {
    var data = validateAddOrUpdateSkill();
    !hasError() && api.skill.update(data, function(success) {
        showSuccess('Skill has been updated!');
        load(page.skillId);
        $('#exampleModalCenter').modal('hide');
    });
}

var editSkill = function(id) {
    setInCaseOfAddOrEdit('edit');
    $('#button-skill-update').attr('data-id', id);
    $('#add-update-skill').val((skillObject && skillObject[id] ? skillObject[id].name : ''));
}

var addSkill = function() {
    var data = validateAddOrUpdateSkill();
    !hasError() && api.skill.add(data, function(success) {
        showSuccess('Skill has been created!');
        load(page.skillId);
        $('#exampleModalCenter').modal('hide');
    });
}

var loadSkills = function(skill, i) {
    $('#skills-table tbody').append('<tr> <th scope="row">'+i+'</th> <td><a href="/create-manage-skills/'+skill.id+'"> '+(skill && skill.name ? skill.name : 'NA')+'</a></td> <td><button type="button" class="btn btn-round btn-warning-rgba" onclick="editSkill('+skill.id+')" data-toggle="modal" data-tooltip="tooltip" data-target="#exampleModalCenter" data-placement="top" data-original-title="Edit"><i class="feather icon-edit"></i></button> </td> </tr>');

    $('[data-tooltip="tooltip"]').tooltip();
}

var clearSkills= function() {
    $('#skills-table tbody').html('');
}

var loadJsTree = function(data) {
    $('#types-tree').jstree("destroy"); 
    $('#types-tree').jstree({
        'core' : { 
            'themes' : { 'responsive': false },
            'data' : data,
        },
        'plugins' : ['types']
    }); 
}

var redirectSkills = function(id){
    window.open('/create-manage-skills/'+id,'_self');
} 
var setSkillJson = function(obj, skill, dataObj){
    if(skill && skill.length > 0){
        skill.forEach(function(s) {
            var temp = {
                "text" : "<a onclick='redirectSkills("+s.id+");'>"+s.name+"</a>",
                "state" : { "opened" : true },
                "icon" : "feather icon-feather"
            }
            if(dataObj && dataObj[s.id]){
                temp["children"] = setSkillJson([], dataObj[s.id], dataObj);
            }
            obj.push(temp);
        })
    }
    return obj;
}

var reloadList = function () {
    load(page.skillId);
}

var load = function(id) {
    var page = getPageNo();
    var limit = getLimit();
    var i = (page == 1 ? 1 : ((10* ( page - 1) + 1)) );
    api.skill.get(id, {page: page, limit: limit}, function(success) {
        clearSkills(); 
        if(success && success.skills && success.skills.length > 0){
            success.skills.forEach(function(skill) {
                skillObject[skill.id] = skill;
                loadSkills(skill, i);
                ++i;
            });
            if(success.count)
                addPagination(success.pages, success.count);
        }else $('#skills-table tbody').html('<tr> <th scope="row">No Skills Found</th> </tr>');
    });
    
    api.skill.all(undefined, function(success) {
        var finalArray = []; var dataObj = {};  
        if(success && success.skills && success.skills.length > 0){
            success.skills.forEach(function(skill) {
                if(!dataObj[skill.parentId]) dataObj[skill.parentId] = [];
                dataObj[skill.parentId].push(skill);
            });
            finalArray = setSkillJson([], dataObj[id],  dataObj)
            loadJsTree(finalArray);
        }else loadJsTree(finalArray);
    });
}

$(document).ready(function(){
    load(page.skillId);
    if(page.skillId > 0)
        $('#go-back-skills').show();
});