var data = {};
var questionId = 1;
var ansLoopCount = 0;
var addAns = 3;
var QuizStatus;
var qCou = 0;
var percentage = 0;
var dbSkills = [];

var validateQuiz = function () {
	clearErrors();
	var formdata = new FormData();
	var languageId = $('#inputState').val();
	var quizName = sanitize($('#quizName').val());
	/* var quizDetail = $('#quizDescription').val(); */
	var quizDetail = CKEDITOR.instances['quizDescription'].getData();
	if (quizName.length == 0) {
		addError('name', 'Title field is required');
	}
	var allSkills = $('.group-radio:checkbox:checked').map(function () {
        return this.id;
    }).get().join(",");
    if (allSkills == '') {
        addError('skills', 'Skill field is required');
	}
	formdata.append('skills', allSkills);
	formdata.append('description', quizDetail);
	formdata.append('name', quizName);
	formdata.append('languageId', languageId);
	if ($('input[name=quizlogo]').prop('files')[0])
		formdata.append('logo', $('input[name=quizlogo]').prop('files')[0]);
	if( page.quizId == '' && $('input[name=quizlogo]').prop('files')[0] == undefined)
		addError('quizFile', 'Image Field is required');
	hasError() && showErrors();
	return formdata;
}

function saveSettings(){
	clearErrors();
	var status = '';
	var skipping = $("#customSwitch1").is(":checked");
	if(!skipping)
		skipping = false;
	var reset_assessment = ($('#setting1').is(':checked') ? true : false);
	var quizId = page.quizId;
	var duration = $("#duration").val();
	var percentage = $("#range-slider-own-numbers").val();
	var settings = JSON.stringify({"reset_assessment": reset_assessment, "skipping":skipping,"duration" : duration,"percentage" : percentage});
	if(quizStatus == "Draft" )
		status = 'Active';
	else status = quizStatus;
	if(!duration)
		addError("duration","Duration Required");
	else if(duration == 0){
		$("#duration").val('');
		addError("duration","Duration Required");
	}
	if(percentage == 0)
		addError("percentage","Percentage Required");
	hasError() && showErrors();
	!hasError() && api.quiz.settings({settings : settings,quizId : quizId,status : status},function(success) {
		if(success){
			showSuccess('Assessment is successfully saved.')
			setTimeout(function(){
				window.location = '/assessment/list';
			}, 2000)
		}
			
	})

}

function detailActions(){
	$('#quizControl').removeClass("active show");
	$('#quizCont').removeClass("active");
	$('#detail').addClass("active show");
	$('#detail-tab').addClass("active");
	$('#curriculum-tab').removeClass("active");
	$('#curriculum').removeClass("active show");
	$("#draft").css("display","block").attr("onclick","saveQuiz(this.id)");
	$("#next").css("display","block").attr("onclick","saveQuiz()");
	$("#finish").css("display","none");
}

function curriculumActions(){
	$('#quizControl').removeClass("active show");
	$('#quizCont').removeClass("active");
	$('#detail').removeClass("active show");
	$('#detail-tab').removeClass("active");
	$('#curriculum-tab').removeClass('disabled').addClass("active");
	$('#curriculum').addClass("active show");
	$("#draft").css("display","block").attr("onclick","nextSettings(this.id)");
	$("#next").css("display","block").attr("onclick","nextSettings()");
	$("#finish").css("display","none");
}

$("#detail-tab").click(function(){
	detailActions();
});

$("#curriculum-tab").click(function(){
	curriculumActions();	
});

$("#quizCont").click(function(){
	nextSettings();
	$('.irs-slider single').attr("style","left:20%");
});

function nextSettings(name){
	if(qCou < 3){
		addError("countChk","Please add atleast 3 questions");
		hasError() && showErrors();	
	}
	if(name)
		window.location = '/assessment/list';
	if(!$('#quizCont').hasClass("disabled")){
		$('#quizControl').addClass("active show");
		$('#quizCont').addClass("active");
		$('#detail').removeClass("active show");
		$('#detail-tab').removeClass("active");
		$('#curriculum-tab').removeClass("active");
		$('#curriculum').removeClass("active show");
		$("#draft").css("display","none");
		$("#next").css("display","none");
		$("#finish").css("display","block");
	}
}

function setBar(percentage){
	$("#range-slider-own-numbers").ionRangeSlider({
		type: "single",
		grid: true,
		from: percentage,
		to: 10,
		min : 0,
		max : 100,
		//values: [0, 10, 20, 30, 40, 50, 60, 70, 80,90,100]
	});
}

function setSettings(data){
	var settings =JSON.parse(data);
	if(settings){
		if(settings.percentage){
			
			percentage = settings.percentage;
			setBar(percentage);
		}
		if(settings.skipping)
			$("#customSwitch1").prop("checked","checked");
		if(settings.reset_assessment)
			$("#setting1").prop("checked","checked");
		if(settings.duration){
			$('#duration').val(settings.duration);
		}
	}else{
		setBar(10);
	}
}

var saveQuiz = function(name) {
	var quizId = page.quizId;
	if (quizId > 0) {
		var data = validateQuiz();
		data.append('quizId', quizId);
		!hasError() && api.quiz.update(data, function(success) {
			if(name)
				window.location = '/assessment/list';
			else
				window.location = '/assessment/create/'+page.quizId+'?type=questions';
			showSuccess('Assessment Details has been updated!');
		});
	} else {
		var data = validateQuiz();
		!hasError() && api.quiz.post(data, function(success) {
			if (success.status == 200);
			{
				if(name)
					window.location = '/assessment/list';
				else
					window.location = '/assessment/create/'+success.id+'?type=questions';
				showSuccess('Assessment Details has been Added!');
			}
		});
	}
}
var loadLanguages = function(languageId) {
	api.course.language(undefined, function(success) {
		for (var i = 0; i < success.languages.length; i++) {
			var selected = '';
			if ((languageId != 0 ? languageId == success.languages[i].id : 24 == success.languages[i].id) )  selected = 'selected'; 
			$('.inputLang').append('<option value="' + success.languages[i].id +'" '+selected+'>' + success.languages[i].name + '</option>')
		}
	})
}
var clearStoreData = function() {
	return;
}
var hideLoader = function() {
	return;
}
var showLoader = function() {
	return;
}

function clearExistingSkills() {
    $('#skillNewName').html('');
}
var load = function() {
	clearStoreData();
	hideLoader();
   /* showLoader() && */api.quiz.get({ id: page.quizId }, function(success) {
	    if(success.quiz){
			setSettings(success.quiz.settings);
			loadLanguages(success.quiz.languageId);
			success.quiz.AssessmentSkills.forEach(function(skill) {
				dbSkills.push(skill.skillId);
			})
		}else{
			loadLanguages(0);
		}
		loadSkills();
		hideLoader();
		$('#quizName').val((success.quiz ? success.quiz.name : ''));
		quizStatus = (success.quiz ? success.quiz.status : '');
		$('#quizDescription').val((success.quiz ? success.quiz.description : ''));
		$('#output').attr('src', '/static/quiz/logo/' + (success.quiz ? success.quiz.logo : ''))
		if(quizStatus != 'Draft')
			$('#draft').remove();
		else
			$('#draft').css('display','block');
		if (success.quiz && success.quiz.QuizQuestions) {
			success.quiz.QuizQuestions.forEach(function(question) {
				addQuestion(question);
				question.QuizQuestionOptions.forEach(function(answerData) {
					addAnswer(question.id,undefined,answerData);
				})
			})
		}
		if(success.quiz && success.quiz.AssessmentSkills){
			setTimeout(function () {
				setSelectedSkill();
			}, 500);
		}
	}, function(err) {
		hideLoader();
	})
}

$('.filePhoto').change(function () {
	// var i = $(this).prev('label').clone();
	var file = $('.filePhoto')[0].files[0].name;
	ext = file.split('.').pop().toLowerCase();
    if(ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif')
		$(this).next('label').text(file);
    else{
        $('#filePhoto').val('');
        $(this).next('label').text('Choose file');
    } 
});


function readURL(input, src) {
	if (src === 'image-q') {
		if (input.files && input.files[0]) {
			var filename = input.files[0].name;
			ext = filename.split('.').pop().toLowerCase();
			if(ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif'){
				var reader = new FileReader();
				reader.onload = function (e) {
					$('#output').attr('src', e.target.result);
					$('#h2').addClass('img_show_upload');
				}
				reader.readAsDataURL(input.files[0]);
			}else{
				$('#image-q').val('');
				addError('ext', 'Please choose jpeg, jpg and png file format');
				hasError() && showErrors();
			}
		}
	}else {
		if (input.files && input.files[0]) {
			var filename = input.files[0].name;
			ext = filename.split('.').pop().toLowerCase();
			if(ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif'){
				var reader = new FileReader();
				reader.onload = function (e) {
					$('#output-q' + src.slice(-1)).attr('src', e.target.result);
					$('#h2').addClass('img_show_upload');
				}
				reader.readAsDataURL(input.files[0]);
			}else{
				$('#image-q'+src.slice(-1)).val('');
				addError('ext', 'Please choose jpeg, jpg and png file format');
				hasError() && showErrors();
			}
		}
	}
}

$(document).on({
	change: function () {
		readURL(this, $(this).attr("id"));
	},
}, '.filePhoto');

function isQuestionAdded(){
	clearErrors()
	api.quiz.isQuestionAdded({quizId : page.quizId},function(success){
		if(success && success.questionCount >= 3){
			qCou = success.questionCount;
			$("#quizCont").removeClass('disabled');
		}else{
			$("#quizCont").addClass('disabled');
		}
	})
}

// $(".qustionImage").change(function () {
//   readURL(this, $(this).attr('id'));
// });

function queryString() {
    var queryString = window.location.search.substring(1);
    var varArray = queryString.split("=");
    var param = varArray[1];
    return param;
}


$(document).ready(function () {
	if (page.quizId > 0) {
		var type = queryString();
		if(type == 'questions'){
			curriculumActions();
			isQuestionAdded();
		}else{
			$('#detail').addClass("active show");
			$('#detail-tab').addClass("active");
			$('#curriculum-tab').removeClass("disabled");
			$("#draft").css("display","block").attr("onclick","saveQuiz(this.id)");
			$("#next").css("display","block").attr("onclick","saveQuiz()");
			$("#finish").css("display","none");
			isQuestionAdded();
		}
		load();
	}
	else {
		$('#detail-tab').addClass('active');
		$('#detail').addClass('active show');
		loadLanguages(0);
		loadSkills();
	}
})


// let wrapper = $('#accordion');
// $('.btn-link').on('click', function () {
// let status = $(this).attr('aria-expanded'); // code is useless here. Just to check if collapse open or close
// wrapper.find(".icon-chevron-down").removeClass("icon-chevron-down").addClass("icon-chevron-up");
//   // wrapper.find('.fa-chevron-down').removeClass('fa-chevron-down').addClass('fa-chevron-up');
// });

// $('.btn').click(function(){
//   alert(328)
//   $(this).find(".feather.icon-chevron-down").removeClass("feather icon-chevron-down").addClass("feather icon-chevron-up");
// });

function deleteQuestion(questionId,e){
	e.stopPropagation();
    swal({ title: "Warning!", type: "warning", text: "Are you sure you want to delete?", showCancelButton: true })
    .then(function(){
	api.quiz.deleteQuestion({questionId:questionId,quizId:page.quizId},function(success){
		if(success){
			showSuccess('Question has been deleted');
			$('#accordionExample'+questionId+'').remove();
		}
	})
}) 
}


function closeDiv(questionId){
	if($('#qstnTitle-'+questionId).text() == ''){
		$('#accordionExample'+questionId).remove();
		$('.accordion').removeClass('active');

	}
	$('#collapseOne'+questionId).removeClass("show");
	$('.collapse').collapse(); 
}

function ckeckOpenQuestionDiv(){
	clearErrors();
    if($(".accordion").hasClass('active') == true){
        addError('question box','Save Question first');
        hasError() && showErrors();
        return false;
    }
    else
      return true;
}

function addQuestion(questionData){
	if (questionData != undefined){
		questionId = questionData.id;
        var div_check = true;
    }
    else
        var div_check = ckeckOpenQuestionDiv();
	if(div_check) 
	$('#quizMain').append('<div class="accordion ' + (questionData == undefined ? 'active' : '') + '" id="accordionExample' + questionId + '"> <div class="card"> <div class="card-header" id="headingOne"> <h2 class="mb-0"> <button class="btn btn-link acrr_btn" type="button" data-toggle="collapse" data-target="#collapseOne' + questionId + '" aria-expanded="true" id=title-' + questionId + ' aria-controls="collapseOne">Question :<span><span id="qstnTitle-'+questionId+'">' + (questionData ? questionData.title : '') + '</span> <i ' + (!questionData ? "style='display:none;'": '') + ' class="feather icon-edit edit-icon-'+questionId+'"></i><i class="feather icon-trash ml-1" '+(questionData == undefined? 'style="display:none;"' : '')+' id="del-'+questionId+'" onclick="deleteQuestion(' + questionId + ',event)"></i></span></button> </h2> </div> <div id="collapseOne' + questionId + '" class="collapse show" aria-labelledby="headingOne" data-parent="#accordionExample' + questionId + '"> <div class="card-body"> <div class="add_quiz" id="Question-' + questionId + '"> <div class="row"> <div class="col-sm-8"> <div class="form-group"> <label>Question</label> <input type="text" value="' + (questionData ? questionData.title : '') + '" '+(questionData?'name="'+questionData.id+'"':'')+' id="title-q' + questionId + '" class="form-control" placeholder="Enter Your Question"> </div> <div id="addAns' + questionId + '"> </div> <button type="button" class="btn btn-success" onclick="addAnswer(' + questionId + ')" id="addAns-'+ questionId +'"> <i class="feather icon-plus"></i> Answer </button> </div> <div class="col-sm-4"> <label>Upload Image (Optional)</label> <div class="custom-file"> <input type="file" class="custom-file-input qustionImage" accept="image/x-png,image/gif,image/jpeg" onchange="previewImage('+questionId+');" id="image-q' + questionId + '" aria-describedby="inputGroupFileAddon01"></img> <label class="custom-file-label" for="inputGroupFile01">Choose file</label> </div> <div id="h3-' + questionId + '"> <img class="img_set_asses img-fluid" id="output-q' + questionId + '" '+(questionData ? (questionData.thumbnail ? 'src="/static/quiz/content/'+questionData.thumbnail+'"' : ''): '')+'> </div> </div> <div class="col-sm-12" style="text-align: right;"> <button type="button" class="btn btn-info" onclick="closeDiv('+questionId+')">Cancel</button> <button type="button" id="save-'+questionId+'" class="btn btn-success"  onclick="saveQuestion(' + questionId + ')" >Save</button></div> </div> </div> </div> </div> </div> </div>');
	if(!questionData){
		for (var i = 1; i < 3; i++) {
				addAnswer(questionId, i);
			}
	}else
		$('.collapse').collapse();
		questionId++;
}

function loadImage(input,questionId) {
		var reader = new FileReader();
		
		reader.onload = function (e) {
			$('#output-q'+questionId).attr('src', e.target.result);
		}
		reader.readAsDataURL(input);
}

function previewImage(questionId){
	var file = $('#image-q' + questionId)[0].files[0];
	loadImage(file,questionId);
}
 

function setImage(id) {
	// var file = $('#image-q' + id)[0].files[0].name;
	// $('#img-' + id).text(file);
}

var closeAnswers = function (qId, aId) {
	for (i = aId; i < Object.entries(data[qId]["answer"]).length; i++) {
		data[qId]['answer'][i] = data[qId]['answer'][i + 1];
	}
	delete data[qId]['answer'][i];
}
function closeQuizAns(questionId, answerId) {
	if($('.input_count_'+questionId+'').length > 2){
		var delId = 'opt-'+questionId+answerId;
		var answerId = $('#ans-'+questionId+answerId).attr('name');
		$('#'+delId).remove();
		if(answerId){
			api.quiz.deleteQuestionOption({optionId:answerId},function(success) {
			})
		}
	}
	else{
		addError('optionCount','Atleast two option required');
		hasError() && showErrors();
	}
	if ($('.input_count_'+questionId+'').length <= 5) {
		$('#addAns-'+ questionId).show();
	}
}

function addAnswer(questionId, answerId, answerData){
	if(answerId == undefined && answerData == undefined)
		answerId = addAns++;
	if(answerData)
		answerId = answerData.id
	if($('.input_count_'+questionId+'').length < 5){
		$('#addAns' + questionId).append('<div class="row" id="opt-'+ questionId+answerId+'"> <div class="col-sm-1 text-right "> <div class="custom-control custom-radio custom-control-inline mx-0"> <input type="radio" '+(answerData ? (answerData.isCorrect == 1 ? 'checked' :'') : '')+' id="check-q' + questionId + 'a' + answerId + '" name="checkbox-'+questionId+'[]"c value="'+answerId+'" class="custom-control-input checkbox-'+questionId+'"> <label class="custom-control-label" for="check-q' + questionId + 'a' + answerId + '"></label> </div> </div> <div class="col-sm-11"> <div class="form-group"> <input type="text" id="ans-'+questionId+answerId+'" '+(answerData ? 'name="'+answerId+'"' : '')+' class="form-control input_count_'+questionId+'" value="'+(answerData ? answerData.title : '')+'" placeholder="Enter Your Answer"><span id="closeId" class="close_icon_quiz" onclick="closeQuizAns(' + questionId + ',' + answerId + ')"><i class="feather icon-x"></i></span></div> </div> </div>');
	}
	if($('.input_count_'+questionId+'').length == 5){
		$('#addAns-'+ questionId).hide();
	}
	answerId++;
}


var validateQuestion = function(qId) {
	clearErrors();
	var data = [];
	var selected = '';
	if($('#title-q' + qId).val() == '')
		addError('titleEr','Question Title Required');
		var testval = [];
		$(".input_count_"+qId+"").each(function(k,v) { 
			if(v.value == ''){
				addError('checkboxEr','Please Enter Your Answer');
			}  
		}); 
		var testval = $('input:radio:checked.checkbox-'+qId+'').map(function(){
			selected = sanitize($('#ans-'+qId+this.value).val());
			return selected; }).get().join(",");
			
		if(selected == ''){
			addError('checkboxErr','Please select your correct answer');
		}else
			$(".input_count_"+qId+"").each(function() {
				var isCorrect = 0;
			if(testval.includes(this.value))
				isCorrect = 1;		
				data.push({"isCorrect":isCorrect,"title":sanitize(this.value)})				
			});
			hasError() && showErrors();
	return data;	
}

function groupHierarchyRender() {
    $("#accordian a").click(function () {
        var link = $(this);
        var closest_ul = link.closest("ul");
        var parallel_active_links = closest_ul.find(".active")
        var closest_li = link.closest("li");
        var link_status = closest_li.hasClass("active");
        var count = 0;
        closest_ul.find("ul").slideUp(function () {
            if (++count == closest_ul.find("ul").length)
                parallel_active_links.removeClass("active");
        });
        if (!link_status) {
            closest_li.children("ul").slideDown();
            closest_li.addClass("active");
		}
		$('#accordian').click(function(){
            if ($('#accordian').offset().top + $('#accordian').outerHeight() < $('.footerbar').offset().top) { 
            $('#accordian').css({"bottom":"0"});
            } 
        })
    })
}

$(document).click(function (e) {
	//  alert()
	  var container = $("#skills_append");
	  if ($(e.target).is('.accor a') || $(e.target).is('.accor a input')) {
		  container.show();
	  }
	  else {
		   container.hide();
	  }
  
  });

function setSelectedSkill() {
    $('#added-skills').html('').html(' <i class="fa fa-lg fa-tasks"></i>');
    var checkedVals = $('.group-radio:checkbox:checked').map(function () {
        return $('#added-skills').append('<span id="grp-' + this.id + '">' + this.value + '<i class="feather icon-x" onclick="removeSkill(' + this.id + ')"></i></span>');
	}).get();
	if(checkedVals.length == 0)
		$('#added-skills').html('').html(' <i class="fa fa-lg fa-tasks"></i>Select Skill Type');
}
function appendSkills(group) {
    if (group != undefined) {
        if (group.parentId == 0) {
            $('#skills_append').append('<li id="skills_append-' + group.id + '"><a><input type="checkbox" id="' + group.id + '" value="' + group.name + '" ' + (dbSkills.includes(group.id) ? 'checked' : '') + ' name="skills[]" class="group-radio" onclick="setSelectedSkill()">  ' + group.name + '</a></li>');
        } else {
            if (!$('#skills_append-' + group.parentId).has('ul').length)
                $('#skills_append-' + group.parentId).append('<ul></ul>');
            $('#skills_append-' + group.parentId + ' > ul').append('<li id="skills_append-' + group.id + '"><a><input type="checkbox"  id="' + group.id + '" class="group-radio" name="skills[]" value="' + group.name + '" ' + (dbSkills.includes(group.id) ? 'checked' : '') + ' onclick="setSelectedSkill()">  ' + group.name + '</a></li>')
        }
    } else {
        $('#skills_append').append('<li >No Skill Found.</li>');
    }
}

function addExistingSkill(skill) {
    if (skill.parentId == 0) {
        $('#existing-skill').append('<li id="existing-skill-' + skill.id + '"><a><input type="radio" id="radio-skill-' + skill.id + '" name="skill" class="skill-radio" onclick="setExistingSkillName(\'' + skill.name + '\')">  ' + skill.name + '</a></li>');
    } else {
        if (!$('#existing-skill').has('li').length)
            $('#existing-skill').append('<li id="existing-skill-' + skill.id + '"><a><input type="radio" id="radio-skill-' + skill.id + '" name="skill" class="skill-radio" onclick="setExistingSkillName(\'' + skill.name + '\')">  ' + skill.name + '</a></li>');
        else {
            if (!$('#existing-skill-' + skill.parentId).has('ul').length)
                $('#existing-skill-' + skill.parentId).append('<ul></ul>');
            $('#existing-skill-' + skill.parentId + ' > ul').append('<li id="existing-skill-' + skill.id + '"><a><input type="radio"  id="radio-skill-' + skill.id + '" class="skill-radio" name="skill" onclick="setExistingSkillName(\'' + skill.name + '\')">  ' + skill.name + '</a></li>')
        }
    }
}

function setSkillJson(obj, t, skill, dataObj) {
    if (skill && skill.length > 0) {
        skill.forEach(function(s) {
            var temp = {
                "text": s.name,
                "state": { "opened": true },
                "icon": (t == 'p' ? "feather icon-folder" : "feather icon-feather")
            }
            if (dataObj && dataObj[s.id]) {
                temp["children"] = setSkillJson([], 'c', dataObj[s.id], dataObj);
            }
            obj.push(temp);
        })
    }
    return obj;
}

function addNewSkill() {
    var data = validateNewSkill();
    !hasError() && data && api.skill.add(data, function(success) {
        if(success){
            clearCreateSkill();
            var skill = {
                id: success.diX342,
                parentId:success.gif$5ds,
                name: success.name
            }
            appendSkills(skill);
            addExistingSkill(skill);
            if(!dataObj[success.gif$5ds])  dataObj[success.gif$5ds] = [];
            dataObj[success.gif$5ds].push(skill);
            finalArray = setSkillJson([], 'p', dataObj[0],  dataObj);
            loadJsTree(finalArray);
        }
        showSuccess('New Skill is successfully added.');
    });
}


function loadJsTree(data) {
    $('.tree_js').hide();
    $('#types-tree').jstree("destroy");
    $('#types-tree').jstree({
        'core': {
            'themes': { 'responsive': false },
            'data': data,
        },
        'plugins': ['types']
    });


}

function removeSkill(skillId) {
    var count = 0;
    var checkedVals = $('.group-radio:checkbox:checked').map(function () {
        ++count;
    }).get();
    if (count == 1) $('#added-skills').html('<i class="fa fa-lg fa-tasks"></i>Select Skill Type');
    $("#grp-" + skillId + "").remove();
    $("#" + skillId + "").prop('checked', false);
}

var dataObj = {};
function loadSkills() {
    var type = "ASC";
    api.skill.skillsByParent({ type: type }, function (success) {
        if(success && success.skills && success.skills.length > 0){
            clearExistingSkills();  
            var finalArray = []; 
            success.skills.forEach(function(skill) {
                appendSkills(skill);
                if (!dataObj[skill.parentId]) dataObj[skill.parentId] = [];
                dataObj[skill.parentId].push(skill);
                addExistingSkill(skill);
            });
            finalArray = setSkillJson([], 'p', dataObj[0], dataObj);
            loadJsTree(finalArray);
            groupHierarchyRender();  
        }else{
            appendSkills();
            groupHierarchyRender();
            $('.tree_js').show();
        }
    });
}

function savedQuestionOption(qId,dbQstnId){
	clearErrors();
	var data = {};
	var add = [];
	var update = [];
	var selected = '';
	if($('#title-q' + qId).val() == '')
		addError('titleEr','Question Title Required');
	var testval = [];
	$(".input_count_"+qId+"").each(function(k,v) { 
		if(v.value == ''){
			addError('checkboxEr','Please Enter Your Answer');
		}  
	}); 
	var testval = $('input:radio:checked.checkbox-'+qId+'').map(function(){
		selected = $('#ans-'+qId+this.value).val();
	return selected; }).get().join(",");
	if(selected == ''){
		addError('checkboxErr','Please select your correct answer');
	}else
		$(".input_count_"+qId+"").each(function() {
			var isCorrect = 0;
			if(testval.includes(this.value))
				isCorrect = 1;		
			if(this.name)
				update.push({"id":this.name,"isCorrect":isCorrect,"title":sanitize(this.value)});
			else
				add.push({"isCorrect":isCorrect,"title":sanitize(this.value)});
			data['update'] = update;
			data['add'] = add;
		});
	hasError() && showErrors();
	return data;	
} 

var saveQuestion = function(questionId) {
	var getDbId = $('#title-q'+questionId).attr('name');
	var newData = new FormData();
	var title = sanitize($('#title-q' + questionId).val());
	var qImage = $('#image-q' + questionId).prop('files')[0];
	newData.append('filename', qImage)
	newData.append('title', title);
	newData.append('quizId', page.quizId);
	if (questionId && getDbId == undefined) {
		var data = validateQuestion(questionId);
		newData.append("data", JSON.stringify(data));
		!hasError() && api.quiz.createQuestion(newData, function(success) {
			$('.collapse').collapse();
			if(success){
				showSuccess('Question has been Added!');
				$('.edit-icon-'+questionId).css("display","");
				$("#qstnTitle-"+questionId).text(title);
				$("#del-"+questionId).attr("style","block").attr("onclick","deleteQuestion("+questionId+",event)");
				$("#title-q"+questionId+"").attr("name",success.questionId);
				var c = success.options[0].id;
				$('.input_count_'+questionId).each(function(i){
					$(this).attr('name', c);
					c++;
				});				
				isQuestionAdded();
				$('#collapseOne'+questionId).removeClass("show");
				$('.accordion').removeClass('active');

			}
		}, function(err) {
		})
	}else if(questionId && getDbId){
		var data = savedQuestionOption(questionId,getDbId);
		newData.append('questionId', getDbId)
		newData.append('data', JSON.stringify(data));
		!hasError() && api.quiz.editQuestion(newData,function(success) {
			$('.collapse').collapse();
			if(success){
				showSuccess('Question has been Updated!');
				$('.accordion').removeClass('active');
				$("#qstnTitle-"+questionId).text(title);
				$("#title-q"+questionId+"").attr("name",success.questionId);
				var c = success.options[0].id;
					$('.input_count_'+questionId).each(function(i){
						$(this).attr('name', c);
						c++;
					});	
					$('#collapseOne'+questionId).removeClass("show");

			}
		});
	
	}
}


function checkBox() {
	if ($('#accept').is(':checked')) {
		window.location.href = "/startquiz";
	}
	else {
		alert('You must agree to the terms first.');
	}

}


var selectedQuestionAnswer = function(questionId, answerId) {
	var checkBox = document.getElementById("check-q" + questionId + "a" + answerId);
	if ($(checkBox).is(':checked')) {
		window.location.href = "/startquiz";
	}
}


var editQuestion = function(questionId) {
	validateAddedQuestion(questionId);
	var newData = new FormData();
	// var qImage = $('#image-q' + questionId).prop('files')[0];
	// console.log("TCL: saveQuestion -> qImage", qImage)
	// newData.append('filename', qImage)
	newData.append('quizId', page.quizId);
	newData.append('questionId', questionId);
	newData.append("data", JSON.stringify(data[questionId]));
	api.quiz.editQuestion(newData, function(success) {
	}, function(err) {

	})
}
