
var language = null ;
var sortBy = 'recent';
var skill = null;
var fromDate = null, toDate = null;

var switchToGrid = function(){
    $('#List').css({"display":"none"}); 
    $('#Grid').css({"display":"inline"}); 
    $('#gridView').css({"display":"block"}); 
    $('#tableView').css({"display":"none"}); 
}

var switchToList = function(){
    $('#Grid').css({"display":"none"}); 
    $('#List').css({"display":"inline"}); 
    $('#gridView').css({"display":"none"}); 
    $('#tableView').css({"display":"block"}); 
}

var dateFilterInit = function(){
    var currentDate = new Date();
    var prevDate = new Date();
    prevDate.setMonth(prevDate.getMonth() - 1);
    fromDate = prevDate.toString('yyyy/MM/dd');
    toDate = currentDate.toString('yyyy/MM/dd');
    $('input[name="daterange"]').daterangepicker({
        opens: 'left',
        startDate: prevDate,
        endDate: currentDate,
        maxDate: new Date(), 
    }, function(start, end, label) {
        fromDate = start.format('YYYY/MM/DD');
        toDate = end.format('YYYY/MM/DD');
        load(true);
    });
}

var searchQuery = function() {
    setPage(1);
    load(false);
}

var validate = function(){    
    clearErrors();
    var data = new Object();
    data.search = $('#searchBar').val();
    if(data.search.length < 3){
        data.search = undefined;
    }
    if(sortBy) data.sort = sortBy;
    data.page = getPageNo();
    if(fromDate != null && toDate != null){
        data.fromDate = fromDate;
        data.toDate = toDate;
    }
    if (skill)
        data.skill = skill;
    if(language){
      data.language = language;
    }
    data.limit = getLimit();
    hasError() && showErrors();
    return data;
}

var reloadList = function () {
    load(true);
}

var sort = function(type){
    sortBy = type; 
    load(true);
}

var languageFilter = function(type){
    language = type;
    load(true);
}

function viewQuizAnalytics(status, id) {
    if(status == 'Published'){
        window.open('/result/user-assessment-result/'+id, '_blank');
    }else  swal({ title: "Warning!",  type: "warning", text: "Your Assessment is not Published!" });
}

var addQuiz= function(detail){
    if(detail.status == 'Active') color = '#41be41';
    else if(detail.status == 'Published') color = '#f28a3c';
    else color = '#c1c1d7';
    var skills = 'NA';
    if(detail.AssessmentSkills && detail.AssessmentSkills.length > 0){
        var data = [];
        for(var i = 0; i < detail.AssessmentSkills.length; i++){
            if(detail.AssessmentSkills[i] && detail.AssessmentSkills[i].Skill  && detail.AssessmentSkills[i].Skill.name )
            data.push(detail.AssessmentSkills[i].Skill.name);
        }
        var skills = data.join(', ');
    }
    var formatedDate = new Date(detail.createdAt).toString('dS MMM yyyy h:mm tt');
    var listView = '<tr> <th scope="row">'+detail.name+'</th><td>'+skills+'</td> <td>' + (detail && detail.totalQuestions ? detail.totalQuestions : 0) + '</td>   <td>'+detail.Language.name+'</td> <td>'+detail.status+'</td><td><a  href="javascript:void(0)" onclick="cloneAssessment(\''+detail.status+'\', '+detail.id+')" data-toggle="tooltip" data-placement="top" title="" data-original-title="Clone" class="btn btn-round btn-warning-rgba"> <i class="feather icon-copy"></i> </a> <a  href="javascript:void(0)" onclick="viewQuizAnalytics(\''+detail.status+'\', '+detail.id+')" data-toggle="tooltip" data-placement="top" title="" data-original-title="Assessment Result" class="btn btn-round btn-warning-rgba"> <i class="feather icon-bar-chart-line"></i> </a></td> </tr>';
    $('[data-toggle="tooltip"]').tooltip({
        trigger : 'hover'
     })
    $('#quizTable').append(listView);
    var gridView = ' <div class=" row grid_course_view"> <div class=" col-sm-2 grid_sty img_show"> <img class="img-fluid" src="/static/quiz/logo/' + detail.logo + '"> </div> <div class="col-sm-4 grid_sty content-head"> <div class="content"> <h5>' + detail.name + '</h5><p class="date-text">' + formatedDate.substr(0,24) + '</p><h6 class="skills-text"><i class="feather icon-box"></i> Skills - <span>'+skills+'</span></h6><h6 class="skills-text"><i class="feather icon-flag"></i> Status - <span class="badge badge-pill badge-success" style="background:'+color+'">'+detail.status+'</span></h6> <!-- <h6 class="skills-text"><i class="feather icon-user"></i> Author - <span>Anjani Pandey</span></h6> --> '+(detail.status != 'Published' ? '<a href="/assessment/create/' + detail.id + '?type=quiz" class="content-hover"><span>Manage Assessment</span></a>' : '' )+' </div> </div> <div class="col-sm-2 grid_sty content-head text-center"> <div class="content w-100"> <h5 class="block-head">Questions</h5><p>' + (detail && detail.totalQuestions ? detail.totalQuestions : 0) + '</p>  '+(detail.status != 'Published' ? '<a href="/assessment/create/' + detail.id + '?type=questions" class="content-hover"><span>Manage Questions</span></a>' : '' )+'  </div> </div>  <div class="col-sm-2 grid_sty content-head text-center"> <div class="content w-100"> <h5 class="block-head">Language</h5><p>'+detail.Language.name+'</p> </div> </div><div class="col-sm-2 grid_sty content-head text-center"> <div class="content w-100"><a  href="javascript:void(0)" onclick="cloneAssessment(\''+detail.status+'\', '+detail.id+')" data-toggle="tooltip" data-placement="top" title="" data-original-title="Clone" class="btn btn-round btn-warning-rgba"> <i class="feather icon-copy"></i> </a> <a data-toggle="tooltip" data-placement="top" title="" data-original-title="Assessment Result" class="btn btn-round btn-warning-rgba" href="javascript:void(0)" onclick="viewQuizAnalytics(\''+detail.status+'\', '+detail.id+')"><i class="feather icon-bar-chart-line"></i></a></div> </div>  </div>';
    $('#gridView').append(gridView);
    $('[data-toggle="tooltip"]').tooltip({
        trigger : 'hover'
     })
}

function resetCourseFilter(){
    dateFilterInit();
    language = null;
    sortBy = 'recent';
    skill = null;
    fromDate = null, 
    toDate = null;
    load(true);
}

var clearQuiz = function(){
    $('#gridView').html('');
    $('#quizTable').html('');
    $('#paginate').hide();
}

var cloneAssessment = function(status, id){
    if(status == 'Published'){
        swal({ title: "Warning!", type: "warning", text: "Are you sure", showCancelButton: true })
        .then(function () {
            api.quiz.clone({id:id}, function (success) {
                if(success && success.success){
                    showSuccess('Assessment has been Cloned');
                    load(true);
                }
            });
        })
    }else  swal({ title: "Warning!",  type: "warning", text: "Your Assessment is not Published!" });
}

var load = function(noloader) {
    var data = validate();
    !hasError() && api.quiz.list(data, function(success) {
        clearQuiz();
        if(success.count){
            count = 0; select = true;
            success.quiz.forEach(function(quiz) {
                addQuiz(quiz);
            });
            $('#paginate').show();
            addPagination(success.pages, success.count);
        } else {
            $('#gridView').html('<tr><td colspan="2">No Assessment Found.</td></tr>');
            $('#quizTable').html('No Assessment Found.');
        }
    }, function(error) {}, noloader);
}
  
function skillFilter(id) {
    if (id == 'all') skill = null;
    else skill = id;
    load(true);
}

function loadSkills() {
    var type = "DESC";
    api.skill.all({ type: type }, function (success) {
        $('#skills_append').html('<a class="dropdown-item" href="#" onclick="skillFilter(\'all\')">All</a>');
        success.skills.forEach(function(skill) {
            $('#skills_append').append('<a class="dropdown-item" href="#" onclick="skillFilter(' + skill.id + ')">' + skill.name + '</a>');
        });
    });
}

var loadLanguages = function(){
    api.course.language(undefined , function(success){
        for(var i=0;i<success.languages.length ;i++){
            $('.inputLang').append('<a class="dropdown-item" onclick="languageFilter(`'+success.languages[i].name+'`)">'+success.languages[i].name+'</a>')
        }
    })
}

$(document).ready(function(){
    dateFilterInit();
    load(true);
    loadLanguages();
    loadSkills();
});