var quizCountId = 1;
var nex = 'C'.charCodeAt(0);
var originalLectureId;
var originalSectionId;
var sId;
var lId;

var finalSubmit = function(){
    showSuccess('All Questions are successfully saved!');
}

var validateUpdateQuizQuestion = function(quizCountId){
    clearErrors();
    var data = new FormData();
    var opt = [];
    data.append('lectureId', originalLectureId);
    data.append('id', $('#question-text-'+quizCountId).attr('data-id'));
    data.append('type', 'quiz');
    var title = sanitize($('#question-text-'+quizCountId).val());
    if(title.length == 0)
        addError('qtitle', 'Please enter a question');
    data.append('title', title);
    if($('#customFile-'+quizCountId).prop('files')[0])
        data.append('thumbnail', $('#customFile-'+quizCountId).prop('files')[0]);
    var correctOption = $('#correct-option-'+quizCountId).attr('data-opt');
    $(".option-"+quizCountId).each(function() {
        if($(this).val() == '')
            addError('qoption', 'Please enter a option');
        else{
            if($(this).attr('data-id') != undefined)
                opt.push({ 'id': $(this).attr('data-id'), 'mode': 'update', 'title': sanitize($(this).val()), 'isCorrect': ( correctOption == $(this).attr('data-opt') ? 1 : 0 ) });
            else opt.push({ 'mode': 'add', 'title': sanitize($(this).val()), 'isCorrect': ( correctOption == $(this).attr('data-opt') ? 1 : 0 ) });
        } 
    })
    if(correctOption == undefined)
        addError('qcorrect', 'Please choose a correct option');
    data.append('options', JSON.stringify(opt));
    hasError() && showErrors();
    return data;
}

var updateQuizQuestion = function(quizCountId){
    var data = validateUpdateQuizQuestion(quizCountId);
    !hasError() && api.course.updateQuestion(data, function(success) {
        $('#loader-wrap').show();
        if(success){
            $('#heading-text-'+quizCountId).text('Question '+quizCountId+':  '+ $('#question-text-'+quizCountId).val());
            showSuccess('Question is successfully updated.');
            // id="question-'+quizCountId+'"
            // addQuizQuestion(success.result.CourseQuizQuestion, quizCountId);
            $('#loader-wrap').hide();
            $('#quizQuestion-'+quizCountId).removeClass('show');
        }
    }, function(err) { })
}

var validateQuizQuestion = function(quizCountId){
    clearErrors();
    var data = new FormData();
    var opt = [];
    data.append('lectureId', originalLectureId);
    data.append('type', 'quiz');
    var title = sanitize($('#question-text-'+quizCountId).val());
    if(title.length == 0)
        addError('qtitle', 'Please enter a question');
    data.append('title', title);
    if($('#customFile-'+quizCountId).prop('files')[0])
        data.append('thumbnail', $('#customFile-'+quizCountId).prop('files')[0]);
    var correctOption = $('#correct-option-'+quizCountId).attr('data-opt');
    $(".option-"+quizCountId).each(function() {
        if($(this).val() == '')
            addError('qoption', 'Please enter a option');
        else opt.push({ 'title': sanitize($(this).val()), 'isCorrect': ( correctOption == $(this).attr('data-opt') ? 1 : 0 ) });
    })
    if(correctOption == undefined)
        addError('qcorrect', 'Please choose a correct option');
    data.append('options', JSON.stringify(opt));
    hasError() && showErrors();
    return data;
}

var saveQuizQuestion = function(quizCountId){
    var data = validateQuizQuestion(quizCountId);
    !hasError() && api.course.createQuestion(data, function(success) {
        if(success){
            $('.collapse').collapse();
            showSuccess('Question is successfully created.');
            $(".new-div-" + lId).css("display", "block");
            $('#lname-'+lId).html('').html('Total no. of Questions: '+success.questionCount);
            $("#v-" + lId + "").removeClass('active_btn').attr("disabled", false);
            $("#p-" + lId + "").removeClass('active_btn').attr("disabled", false);
            $('#q-'+lId).addClass('active_btn').attr("disabled", true);
            $('#video-pdf-' + lId).hide();
            $('#img-' + lId + '').attr("src", "/static/course/content/thumbnail/quiz.jpeg");
            $('#type_' + lId + '').text('quiz');
            $("#editFile-" + lId + "").attr('data-target', '#quizModal').attr('onclick', 'quizModal(' + sId + ',' + lId + ')');
            $("#vp-" + lId + "").attr('data-toggle', 'modal').attr('data-target', '#quizModal').attr('onclick', 'quizModal(' + sId + ',' + lId + ')').css({"display":"inline-block"});
            if ($('.settingCls').hasClass('disabled') == true)
                    $('.settingCls').removeClass('disabled');
            quizModal(sId, lId);
        }
    }, function(err) { })
}

var delQuestionOption = function(cha, oId){
    swal({ title: 'Are you sure?',  text: "You won't be able to revert this!", type: 'warning', showCancelButton: true, confirmButtonClass: 'btn  btn-success', cancelButtonClass: 'btn btn-danger m-l-10',  confirmButtonText: 'Yes, delete it!'})
    .then(function () {
        if($('.option-'+oId).length > 2){
            if($('#input-'+oId+'-'+cha).attr('data-id') != undefined){
                var id = $('#input-'+oId+'-'+cha).attr('data-id');
                api.course.deleteQuestionOption(id, undefined, function(success) {
                    if(success){
                        showSuccess('Option is successfully deleted.');
                    }
                }, function(err) { })
            }
            $('#del-opt-'+cha).remove();
            $('#'+cha+'-'+oId).remove();
            if($('#correct-option-'+oId).attr('data-opt') == cha)
                $('#correct-option-'+oId).text('Correct Option');
            $('.hide_option_'+oId).show();
            if($('.option-'+oId).length == 2)
                $('.hide_option_'+oId).hide();
            if($('.option-'+oId).length > 2)
                $('#add-option-'+oId).show();
        }else {
            addError('af', "Can'\t delete two options are required in this question.!");
            hasError() && showErrors();
        }
    });
}

var delQuestion = function(dId){
    swal({ title: 'Are you sure?',  text: "You won't be able to revert this!", type: 'warning', showCancelButton: true, confirmButtonClass: 'btn  btn-success', cancelButtonClass: 'btn btn-danger m-l-10',  confirmButtonText: 'Yes, delete it!'})
    .then(function () {
        if($('#question-text-'+dId).attr('data-id') != undefined){
            var id = $('#question-text-'+dId).attr('data-id');
            api.course.deleteQuestion(id, originalLectureId, undefined, function(success) {
                if(success){
                    showSuccess('Question is successfully deleted.');
                    $('#lname-'+lId).html('').html('Total no. of Questions: '+success.questionCount);
                    quizModal(sId, lId);
                }
            }, function(err) { })
        }
        $('#question-'+dId).remove();
        --quizCountId;
    });
}

var imageUrl = function(input, quizCountId) {
    if (input.files && input.files[0]) {
        var filename = input.files[0].name;
        ext = filename.split('.').pop().toLowerCase();
        if(ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif'){
            var reader = new FileReader();
            reader.onload = function (e) {
                $('#storeImg-'+quizCountId).attr('src', e.target.result);
            };
            reader.readAsDataURL(input.files[0]);
        }else{
            $('#customFile-'+quizCountId).val('');
            addError('ext', 'Please choose jpeg, jpg and png file format');
            hasError() && showErrors();
        }
    }
}

var getImage = function(quizCountId){
    var file = $('#customFile-'+quizCountId)[0].files[0].name;
    ext = file.split('.').pop().toLowerCase();
    if (ext == 'png' || ext == 'jpeg' || ext == 'jpg' || ext == 'gif'){
        $('#label-'+quizCountId).text(file);
        imageUrl($('#customFile-'+quizCountId)[0], quizCountId);
    }else {
        $('#customFile-'+quizCountId).val('');
        $('#label-'+quizCountId).text('Choose file');
    }
}

var addOption = function(quizCountId, questionOptions = undefined){
    if(questionOptions != undefined){
        var charac = 'A'.charCodeAt(0);
        questionOptions.forEach(function(option){ 
            var curr = String.fromCharCode(charac++);
            $('#option-append-'+quizCountId).append('<a class="dropdown-item removeActive-'+quizCountId+'" id="'+curr+'-'+quizCountId+'" href="javascript:void(0);" onclick="getCorrectOption(\''+curr+'\','+quizCountId+')">' + curr + '</a>');
            $('#addOptionNum-'+quizCountId).append('<div class="form-group" id="del-opt-'+curr+'"> <input type="text" id="input-'+quizCountId+'-'+curr+'" class="form-control option-'+quizCountId+'" placeholder="Enter Your Answer" data-opt="'+curr+'" value="'+(option ? option.title: '')+'" '+(option ? 'data-id='+option.id : '')+'> <span class="alfpa_bet">'+curr+'.</span> <span class="del_quiz hide_option_'+quizCountId+'" onclick="delQuestionOption(\''+curr+'\','+quizCountId+')"><i class="fa fa-trash"></i></span> </div>');
            if(option.isCorrect == 1)
                getCorrectOption(curr, quizCountId);
        })
        if(questionOptions.length == 2) $('.hide_option_'+quizCountId).hide();
        else $('.hide_option_'+quizCountId).show();
    }else {
        if($('.option-'+quizCountId).length == 0){
            $('#option-append-'+quizCountId).append('<a class="dropdown-item removeActive-'+quizCountId+'" id="A-'+quizCountId+'" href="javascript:void(0);" onclick="getCorrectOption(\'A\','+quizCountId+')">A</a> <a class="dropdown-item" id="B-'+quizCountId+'" href="javascript:void(0);" onclick="getCorrectOption(\'B\','+quizCountId+')">B</a>')
            $('#addOptionNum-'+quizCountId).append('<div class="form-group" id="del-opt-A"> <input type="text" id="input-'+quizCountId+'-A"  class="form-control option-'+quizCountId+'"  placeholder="Enter Your Answer" data-opt="A"> <span class="alfpa_bet">A.</span><span class="del_quiz hide_option_'+quizCountId+'" style="display:none;" onclick="delQuestionOption(\'A\','+quizCountId+')"><i class="fa fa-trash"></i></span> </div> <div class="form-group" id="del-opt-B"> <input type="text" id="input-'+quizCountId+'-B" class="form-control option-'+quizCountId+'" placeholder="Enter Your Answer"  data-opt="B"> <span class="alfpa_bet" >B.</span><span class="del_quiz hide_option_'+quizCountId+'" style="display:none;" onclick="delQuestionOption(\'B\', '+quizCountId+')"><i class="fa fa-trash"></i></span> </div>');
        }else if($('.option-'+quizCountId).length < 5){
            var cht = $('.option-'+quizCountId).last().attr('data-opt').charCodeAt(0);
            var curr = String.fromCharCode(++cht);
            $('#option-append-'+quizCountId).append('<a class="dropdown-item removeActive-'+quizCountId+'" id="'+curr+'-'+quizCountId+'" href="javascript:void(0);" onclick="getCorrectOption(\''+curr+'\','+quizCountId+')">' + curr + '</a>');
            $('#addOptionNum-'+quizCountId).append('<div class="form-group" id="del-opt-'+curr+'"> <input type="text" id="input-'+quizCountId+'-'+curr+'" class="form-control option-'+quizCountId+'" placeholder="Enter Your Answer" data-opt="'+curr+'"> <span class="alfpa_bet">'+curr+'.</span> <span class="del_quiz hide_option_'+quizCountId+'" onclick="delQuestionOption(\''+curr+'\','+quizCountId+')"><i class="fa fa-trash"></i></span> </div>');
            $('.hide_option_'+quizCountId).show();
        }
    }
    if($('.option-'+quizCountId).length == 5){
		$('#add-option-'+quizCountId).hide();
    }
    if($('.option-'+quizCountId).length == 2){
        $('.hide_option_'+quizCountId).hide();
	}
}

var getCorrectOption = function(type, quizCountId){
    $('#correct-option-'+quizCountId).text('Correct Option ('+type+')');
    $('#correct-option-'+quizCountId).attr('data-opt', type);
    $('.removeActive-'+quizCountId).removeClass('active').css({"background-color": "","color": ""});
    var id = '#'+type+'-'+parseInt(quizCountId);
    $(id).addClass('active').css({"background-color": "green","color": "white"});
}

var addnewQuizQuestion = function(){
    clearErrors();
    var newCheckId = quizCountId - 1;
    if($('#question-text-'+newCheckId).attr('data-id') == undefined){
        addError('roshit', 'Please save previous question first.');
        hasError() && showErrors();
    }else addQuizQuestion();

}

var addQuizQuestion = function(question = undefined, i){
    if(question != undefined) quizCountId = i;
    $('#quizAllQuestion').append(' <div class="accordion" id="question-'+quizCountId+'"> <div class="card quiz_card" id="uniqueQuizId'+quizCountId+'"> <div class="card-header quiz_card_head" id="headingOne"> <button id="heading-text-'+quizCountId+'" class="btn btn-link btn_quiz_head" type="button" data-toggle="collapse" data-target="#quizQuestion-'+quizCountId+'" aria-expanded="true" aria-controls="collapse-'+quizCountId+'"> Question '+quizCountId+': '+(question ? question.title: '')+'</button> <span class="del_quizQuest" onclick="delQuestion('+quizCountId+');"><i class="fa fa-trash"></i></span> </div> <div id="quizQuestion-'+quizCountId+'" class="collapse '+(i ? i == 1 ? 'show' : '': 'show')+'" aria-labelledby="headingOne" data-parent="#question-'+quizCountId+'"> <div class="card-body"> <div class="row" id="addOptionAns"> <div class="col-sm-12"> <div class="form-group"> <input type="text" id="question-text-'+quizCountId+'" class="form-control" placeholder="Enter Your Question" value="'+(question ? question.title: '')+'" '+(question ? 'data-id='+question.id : '')+'> </div> </div> <div class="col-sm-6" id="addOptionNum-'+quizCountId+'">     </div> <div class="col-sm-6"> <div class="custom-file mb-3"> <input type="file" class="custom-file-input" id="customFile-'+quizCountId+'" accept="image/x-png,image/gif,image/jpeg" onchange="getImage('+quizCountId+')" name="filename"> <label id="label-'+quizCountId+'" class="custom-file-label" for="customFile">Choose Image <b style="color:#2c5882">(Optional)</b></label> </div><div class="store_img"><img id="storeImg-'+quizCountId+'" src="'+(question && question.thumbnail ? '/static/course/content/thumbnail/'+question.thumbnail: '')+'"></div> </div> </div> <div class="option_answer"> <div class="row"> <div class="col-sm-8"> <div class="opti_btn"> <button type="button" class="btn btn-primary" id="add-option-'+quizCountId+'" onclick="addOption('+quizCountId+');">Add Option</button><div class="btn-group"> <button type="button" class="btn btn-info dropdown-toggle mr-2" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" id="correct-option-'+quizCountId+'">Correct Option </button> <div class="dropdown-menu" id="option-append-'+quizCountId+'" >    </div> </div>  </div> </div> <div class="col-sm-4"> <div class="save_quiz_quest"> <button type="button" class="btn btn-success" onclick="'+(question ? 'updateQuizQuestion('+quizCountId+')': 'saveQuizQuestion('+quizCountId+');')+'">Save</button> </div> </div> </div> </div> </div> </div> </div></div>');
    $('#option-append-'+quizCountId).html('');
    $('#addOptionNum-'+quizCountId).html('');
    addOption(quizCountId, (question != undefined ?  question.CourseQuizQuestionOptions: undefined));
    ++quizCountId;
}

var quizModal = function(sectionId, lectureId) {
    sId = sectionId;
    lId = lectureId
    originalSectionId = $('#section-' + sId).attr('name');
    originalLectureId = $('#lecture-' + lId).attr('name');
    var check = checkInputData(lId);
    if(check){
        $('#quizAllQuestion').html('');
        api.course.lectureQuestion({wQ3LG:originalLectureId, rT5Sd:originalSectionId}, function(success) {
            if(success && success.success && success.result.length > 0){
                var i = 1;
                success.result.forEach(function(question) {
                    addQuizQuestion(question.CourseQuizQuestion, i);
                    ++i;
                });
            }else {
                quizCountId = 1;
                addQuizQuestion();
            }
        }, function(err) {
        })
    }

}