var validate = function(){
    clearErrors();
    var data = new Object();
    data.firstName = sanitize($('#fname').val());
    if(data.firstName.length == 0){
        addError('fname', 'First Name is required field');
    }

    data.lastName = sanitize($('#lname').val());
    if(data.lastName.length == 0){
        addError('lname', 'Last Name is required field');
    }

    data.email = sanitize($('#email').val());
    if(data.email.length == 0){
        addError('email', 'Email is required field');
    }else if(!validateEmail(data.email)){
        addError('email', 'Email is Invalid');
    }

    data.password = sanitize($('#password').val());
    if(data.password.length == 0){
        addError('password', 'Password is required field');
    }

    data.confhash = sanitize($('#password-confirm').val());
    if(data.confhash.length == 0){
        addError('password-confirm', 'Confirm password is required field');
    }
    hasError() && showErrors();
    return data;
}

var register = function(){
    
    var data = validate();
    showLoader();
    !hasError() && api.auth.post(data, function(data){
        hideLoader();
        showSuccess('Verification link sent to your provided email.');
        setTimeout(function() {
            window.location = '/verify';
        },1000);
    }, function (err) {
        hideLoader();
        if(err.errors){
        showError(JSON.stringify(err.errors));}
    });
}





$(document).ready(function(){
    $('#register').on('click', function(){
        register();
        return false;
    });
    var dataAllInputs  = document.getElementsByTagName("input");
    for (var i = 0; i < dataAllInputs.length; i++) 
        dataAllInputs[i].setAttribute('autocomplete', 'off');
});