var headerVal = new Object();

var url = /^(?:(?:https?|ftp):\/\/)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/;
var domainName = /^((?:(?:(?:\w[\.\-\+]?)*)\w)+)((?:(?:(?:\w[\.\-\+]?){0,62})\w)+)\.(\w{2,6})$/;

var validateAD = function(){
    clearErrors();
    var data = new Object();
    data.ssl = sanitize($.trim($('#ssl').val()));
    if(data.ssl.length == 0 )
        addError('ssl', 'Please Choose Protocol');

    data.url = sanitize($.trim($('#url').val()));
    if(data.url.length == 0)
        addError('url', 'Enter Url');
    data.baseDN = sanitize($.trim($('#domainName').val()));
    if(data.baseDN.length == 0)
        addError('domainName', 'Enter Domain Name');
    else if(!data.baseDN.match(domainName))
        addError('domainName', 'Enter Valid Domain Name');

    data.username = sanitize($.trim($('#ad_username').val()));
    if(data.username.length == 0)
        addError('ad_username', 'Enter Username'); 

    data.password = $.trim($('#ad_password').val());
    if(data.password.length == 0)
        addError('ad_password', 'Enter Password');

    data.savePassword = $('#savePassword').prop('checked');
    hasError() && showErrors();
    return data;
}

var saveUpdateAD = function(){
    var data = validateAD();
    if(!hasError() && data){
        api.setting.AD(data, function(success) {
            if(success && success.success)
                showSuccess('Authenticated.');
            $('#save-update-ad').html('Update');

        });
    }
}

var allowLearnerToThierLogin = function(type){
    api.company.skipLogin({type: type}, function(success) {
        if(success && success.success)
            showSuccess('Skip login setting is '+(type ? 'On': 'Off'));
    });
}

var validateChangePassword = function(){
    clearErrors();
    var data = new Object();
    var oldPass = $('#oldPass').val();
    if(oldPass.length == 0)
        addError('oldPass', 'Old Password is required field');
    var newPass = $('#newPass').val();
    if(newPass.length == 0)
        addError('newPass', 'New Password is required field');
    var confPass = $('#newRePass').val();
    if(confPass.length == 0)
        addError('newRePass', 'Confirm new password is required field')
    if(confPass != newPass)
        addError('newRePass', 'Confirm new password should match new Password');
    data.oldPass = oldPass;
    data.newPass = newPass;
    data.confirmPass = confPass;
    hasError() && showErrors();
    return data;
}

var clearChangePassword = function(){
    $('#oldPass').val('');
    $('#newPass').val('');
    $('#newRePass').val('');
}

var updatePassword = function(){
    var data = validateChangePassword();
    !hasError() && api.setting.changePassword(data, function(success) {
        showSuccess('New Password has been updated!');
        clearChangePassword();
        setTimeout(function(){ 
           window.location = '/logout';
        }, 1000);
    })
}

var validateUpdateCompany = function(){
    clearErrors();
    var r = 0;
    var formdata = new FormData();
    var companyName = sanitize($('#company-name').val());
    formdata.append('name', companyName);
    let t;
    let file = $('input[name=company-logo]').prop('files')[0];
    //formdata.append('logo', $('input[name=company-logo]').prop('files')[0]);
    if(file != undefined){
    t = file.type.split('/').pop().toLowerCase();
    if (t != "jpeg" && t != "jpg" && t != "png") {
        addError('validImg', 'Only .png, .jpg and .jpeg format allowed!');
        r=1;
    }
    if (file.size > 10485760) {
        addError('validImg', 'File Size Too Large !!');
        r=1
    }
    formdata.append("logo", file);
}
    if(r == 1){
        hasError() && showErrors();
    }else
       return formdata;
}

var updateCompany = function(){
    var data = validateUpdateCompany();
    var id = $('#company-id').val();
    !hasError() && api.setting.update(id, data, function(success){
        if(success && success.success)
            showSuccess('Company Profile is updated successfully');
        if(success.company.logo && success.company.logo != null){
            $('#headLogo').addClass('logoImage');
            $('#headLogo').attr('src', '/static/company/logo/'+success.company.logo)
        }
    })
}

var readURL = function(input) {
    if (input.files && input.files[0]) {
        var reader = new FileReader();
        reader.onload = function (e) {
            $('#company-logo').attr('src', e.target.result);
        };
        reader.readAsDataURL(input.files[0]);
    }
}

var validateProfile = function(){
    clearErrors();
    var data = new Object();
    data.firstName = sanitize($('#firstName').val());
    if(data.firstName.length == 0){
        addError('firstName', 'First Name is required field');
    }
    data.lastName = sanitize($('#lastName').val());
    hasError() && showErrors();
    return data;
}

var saveProfile = function() {
    var data = validateProfile();
    !hasError() && api.setting.profileUpdate(data, function(success) {
        showSuccess('Profile has been updated!');
    })
}


var validateSender = function() {
    clearErrors();
    var data = new Object();
    data.name = $('#senderName').val();
    if(data.name.length == 0)
        addError('senderName', 'Please Enter Name');
    data.fromAddress = $('#fromAddress').val();
    if(data.fromAddress.length == 0)
        addError('fromAddress', 'Please Enter From Address');
    data.host = $('#host').val();
    if(data.host.length == 0 || data.host.indexOf(":") == -1)
        addError('host', 'Enter a valid Host address with port number.');

    var username = $('#username').val();
    data.username = '';
    if(username.length)
        data.username = username;
    var password = $('#password').val();
    if(password.length && password != "*****")
        data.password = password;
    data.ignore_cert_errors = 1;
    data.requiretls = $('#strattls').prop("checked");
    hasError() && showErrors();
    return data;
}

var saveSender = function() {
    var data = validateSender();
    if(!hasError()){
        $('#savesender').attr('disabled','disabled');
        if(senderId == 0){
            api.sender.post(data, function(success) {
                if(success.senderId){
                    showSuccess('SMTP Profile has been created!');
                    senderId = success.senderId;
                    $('#add-email-headers').hide();
                    // $('#advanced-settings').show();
                    $('#savesender').html('Update').removeAttr('disabled');
                }
            }, function(error) { $('#savesender').removeAttr('disabled') });
        }else{
            api.sender.patch(senderId, data, function(success) {
                showSuccess('SMTP Profile is updated!');
                $('#savesender').html('Update').removeAttr('disabled');
                loadSender();
            }, function(error) { $('#savesender').removeAttr('disabled') })
        }
    }
}

var validateHeader = function(){
    clearErrors();
    var data = new Object();
    data.key = $('#key').val();
    if(data.key.length == 0)
        addError('key', 'Please enter the Email Header');
    data.value = $('#value').val();
    if(data.value.length == 0)
        addError('value', 'Please enter the Email Header Value');
    if(senderId > 0)
        data.senderId = senderId;
    hasError() && showErrors();
    return data;
}


var removeHeader = function(id) {
    swal({ title: "Warning!", type: "warning", text: "Are you sure", showCancelButton: true, })
    .then(function(){
        api.header.delete(id, undefined, function(success) {
            showSuccess('Header Removed!');
            loadHeaders(senderId);
        })
    })
}

var addHeader = function(header) {
    if(header.key.length && header.value.length){
        headerVal[header.key] = {key: header.key, value: header.value};
        $('#headers tbody').append('<tr><td>'+header.key+'</td><td>'+header.value+'</td><td><a href="javascript:void(0);" style="color:red;" onclick="removeHeader(\''+header.id+'\')"><i class="fa fa-trash" aria-hidden="true"></i> Remove</a></td></tr>')
    } 
}

var clearHeaderFields = function() {
    $('#key').val('');
    $('#value').val('');
}

var addNewHeader = function() {
    var data = validateHeader();
    !hasError() &&  api.header.post(data, function(success) {
        clearHeaderFields();
        loadHeaders(senderId);
        showSuccess('New Header Added!');
    })
}

var validateAdvancedSetting = function(){
    clearErrors();
    var data = {};
    data.ssl = $('#ssl').prop('checked');
    data.pool = $('#pool').prop('checked');
    if($('#pool').prop('checked')){
        data.maxMessage = $('#maxmessage').val();
        if(data.maxMessage.length == 0)
            addError('maxmessage', 'Enter a Max. message');
        data.maxConnection = $('#maxconnection').val();
        if(data.maxConnection.length == 0)
            addError('maxconnection', 'Enter a Max. connection');
        data.connectionTimeout = $('#connectiontimeout').val();
        if(data.connectionTimeout.length == 0)
            addError('connectiontimeout', 'Enter a connection timeout');
    }
    data.limit = $('#limit').val();
    if(data.limit.length == 0)
        addError('limit', 'Enter a limit');
    data.delay = $('#delay').val();
    if(data.delay.length == 0)
        addError('delay', 'Enter a delay');
    hasError() && showErrors();
    return data;
}

var advancedSetting = function(){
    var data = validateAdvancedSetting();
    !hasError() && api.sender.advancedSettings(senderId, data, function(success){
        $('#advancedSetting').modal('hide');
        showSuccess('Advanced Setting has been updated!');
    })
}

var validateBody = function() {
    var data = new Object();
    data.fromAddress = $('#fromAddress').val();
    if(data.fromAddress.length == 0)
        addError('fromAddress', 'Please Enter From Address');
    data.host = $('#host').val();
    if(data.host.length == 0 || data.host.indexOf(":") == -1)
        addError('host', 'Enter a valid Host address with port number.');
    var username = $('#username').val();
    data.username = '';
    if(username.length)
        data.username = username;
    var password = $('#password').val();
    if(password.length && password != "*****") 
        data.password = password;
    else  data.senderId = senderId;
    data.email = $('#email').val(); 
    if(data.email.length == 0)
        addError('email', 'Please Enter Email');
    data.headers = Object.values(headerVal);
    hasError() && showErrors();
    return data;
}

var addPool = function(){
    if($('#pool').prop('checked')){
        $('#maxmessage').prop('disabled', false);
        $('#maxconnection').prop('disabled', false);
        $('#connectiontimeout').prop('disabled', false);
    }else {
        $('#maxmessage').prop('disabled', true);
        $('#maxconnection').prop('disabled', true);
        $('#connectiontimeout').prop('disabled', true);
    }
}

var sendTestEmail = function()  {
    var data = validateBody();
    !hasError() && api.sender.send(data, function(success) {
        $('#test-mail').modal('hide');
        showSuccess('Test email send successfully!');
    }, function(err) { });
}

var SMTPRadio = function(type){
    if(type == 'd') $('#showCustom').hide();
    else  $('#showCustom').show();
    api.company.smtp({type: type}, function(success) {
        if(success && success.success)
            showSuccess('You Set '+(type == 'd' ? 'Default' : 'Custom')+ ' Setting');
        // loadSender();
    });
}

var loadEmailUnsubscribe = function(){
    api.member.emailUnsubscribe(undefined, function(success) {
        if(success && success.success){
            $('#course-assigning').addClass((success.member.courseMails ? 'active' : '' )).attr('preference', success.member.courseMails);
            $('#assessment-assigning').addClass((success.member.assessmentMails ? 'active' : '' )).attr('preference', success.member.assessmentMails);
            $('#reminder-mails').addClass((success.member.reminderMails ? 'active' : '' )).attr('preference', success.member.reminderMails);
            $('#announcement-mails').addClass((success.member.announcementMails ? 'active' : '' )).attr('preference', success.member.announcementMails);
        }
    });
}

var saveEmailUnsubscribePreference = function(type, id){
    var data = new Object();
    var newPrefer = ($('#'+id).attr('preference') == 'false'? true : false);
    data[type] = newPrefer;
    api.member.saveEmailUnsubscribe(data, function(success) {
        if(success && success.success){
            $('#'+id).attr('preference', newPrefer);
            showSuccess('Your Email Unsubscribe Preference is successfully Updated.')
        }
    });
}

$(document).ready(function(){
    $('#logoUpload').change(function() {
        var i = $(this).prev('label').clone();
        var file = $('#logoUpload')[0].files[0].name;
        $(this).next('label').text(file);
    });
    $('#custom-smtp').click(function(){
       loadSender();
    });
    $('#email-unsubscribe').click(function(){
        loadEmailUnsubscribe();
     });
    $('#attack-profile').click(function(){
        $('#showCustom').hide();
        if($('#custom-smtp').prop('checked'))
            $('#showCustom').show();
    });
    $('#home').addClass('show active');
})