var searchQuery = null;
var setting;
var sortByPer = {};

var download = function (content, fileName, mimeType) {
    var a = document.createElement('a');
    mimeType = mimeType || 'application/octet-stream';

    if (navigator.msSaveBlob) {
        navigator.msSaveBlob(new Blob([content], {
            type: mimeType
        }), fileName);
    } else if (URL && 'download' in a) {
        a.href = URL.createObjectURL(new Blob([content], {
            type: mimeType
        }));
        a.setAttribute('download', fileName);
        document.body.appendChild(a);
        a.click();
        document.body.removeChild(a);
    } else {
        location.href = 'data:application/octet-stream,' + encodeURIComponent(content);
    }
}
var setDetails = function(data) {
    var items = [], count = 1;
    items.push([
        'Sr. No.',
        'Name',
        'Email',
        'Max Marks',
        'Mark Obtained',
        'Percentage',
        'Attempts',
        'Status'
    ]);
    for (var i = 0; i < data.length; i++) {
        var passingPercentage = (data[i].percent ? data[i].percent : 0)+ '%';
        var totalMarks = (data[i].Quiz ? data[i].Quiz.totalMarks : 0);
        var obtain_marks = 0, attempts = 0;
        if(data[i].Session.QuizUserDetails && data[i].Session.QuizUserDetails[0]){
            attempts = data[i].Session.QuizUserDetails[0].attempts;
            obtain_marks = data[i].Session.QuizUserDetails[0].obtainedMarks;
        }
        if (data[i].Quiz.settings) setting = JSON.parse(data[i].Quiz.settings);
        if (data[i].percent && parseFloat(data[i.percent]) == 0.00)  status = 'Not attempted';
        else if (data[i].percent && parseFloat(data[i].percent) >= setting.percentage)  status = 'PASS';
        else  status = 'FAIL';
        items.push([
            count++,
            (data[i].Session.firstName ? data[i].Session.firstName : '') + ' ' + (data[i].Session.lastName ? data[i].Session.lastName : ''),
            (data[i].Session.email ? data[i].Session.email : '-'),
            (totalMarks),
            (obtain_marks),
            (passingPercentage),
            (attempts),
            (status),
        ]);
    }
    var csvContent = '';
    items.forEach(function (infoArray, index) {
        dataString = infoArray.join(',');
        csvContent += index < items.length ? dataString + '\n' : dataString;
    });
    download(csvContent, 'user-assessment-result.csv', 'text/csv;encoding:utf-8');
}

var exportcsv = function () {
    clearErrors();
    var data = {};
    data.id =  page.id;
    if (Object.keys(sortByPer).length > 0)
        data.sort = sortByPer;
    data.type = 'csv';
    api.result.get(data, function (success) {
        if (success.users && success.users.length > 0) {
            setDetails(success.users);
        } else {
            addError('error', "No data found, can't download csv.!");
            hasError() && showErrors();
        }
    });

}

var sortByPercentage = function (start, end) {
    sortByPer.start = start;
    sortByPer.end = end;
    if (start == '' && end == '')
        sortByPer = {};
    load(true);
}

var reloadList = function () {
    load(true);
}

var searchQuery = function () {
    setPage(1);
    load(false);
}

var paginationData = function (count) {
    setLimit(count);
    setPage(1);
    load(true);
}

var validate = function () {
    var data = new Object();
    data.search = $('#searchBar').val();
    data.id = page.id;
    if (data.search.length < 3)
        data.search = undefined;
    if (Object.keys(sortByPer).length > 0)
        data.sort = sortByPer;
    data.page = getPageNo();
    data.limit = getLimit();
    return data;
}

var clearUserAssessment = function () {
    $('#user_assessment').html('');
    $('#pagecount').html('');
    $('#pagination').html('');
    $('#gotopage').html('');
}

var setUserAssessment = function (data) {
    var passingPercentage =  data.percent + '%';
    var totalMarks = (data.Quiz ? data.Quiz.totalMarks : 0);
    var setting;
    if (data.Quiz.settings)
        setting = JSON.parse(data.Quiz.settings);
    var obtain_marks = 0, attempts = 0;
    if(data.Session.QuizUserDetails && data.Session.QuizUserDetails[0]){
        attempts = data.Session.QuizUserDetails[0].attempts;
        obtain_marks = data.Session.QuizUserDetails[0].obtainedMarks;
    }
    // console.log(data)
    var status = '', color = '';
    if (data.percent && parseFloat(data.percent) == 0.00 && data.Session.QuizUserDetails.length == 0) {
        status = 'Not attempted';
        color = 'orange';
    }else if (data.percent && parseFloat(data.percent) >= setting.percentage) {
        status = 'PASS';
        color = 'green';
    }else {
        status = 'FAIL';
        color = 'red';
    }
    $('#user_assessment').append('<tr> <td>' + data.Session.firstName + ' ' + (data.Session.lastName ? data.Session.lastName : '') + '</td> <td>' + data.Session.email + '</td> <td>' + totalMarks + '</td> <td>' + obtain_marks + '</td> <td>' + passingPercentage + '</td><td>' + attempts + '</td>  <td style="color:' + color + '"><b>' + status + '</b></td><td><a style="cursor: pointer;color: #0080ff;" onclick="showSwal(\'' + status + '\')" '+((data.percent != 0.00 || data.Session.QuizUserDetails.length != 0) ? 'href="/quiz-results?lId='+page.id+'&sKey='+data.Session.sessionKey+'&ac=YXNzZXNzbWVudA=="' : '')+' title="View Result" target="_blank"><i class="fa fa-list-alt" aria-hidden="true"></i> View</a></td> </tr>');
}

function showSwal(status){
    if(status == 'Not attempted'){
    swal({ title: "Warning", type: "warning", text: "Quiz is not attempted, please try another result" })
    }
}

var load = function (noloader) {
    var data = validate();
    api.result.get(data, function (success) {
        clearUserAssessment();
        if (success.users && success.users.length > 0) {
            success.users.forEach(function (data) {
                setUserAssessment(data);
            });
            if (success.pages && success.count)
                addPagination(success.pages, success.count);
        } else $('#user_assessment').html('<td>No User Found.</td>');
    }, function(error) { }, noloader);
}

$(document).ready(function () {
    load(true);
});