import express from 'express';
import { authRouter } from './resources/auth';
import { dashboardRouter } from './resources/dashboard';
import { courseRouter } from './resources/course';
import { quizRouter } from './resources/quiz';
import { groupRouter } from './resources/group';
import { skillRouter } from './resources/skill';
import { memberRouter } from './resources/member';
import { campaignRouter } from './resources/campaign';
import { simulationRouter } from './resources/simulation';
import { iamRouter } from './resources/iam';
import { iamUserRouter } from './resources/iam-user';
import { actionRouter } from './resources/action';
import { companyRouter } from './resources/company';
import { learnerRouter } from './resources/learner';
import { analyticRouter } from './resources/analytic';
import { resultRouter } from './resources/result';
import { appsumoRouter } from './resources/appsumo';
import { senderRouter } from './resources/sender';
import { templateRouter } from './resources/template';

export const restRouter = express.Router();
restRouter.use('/auth', authRouter);
restRouter.use('/dashboard', dashboardRouter);
restRouter.use('/course', courseRouter);
restRouter.use('/quiz', quizRouter);
restRouter.use('/group', groupRouter);
restRouter.use('/member', memberRouter);
restRouter.use('/skill', skillRouter);
restRouter.use('/campaign', campaignRouter);
restRouter.use('/simulation', simulationRouter);
restRouter.use('/iam', iamRouter);
restRouter.use('/iam-user', iamUserRouter);
restRouter.use('/action', actionRouter);
restRouter.use('/company', companyRouter);
restRouter.use('/learner', learnerRouter);
restRouter.use('/analytic', analyticRouter);
restRouter.use('/result', resultRouter);
restRouter.use('/appsumo', appsumoRouter);
restRouter.use('/sender', senderRouter);
restRouter.use('/template', templateRouter);