import express from 'express';
import dashboardController from './dashboard.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { jwtStrategy } from '../../../middleware/strategy';
import { userPermission } from '../../../middleware/userPermission';

export const dashboardRouter = express.Router();
dashboardRouter.route('/').get(sanitize(), jwtStrategy, userPermission('home-read'),dashboardController.index);
dashboardRouter.route('/campaign-types').get(sanitize(), jwtStrategy, userPermission('home-read'), dashboardController.campaignTypes);
dashboardRouter.route('/graph').get(sanitize(), jwtStrategy,userPermission('home-read'), dashboardController.graph);
dashboardRouter.route('/activity').get(sanitize(), jwtStrategy,userPermission('home-read'), dashboardController.recentActivity);
dashboardRouter.route('/top-courses').get(sanitize(), jwtStrategy,userPermission('home-read'), dashboardController.topCourses);
dashboardRouter.route('/activity-log').get(sanitize(), jwtStrategy,userPermission('home-read'), dashboardController.avtivityLog);


 