import bcrypt from 'bcrypt-nodejs';
import { db } from '../../../models';
import mailer from '../../../mailer';
import { runInNewContext } from 'vm';

export default {

/* API:list of user-----------------------------------------------------------------
  Author: Ashish-------------------------------------------------------------------*/
    async index(req, res) {
         db.Employee.findAll({attributes:['id','firstName','lastName','email'],where:{companyId:req.user.companyId}})
            .then(re => {
                if(re)
                return res.status(200).json({ 'data': re });
                else
                return res.status(401).json({ 'errors':"list is not found" });
            });
    },
 /*API:get User By ID---------------------------------------------------------------
 Author:Ashish---------------------------------------------------------------------*/

   async showUser(req,res){
     if(req.params.userId){
         db.Employee.findOne({where:{id:req.params.userId, companyId:req.user.companyId}},{attributes:['id','firstName','lastName','email']})
        .then(re => {
            if(re)
            return res.status(200).json({ 'User': re });
            else
            throw new RequestError('User is not found',401);
        });  
     }
     else{
        return res.status(401).json({ 'Errors':"Invalid User Id" });
     }
   },

   /*API:show User Policy---------------------------------------------------------------
 Author:Ashish---------------------------------------------------------------------*/

 async showUserPolicy(req,res,next){
       db.Employee.findOne({ where: { id: req.params.userId, companyId: req.user.companyId } })
          .then(user => {
             if (user) {
                return db.UserPolicy.findAll({ attributes: ['id'], where: { userId: user.id , type : 'employee' }, include: [{ model: db.Policy }], })
             }
             throw new RequestError('User is not found', 401);

          })
          .then(re => {
             if (re)
                return res.status(200).json({ 'data': re });

             throw new RequestError('User is not found');
          })
          .catch(err=>{
             console.log(err);
             next(err)
          })
   
  },
  /*API:Delete User---------------------------------------------------------------
 Author:Ashish---------------------------------------------------------------------*/

 async policyUserDelete(req,res){
        var date=new Date();
       db.Employee.findOne({where:{id:req.params.userId , companyId:req.user.companyId }})
       .then(user=>{
         if(user) 
         {
            return db.UserPolicy.update(
               { deletedAt : date },
             { where : { userId : req.params.userId , policyId : req.params.policyId, type : 'employee'},
          })
         }
         throw new RequestError('Access denied !',401);

       })
       .then(re => {
           if(re)    return res.status(200).json({ 'status':"delete User Seccessfully" });
           throw new RequestError('Unable to delelte employee policy',401);
       });  
    
    
  }
,

  async userDelete(req,res,next){
     var date = new Date();
     db.Employee.findOne({ where: { companyId: req.user.companyId, id: parseInt(req.params.userId) } })
        .then(user => {
           if (user && req.user.type == "root") {
              return db.Employee.update({ deletedAt: date }, { where: { id: user.id }, })
           }
           else if (user && req.user.type == "employee" && req.user.id != user.id) {
              return db.Employee.update({ deletedAt: date }, { where: { id: user.id }, })
           }
           throw new RequestError('Access denied. ', 401);
        })
        .then(re => {
           if (re) return res.status(200).json({ 'status': "deleted User Seccessfully" });
           else throw new RequestError('User is not found');
        }).catch(err => {
           next(err)
        })  

 },

  async addEmployee(req, res, next) {
   const {email,firstName,lastName,phone}=req.body;
   var otp=Math.random().toString(36).replace('0.', '');
   var date=new Date();
   var otpExpiry=new Date().setMinutes(date.getMinutes() + 2880);
   return db.Employee.findOne({where:{email},paranoid:false})
   .then(user=>{
      if(user){
         if(user.deletedAt != null){
           return db.Employee.update({ deletedAt : null ,otp,otpExpiry},{where:{id:user.id },paranoid:false}).then(r=>[r[0]," Employee added. Login Link has been sent to employee's email."])
         }
          throw new RequestError("User already exists",409);
      }
      return db.Employee.create({email,phone,otp,otpExpiry,firstName,lastName,valid:1,companyId:req.user.companyId,resetPassword:1, isNewUser:1}).then(r=>[r," New Employee added. Login credentials has been sent to employee's email."])
   })

   .then(([alias,msg])=>{
      if(alias){
         mailer.sendEmployeePassword(email,otp,req.user.Company.alias);
         return res.status(200).json({success:true,key:otp,firstName,lastName,email ,msg});
      }
      return res.status(500).json({Errors:'server error'})
   }).catch(err=>{console.log(err)
      next(err);
   })
},
/* this lists all managed policy and custom policy of same company user----> fixed check it(shivam)*/
async employeePolicyList(req, res,next) {
   db.Employee.findOne({ where : { id:req.params.id,companyId : req.user.companyId }})
   .then(user=>{
      if(user){
       return db.Policy.findAll({
          where: {
             $or: [{
                type: "managed"
             }, {
                type: "custom",
                companyId: req.user.companyId
             }]
          },
          include: [{
             model: db.UserPolicy,
             where: {
                userId: user.id
             }
             ,required:false
          }]
       })
      }
      throw new RequestError('User doent exist',401)
   })
       .then(UserPolicy=>{
         return res.status(200).json({"data":UserPolicy});
       })
       .catch(err=>{
          next(err);
       })
},

async employeePolicyUpdate(req, res, next) {
   const { list } = req.body;
      db.Employee.findOne({ where : { companyId : req.user.companyId  ,id : req.params.id }})
      .then(user=>{
         if(user){
           return db.UserPolicy.destroy({ where: { userId: req.params.id , type:'employee' } })
         }
         throw new RequestError('User doent exist', 401 )
      })
      .then(des => {
         var UserPolicies = [];
         for (var i = 0; i < list.length; i++) {
            UserPolicies.push({
               policyId: parseInt(list[i]),
               userId: req.params.id,
               type:'employee'
            })
         }
         return db.UserPolicy.bulkCreate(UserPolicies);
      })
      .then(UserP => {
         if (UserP) {
            return res.status(200).json({ 'status': "true" });
         } 
            return res.status(500).json({ 'Error': "Server Error!" });
         
      })
      .catch(err => {
         next(err);
      })
   // }
//   else {
//    return res.status(400).json({ 'Error': "Something is Worng !" });
//   }
},

async employeeResetPassword(req, res, next){
      const{ id } =req.body 
      const Password = Math.random().toString(36).replace('0.', '');
      var passwordHash = bcrypt.hashSync(Password);
      var dt=new Date();
      db.Employee.findOne({where: { id, companyId: req.user.companyId}})
      .then(user=>{
         if(user){
            return db.Employee.update({ password : passwordHash , otp : Password ,otpExpiry: dt.setHours(dt.getHours()+48) ,resetPassword : 1, isNewUser : 1}, {where : { id } } ).then(r => [r,user])
         }
         throw new RequestError('User doent exist', 401 )
      }) 
      .then(([re,user])=>{
         console.log(re)
         if(re){
            return db.Company.findOne({where: { id : user.companyId } }) .then(r=>[r,user])
         }
         throw new RequestError('No Company Found', 401 )
      })
      .then(([re,user])=>{
         if(re){
            mailer.employeeResetPassword(user.email,Password,re.alias)
            return res.status(200).json({success:true,"status":"Reset Link Sent."})
         }
         throw new RequestError('Mail Was Not Send', 401 )
      })
      .catch(err => {
         next(err);
      }) 
},
}