import { db } from '../../../models';
import mailer from '../../../mailer';

export default {

    /* API:list of Policy-----------------------------------------------------------------
      Author: Ashish-------------------------------------------------------------------*/

      async index(req, res,next) {
        db.Policy.findAll({ where: {  type: "managed"}})
           .then(re => {
                if(re) return db.Policy.findAll({ where: { type: "custom", companyId: 1 ,deletedAt:null} },{paranoid:true}).then(r => [r, re])
               throw new RequestError("Something is Wrong !", 500);
           })
            .then( async([managed, custom]) => {
                if (managed || custom) {
                    for(var i=0;i<custom.length;i++){
                       await    managed.push(custom[i]);
                    }
                    return res.status(200).json({ 'data': managed });
                }
                throw new RequestError("Something is Wrong !", 500);
            }).catch(err => {
                next(err);
            });
        },



    /* API:list of Action-----------------------------------------------------------------
      Author: Ashish-------------------------------------------------------------------*/


    /* API:Add Policy------------------------------------------------------------------
      Author: Ashish-------------------------------------------------------------------*/

    async addPolicy(req, res) {
        var policy = req.body.policyName;
        var description = req.body.description;
        var action = req.body.action;
        db.Policy.create({ name: policy, type: "custom", description: description , companyId:req.user.companyId })
            .then(r => {
                if (r) {
                    var data = [];
                    for (var i = 0; i < action.length; i++) {
                        data.push({
                            actionId: action[i],
                            policyId: r.id
                        })
                    }
                    return db.PolicyAction.bulkCreate(data);
                }
                throw new RequestError("Server Error!", 500);

            })
            .then(p => {
                if (p) {
                    return res.status(200).json({ 'status': "true" });
                }
                    throw new RequestError("Server Error !", 500);
              
            })
            .catch(err => {
                next(err);
            });

    },

    /* API:Show Policy By PolicyID-----------------------------------------------------------------
      Author: Ashish---------------this needs to fixed -shivam \----------------------------------------------------*/

    async showPolicy(req, res, next) {
        
        db.Policy.findOne({
           where: { id: req.params.policyId ,type:"managed"} 
        })
        .then(policies => {
                return db.Policy.findOne({where : {  id: req.params.policyId ,companyId : req.user.companyId }}).then(r=>[r,policies])
            
        })
        .then(([managed,custom])=>{
            if(managed ){
                return  res.status(200).json({ policy: managed });

            }
            else if(custom){
                return  res.status(200).json({ policy: custom });
            }
            throw new RequestError("Server error !",500);
        })
        .catch(err => {
            next(err);
        });
    },

    /* API:Update Policy -----------------------------------------------------------------
      Author: Ashish-------------------------------------------------------------------*/

    async updatePolicy(req, res) {
        var policy = req.body.policyName;
        var {action , description} =req.body;
        var policyId = req.body.policyId;
        return db.Policy.update({ name: policy,description: description }, { where: { id: policyId ,type:"custom", companyId:req.user.companyId} })
            .then(r => {
                if (r) {
                    return db.Action.findAll({ where: { id: action } })
                } 
                    throw new RequestError("Unauthorized !",401);
                
            })
            .then(dis => {
                if (dis){
                    return db.PolicyAction.destroy({ where: { policyId: policyId } }).then(r => [r, dis])
                }
                throw new RequestError("Server error !");
            })
            .then(([r, list]) => {0
                var policyActionMap = [];
                for (var i = 0; i < list.length; i++) {
                    policyActionMap.push({
                        actionId: list[i].id,
                        policyId: policyId
                    })
                }
                return db.PolicyAction.bulkCreate(policyActionMap);
            })

            .then(p => {
                if (p) {
                    return res.status(200).json({ 'status': "true" });
                } else {
                    throw new RequestError("Something is Wrong !", 500);
                }
            })
            .catch(err => {
                next(err)
            });


    },
    /*API:Delete Policy---------------------------------------------------------------
Author:Ashish---------------------------------------------------------------------*/

    async policyDelete(req, res, next) {
        var date = new Date();
        return db.Policy.findOne({ where: { id: req.params.policyId } })
            .then(re => {
                if (re.type == 'custom') {
                   return db.Policy.destroy({ where: { id: req.params.policyId, type: "custom" } })
                }
                else {
                    throw new RequestError("You Have been Denied Delete Permisssion Manage Type", 500);
                }
            })
            .then(policy => {
                return db.UserPolicy.findAll({ where: { policyId: req.params.policyId , type : 'employee' } }) 
               
            })
            .then(list => {
                return list.reduce((p, data) => {
                    return db.UserPolicy.destroy( { where: { id: data.id } })
                }, Promise.resolve())
             })

            .then(del => {
                return res.status(200).json({ 'status': "Sucessfully Delete" });  
            })
            .catch(err => {
                next(err)
            });
    },
     /*API:Delete Policy count---------------------------------------------------------------
Author:Ashish---------------------------------------------------------------------*/
    async policyUserCount(req, res, next) {
        db.UserPolicy.count({
            attributes: [db.Sequelize.literal('COUNT(DISTINCT(UserId))'), 'UserId'],
            where: { policyId: req.params.policyId, type: 'employee' }
        })
            .then(re => {
                return res.status(200).json({ 'count': re });
            })
            .catch(err => {
                next(err)
            });
    },
    async addUserRoles(req, res, next) {
        db.User.findOne({
            where: { email: req.body.email, companyId: req.user.companyId }
        })
        .then(user => {
            if(!user){
                return db.User.create({ firstName: req.body.firstName, lastName:(req.body.lastName ? req.body.lastName : null), email: req.body.email, companyId: req.user.companyId })
            }else throw new RequestError("Email already exists!");
        })
        .then(user => {
            return db.MetaAuth.findOne({ where : { email: req.body.email } }).then(r =>[r, user.id])
        })
        .then(([methauth, userId]) => {
            if(methauth)
                return db.MetaAuth.update({ userId:userId }, { where : { id: methauth.id } }).then(r =>[r, userId])
            else return db.MetaAuth.create({ email : req.body.email, userId : userId, valid: 1, isNewUser : 1 }).then(r =>[r, userId])
        })
        .then(metaauth=> {
            mailer.mailSendToAppsumoUserRoles(req.body, req.user.User);
            return res.status(200).json({ success: true });
        })
        .catch(err => {
            next(err)
        });
    },

    async userRoleList(req, res,next) {
        db.User.findAll({ where: { companyId:req.user.companyId } })
        .then(re => {
            if(re) return res.status(200).json({ 'data': re });
            else throw new RequestError("Something is Wrong!");
        })
        .catch(err => {
            next(err);
        });
    },

    async userRoleCount(req, res,next) {
        db.UserPackage.findOne({ where:{ companyId:req.user.companyId, name: 'users' } })
        .then(userpack => {
            return db.AppsumoPlan.findOne({ where: { users: userpack.value } })
        })
        .then(appsumoplan => {
            return db.User.findAll({ where: { companyId:req.user.companyId } }).then(r => [r, appsumoplan])
        })
        .then(([re, appsumoplan]) => {
            if(re) return res.status(200).json({code:appsumoplan.code, users:re.length });
            else throw new RequestError("Something is Wrong!");
        })
        .catch(err => {
            next(err);
        });
    },
};

/* API:End OF Function -----------------------------------------------------------------
  Author: Ashish-------------------------------------------------------------------*/