import { db } from '../../../models';
var pdf = require('html-pdf');
import path from 'path';
const fs = require('fs');
import templateFile from '../../../krademy/template';

function makeid() {
    var result = '', characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789', charactersLength = 62;
    for ( var i = 0; i < 10; i++ ) { result += characters.charAt(Math.floor(Math.random() * charactersLength)) }
    return result;
}

function secondsToHms(d) {
    d = Number(d);
    var h = Math.floor(d / 3600);
    var m = Math.floor(d % 3600 / 60);
    var s = Math.floor(d % 3600 % 60);

    var hDisplay = h > 0 ? h + (h == 1 ? " hr " : " hrs ") : "";
    var mDisplay = m > 0 ? m + (m == 1 ? " min " : " mins ") : "";
    var sDisplay = s > 0 ? s + (s == 1 ? " sec" : " secs") : "";
    return hDisplay + mDisplay + sDisplay; 
}

function getTime(seconds){
var h = parseInt(seconds)/60
}

var clientTemplateCheck = function(companyId){
    return db.Company.findOne({ where:{ id:companyId } })
    .then(company => {
        var data = {};
            if(company.name && company.logo){
                data = { name: company.name, logo: company.logo }
                return data;
            }else return data;          
    })
}

export default {
    async index(req, res, next) {

        let limit = 10;
        let offset = 0;
        let page = 1;
        let search = '%%';
        if (req.query.search) {
            search = '%' + req.query.search + '%';
        }
        if(req.query.limit != undefined){
            limit = parseInt(req.query.limit);
        }
        if (req.query.page) {
            page = req.query.page;
            if (page < 1)
                page = 1;
        }
        if (req.query.sort) {
            if (req.query.sort == 'name') {
                sort = ['name'];
            }
        }
        var condition = { name: { like: search } };
        let sort = ['createdAt', 'DESC'];
        db.MemberCourse.count({ where: { memberId: req.user.memberId }, include: [{model: db.Member, required:true, attributes: ['id']}, { model: db. Session, required:true}, { model: db.Course, required:true, where: condition }] })
        .then(count=>{
            let pages = Math.ceil(count / limit);
            offset = limit * (page - 1);
            db.MemberCourse.findAll({ 
                where: { memberId: req.user.memberId }, 
                attributes: ['id', 'sessionId', 'courseId', 'createdAt', 'percent'],
                include: [
                    { model: db. Session, required:true, attributes: ['sessionKey'] }, 
                    { model: db.Course, required:true, where: condition, attributes: ['name', 'logo', 'status', 'courseType','instructorDetail'] }
                ],
                limit: limit,
                offset: offset,
                order: [sort]
            })
            .then(course => {
                return res.status(200).json({ 'courses': course, 'count': count, 'pages': pages });
            }).catch(err=>{
                console.log("TCL: index -> err", err)
                    next(err);
                })
        })
        .catch(err=>{
        console.log("TCL: index -> err", err)
            next(err);
        })
    },
    async onGoingCourses(req, res, next) {
        db.MemberCourse.findAll({
            where: { memberId: req.user.memberId},
            attributes: ['id', 'sessionId', 'courseId', 'createdAt','percent'],
            order: [ ['id', 'DESC'] ],
            include: [
                { model : db.Session, required : true, attributes: ['sessionKey'] },
                { model: db.Course, required:true, attributes: ['name', 'logo', 'status', 'courseType'] }
            ],
        })
        .then(memberCourse => {
            return res.status(200).json({ 'membercourses': memberCourse });
        })
        .catch(err=>{
            console.log("TCL: index -> err", err)
                next(err);
        })
    },
    async downloadCertificate(req, res, next){
        try{
            var date = new Date();
            var year = date.getFullYear();
            var templateData = '';
            db.MemberCourse.findOne({where :{id : req.query.memberCourseId}})
            .then(mcourse => {
                if(mcourse){
                    var certificateNo = 'KRA/'+year+'/'+mcourse.id+makeid();
                    if(mcourse.isDownloaded == 0)
                        return db.MemberCourse.update({ 'certificateNo' : certificateNo, 'issuedDate' : date.getFullYear()+'-'+(date.getMonth()+1)+'-'+date.getDate(),'isDownloaded' :1},{where : {id : req.query.memberCourseId}, returning: true})
                    else return mcourse;
                }else throw new RequestError("Invalid Member Course");
            })
            .then(mCourse => {
                return db.MemberCourse.findOne({where : {id : req.query.memberCourseId},
                    include : [{model : db.Course,attributes : ['name', 'companyId']},{model : db.Quiz,attributes : ['name', 'companyId']},
                    {model : db.Member, required : true,attributes : ['firstName','lastName']}]        
                    })
            })
            .then(membercourse => {
                var type = 'certificate';
                if(membercourse.quizId)
                    type = 'assessment_certificate';
                return db.Templates.findOne({where: {type : type}}).then(template =>[template,membercourse])
            })
            .then(([template,membercourse]) => {
                if(membercourse.quizId)
                    return clientTemplateCheck(membercourse.Quiz.companyId).then(r =>[r, template,membercourse])
                else return clientTemplateCheck(membercourse.Course.companyId).then(r =>[r, template,membercourse])
            })
            .then(([company, template,membercourse]) => {
                if(membercourse.quizId)
                    templateData = templateFile.assessmentCertificateTemplateHtml(template, membercourse, company);
                else templateData = templateFile.courseCertificateTemplateHtml(template, membercourse, company);
                return [templateData, membercourse];
            })
            .then(([templateData, membercourse]) => {
                var options = { format: 'A3', orientation: "landscape", "height": "757px", "width": "800px", "timeout": "30000" };
                if(membercourse.fileName){
                    var destination = path.join(appRoot, 'public', 'pdf', membercourse.fileName);
                    if(fs.existsSync(destination))
                        return res.status(200).json({ 'success': true, fileName: membercourse.fileName });
                    else {
                        pdf.create(templateData, options).toFile(path.join(appRoot, 'public', 'pdf', membercourse.fileName), function(err, respons){
                            if(respons) return  res.status(200).json({ 'success': true, fileName: membercourse.fileName });
                            else return res.status(500).json({ 'errors': ['Error downloading certificate.'] });
                        });
                    }
                }else{
                    var milis = new Date();
                    milis = milis.getTime();
                    var str = (membercourse.quizId ? membercourse.Quiz.name: membercourse.Course.name).replace('', '_');
                    db.MemberCourse.update({ 'fileName' : `${milis}_${str}_certificate.pdf` },{where : {id : req.query.memberCourseId}, returning: true}).then(r => {
                        pdf.create(templateData, options).toFile(path.join(appRoot, 'public', 'pdf', `${milis}_${str}_certificate.pdf`), function(err, respons){
                            if(respons) return  res.status(200).json({ 'success': true, fileName: `${milis}_${str}_certificate.pdf`});
                            else return res.status(500).json({ 'errors': ['Error downloading certificate.'] });
                        });
                    })
                }
            }) 
        }catch(err){
            console.log(err);
            res.status(500).json({ 'errors': ['Error downloading certificate.'] });
        }
    },

    async quiz(req, res, next) {
        let limit = 10;
        let offset = 0;
        let page = 1;
        let search = '%%';
        if (req.query.search) {
            search = '%' + req.query.search + '%';
        }
        if(req.query.limit != undefined){
            limit = parseInt(req.query.limit);
        }
        if (req.query.page) {
            page = req.query.page;
            if (page < 1)
                page = 1;
        }
        if (req.query.sort) {
            if (req.query.sort == 'name') {
                sort = ['name'];
            }
        }
        var condition = { name: { like: search } };
        let sort = ['createdAt', 'DESC'];
        db.MemberCourse.count({ where: { memberId: req.user.memberId }, include: [{model: db.Member, required:true, attributes: ['id']}, { model: db. Session, required:true}, { model: db.Quiz, required:true, where: condition }] })
        .then(count=>{
            let pages = Math.ceil(count / limit);
            offset = limit * (page - 1);
            db.MemberCourse.findAll({ 
                where: { memberId: req.user.memberId }, 
                attributes: ['id', 'sessionId', 'quizId', 'createdAt', 'percent', 'completedAt'],
                include: [
                    { model: db. Session, required:true, attributes: ['sessionKey'] }, 
                    { model: db.Quiz, required:true, where: condition, attributes: ['name', 'logo', 'status', 'totalQuestions', 'settings'], include:[{ model: db.Language, attributes: ['id', 'name'] }] }
                ],
                limit: limit,
                offset: offset,
                order: [sort]
            })
            .then(quiz => {
                return res.status(200).json({ 'quizzes': quiz, 'count': count, 'pages': pages });
            }).catch(err=>{
                console.log("TCL: index -> err", err)
                    next(err);
                })
        })
        .catch(err=>{
        console.log("TCL: index -> err", err)
            next(err);
        })
    },
    async startQuizAuthCheck(req, res, next){
        if(req.query && req.query.quizId && req.query.sessionKey){
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId:req.user.memberId}})
                else throw new RequestError('Quiz details required.!');
            })
            .then(membercourse => {
                if(membercourse)
                    return db.QuizQuestion.findOne({
                        where : {quizId : req.query.quizId},
                        attributes : ['id','quizId','title','thumbnail',[db.Sequelize.literal("(SELECT name FROM `Quizzes` WHERE `id` = "+req.query.quizId+")"),"quizname"],[db.Sequelize.literal("(SELECT settings FROM `Quizzes` WHERE `id` = "+req.query.quizId+")"),"settings"]],
                        include : [
                            { model : db.QuizQuestionOption,required : true, attributes : ['id','quizQuestionId','title']}
                            ],
                        limit : 1,
                        offset : 0,
                        order : [['id','ASC']]
                    })
                else throw new RequestError('Id not exist!');
            })
            .then(quizQuestion => {
                if(quizQuestion)
                    return db.QuizQuestion.findAll({where : {quizId : req.query.quizId},attributes : ['id']}).then(r => [r,quizQuestion])
                else throw new RequestError('Question not exist');
            })
            .then(([questioncount,quizQuestion]) => {
                if(quizQuestion)
                    return res.status(200).json({success : true, data : quizQuestion, count : questioncount});
                else throw new RequestError('Question not exist');
            })

        }else throw new RequestError('StatQuiz details required.!');

    },

    async startQuizQuestion(req, res, next){
        if(req.query && req.query.quizId  && req.query.questionId && req.query.sessionKey){     
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r => [r,session])
                else throw new RequestError('Quiz details required.!');
            })
            .then(([membercourse,session]) => {
                if(membercourse)
                    return db.QuizQuestion.findOne({
                        where : {id : req.query.questionId,quizId : req.query.quizId}
                        ,include : [{
                                model : db.QuizQuestionOption,
                                required : true,
                                attributes : ['id','quizQuestionId','title']
                            }]
                    }).then(r => [r,session])
                else throw new RequestError('Id not exist!');
            })
            .then(([quizQuestion,session]) => {
                if(quizQuestion)
                    return db.QuizSecctionTracking.findOne({where : {quizId : req.query.quizId,sessionId : session.id,quizQuestionId :req.query.questionId}}).then(r => [r,quizQuestion])
                else throw new RequestError('Question not exist');
            })
            .then(([sectionTracking,quizQuestion]) => {
                if(sectionTracking)
                    return res.status(200).json({success : true, data : quizQuestion,answered :sectionTracking.answerId});
                else
                    return res.status(200).json({success : true, data : quizQuestion,answered : 0});
            })
           }else throw new RequestError('StatQuiz details required.!');
    },

    async saveAnswer(req, res, next){
        var marks = 0;
        var isCorrect = 0;
        if(req.query && req.query.quizId && req.query.answerId  && req.query.questionId && req.query.sessionKey){  
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r => [r,session])
                else throw new RequestError('Quiz details required.!');
            })
            .then(([membercourse,session]) => {
                if(membercourse)
                    return db.QuizQuestion.findOne({
                        where : {id : req.query.questionId,quizId : req.query.quizId}
                        ,include : [{
                                model : db.QuizQuestionOption,
                                required : true,
                                where : {isCorrect : 1}                                
                            }]
                    }).then(r => [r,session])
                else throw new RequestError('Id not exist!');
            }) 
            .then(([quizQuestion,session]) => {
                if(quizQuestion)
                    return db.QuizSecctionTracking.findOne({where : {quizId :req.query.quizId,sessionId : session.id,quizQuestionId:req.query.questionId}}).then(r => [r,quizQuestion,session])
                else throw new RequestError('Question Id not exist!');
            })
            .then(([trackingCheck,quizQuestion,session]) => {
                if(parseInt(req.query.answerId) == parseInt(quizQuestion.QuizQuestionOptions[0].id)){
                    isCorrect = quizQuestion.QuizQuestionOptions[0].isCorrect
                    marks = quizQuestion.marks
                }
                if(!trackingCheck){
                      return db.QuizSecctionTracking.create({
                        quizId:req.query.quizId,
                        quizQuestionId:req.query.questionId,
                        answerId : req.query.answerId,
                        sessionId:session.id,
                        marks:marks,
                        isCorrect:isCorrect
                    })
                }else{
                    return db.QuizSecctionTracking.update({
                        answerId : req.query.answerId,
                        marks:marks,
                        isCorrect:isCorrect
                    },{where : {quizId:req.query.quizId, quizQuestionId:req.query.questionId, sessionId:session.id}}
                    ) 
                }
            }) 
            .then(create => {
                return res.status(200).json({success : true});
            })
        }else throw new RequestError('StatQuiz details required.!');
    },

    async finishTest(req, res, next){
        if(req.query && req.query.quizId && req.query.sessionKey){     
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r => [r,session])
                else throw new RequestError('Quiz details required.!');
            })
            .then(([membercourse,session]) => {
                if(membercourse)
                    return db.QuizQuestion.findAll({
                        where : {quizId : req.query.quizId}
                    }).then(r => [r,session])
                else throw new RequestError('Id not exist!');
            })
            .then(([quizQuestion,session]) => {
                if(quizQuestion)
                    return db.QuizSecctionTracking.findAll({where : {quizId : req.query.quizId,sessionId : session.id}}).then(r => [r,quizQuestion])
                else throw new RequestError('Question not exist');
            })
            .then(([sectionTracking,quizQuestion]) => {
                    return res.status(200).json({success : true, questionCount : quizQuestion.length,answeredCount : sectionTracking.length});
            })
           }else throw new RequestError('StatQuiz details required.!');

    },

    async submitTest(req, res, next){
        var date = new Date();
        var completedDate = date.getFullYear()+'-'+(date.getMonth()+1)+'-'+date.getDate();
        var timer = secondsToHms(req.query.timer);
        var percentage = 0;
        if(req.query && req.query.quizId && req.query.sessionKey){     
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r => [r,session.id])
                else throw new RequestError('Quiz details required.!');
            })
            .then(([memberCourse,sessionId]) => {
                return db.QuizSecctionTracking.findAll({where : {quizId : req.query.quizId,sessionId : sessionId,isCorrect:1}}).then(r=>[r,memberCourse,sessionId])
            })
            .then(([isCorrect,memberCourse,sessionId]) => {
                 return db.QuizQuestion.findAll({ where : {quizId : req.query.quizId} }).then(r=>[r,isCorrect,memberCourse,sessionId])
            })
            .then(([totalQues,isCorrect,membercourse,sessionId]) => {
                if(membercourse){
                    return db.QuizUserDetail.findOne({ where:{ quizId:req.query.quizId, sessionId:sessionId} }).then(r =>[r,totalQues,isCorrect,sessionId])
                }else throw new RequestError('Not Exist!');
            })
            .then(([quizUser,totalQues,isCorrect,sessionId]) =>{
                percentage = Math.round(isCorrect.length/totalQues.length*100);
                if(quizUser){
                    return db.QuizUserDetail.update({attempts: (quizUser.attempts + 1),percent:percentage, maxMarks: (totalQues.length * 5), obtainedMarks: (isCorrect.length * 5)},{ where:{ id:quizUser.id }}).then(r => [r, percentage]);
                }else {
                    var data = { 
                        quizId: req.query.quizId,
                        sessionId: sessionId,
                        attempts: 1,
                        percent: percentage,
                        maxMarks: (totalQues.length * 5),
                        obtainedMarks: (isCorrect.length * 5)
                    }
                    return db.QuizUserDetail.create(data).then(r => [r, percentage]);
                }
            })
            .then(([r, percentage]) => {
                if(r)
                    return db.MemberCourse.update({percent : percentage,quizTimer : timer,completedAt : completedDate},{where : {quizId : req.query.quizId, memberId: req.user.memberId}})
                else throw new RequestError('Not Exist!');
            })
            .then(membercourse => {
                if(membercourse)
                    return res.status(200).json({success : true});
                 else throw new RequestError('Something Went Wrong !');

            })
           }else throw new RequestError('StatQuiz details required.!');

    },

    async resetQuiz(req, res, next){
        if(req.query && req.query.quizId && req.query.sessionKey){     
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r => [r,session])
                else throw new RequestError('Quiz details required.!');
            })
            .then(([memberCourse,session]) => {
                return db.QuizSecctionTracking.destroy({where : {quizId : req.query.quizId,sessionId : session.id}}).then(r=>[r,memberCourse,session.id])
            })
            .then(([deleted,memberCourse,sessionId]) => {
                return db.QuizUserDetail.update({ percent:0, maxMarks:0, obtainedMarks:0},{ where : {quizId : req.query.quizId,sessionId : sessionId } }).then(r=>[r,memberCourse])
            })
            .then(([r, memberCourse]) => {
                if(r)
                    return db.MemberCourse.update({percent : 0,quizTimer : null,completedAt : null},{where : {id: memberCourse.id}})
                else throw new RequestError('Not Exist!');
            })
            .then(membercourse => {
                if(membercourse)
                    return res.status(200).json({success : true});
                 else throw new RequestError('Something Went Wrong !');

            })
           }else throw new RequestError('StatQuiz details required.!');
    },

    async quizResult(req, res, next){
        var username = '';
        if(req.query && req.query.quizId && req.query.sessionKey){     
            db.Session.findOne({where : {sessionKey : req.query.sessionKey}})
            .then(session => {
                if(session){
                    username = session.firstName +' '+ session.lastName;
                    return db.MemberCourse.findOne({where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r => [r,session])
                }
                else throw new RequestError('Quiz details required.!');
            })
            .then(([isUpdated,session]) => {
                if(isUpdated)
                    return db.QuizQuestion.findAll({
                        where : {quizId : req.query.quizId}
                    }).then(r => [r,session])
                else throw new RequestError('Failed to update!');
            })
            .then(([quizQuestion,session]) => {
                if(quizQuestion)
                    return db.QuizSecctionTracking.findAll({where : {quizId : req.query.quizId,sessionId : session.id}}).then(r => [r,quizQuestion,session])
                else throw new RequestError('Question not exist');
            })
            .then(([sectionTracking,quizQuestion,session]) => {
                    return db.MemberCourse.findOne({attributes:['id','quizTimer','completedAt'],where : {quizId : req.query.quizId, memberId: req.user.memberId}}).then(r=>[r,sectionTracking,quizQuestion,session])
            })
            .then(([memberCourse,sectionTracking,quizQuestion,session]) => {
                return db.Quiz.findOne({attributes:['id', 'settings'],where : {id : req.query.quizId} }).then(r=>[r,memberCourse,sectionTracking,quizQuestion,session])
            })
            .then(([quiz,memberCourse,sectionTracking,quizQuestion,session]) => {
                return db.QuizSecctionTracking.findAll({where : {quizId : req.query.quizId,sessionId : session.id,isCorrect:1}}).then(r=>[r,quiz,memberCourse,sectionTracking,quizQuestion])
            })
            .then(([isCorrect,quiz,memberCourse,sectionTracking,quizQuestion]) => {
                return res.status(200).json({success : true,isCorrect:isCorrect.length,questionCount : quizQuestion.length,answeredCount : sectionTracking.length,memberCourse : memberCourse,username:username,quiz:quiz});
            })
           }else throw new RequestError('StatQuiz details required.!');

    },

    async courseQuizResult(req, res , next){
        var lId = decrypt(req.query.lId);
        if(req.query.ac == 'Y291cnNl5'){
        db.Session.findOne({ where: { sessionKey: req.query.sKey} })
        .then(session => {
            if(session){
                return db.CourseSectionLecture.findOne({ where: {id: lId, type:'quiz' }, required:true, include:[{model:db.CourseSection, required:true, include:[{model:db.Course, where:{companyId: session.companyId }, required:true }] }] }).then(r => [r, session])
            }else  throw new RequestError('Invalid learner receiveds.!');
        })
        .then(([lecture, session]) =>{
            if(lecture)
                return db.CourseSectionLecture.findOne({ attributes:['name'], where: { id:lId, type:'quiz' }, include:[{ model:db.CourseLectureQuestion, attributes:['courseSectionLectureId', 'courseQuizQuestionId'], include:[{ model:db.CourseQuizQuestion, attributes:['id', 'title', 'marks'], include:[{ model:db.CourseQuizQuestionOption, attributes:['courseQuizQuestionId', 'title'], include:[{ model:db.CourseUserQuizAnswer, required:false, attributes:['marks', 'isCorrect'], where:{ sessionId: session.id } }] }] }] }, { model: db.CourseUserQuizDetail, attributes:['percent', 'maxMarks', 'obtainedMarks', 'updatedAt'], where: { sessionId: session.id} }] })
            else  throw new RequestError('Invalid data received.!');
        })
        .then(CourseSectiondata => {
            if(CourseSectiondata)
                return res.status(200).json({success : true, result: CourseSectiondata});
            else
                throw new RequestError("Error fetching questions");
        })
        .catch(err => {
            next(err);
        })
    }else{
        db.Session.findOne({ where: { sessionKey: req.query.sKey} })
        .then(session => {
            if(session){
                return db.QuizQuestion.findOne({ where: {quizId: lId }, required:true, include:[{model:db.QuizQuestionOption, required:true, include:[{model:db.QuizSecctionTracking, where:{quizId: lId }, required:false }] }] }).then(r => [r, session])
            }else  throw new RequestError('Invalid learner receiveds.!');     
        })
        .then(([assessment, session]) =>{
            if(assessment){
                return db.Quiz.findOne({attributes:['name'], where: { id:lId }, include:[{model:db.QuizQuestion,attributes:['id','title'],include:[{model:db.QuizQuestionOption,attributes:['id','title','isCorrect'],include:[{model:db.QuizSecctionTracking, required:false, attributes:['marks', 'isCorrect'], where:{ sessionId: session.id }}]
            }]
        },{model:db.QuizUserDetail, required:false, attributes:['percent', 'maxMarks', 'obtainedMarks', 'updatedAt'], where: { sessionId: session.id}}]
    })
            } else  throw new RequestError('Invalid data received.!'); 
        })
        .then(assessmentresultdata => { 
            if(assessmentresultdata)
                return res.status(200).json({success : true, result: assessmentresultdata});
            else 
                throw new RequestError("Error fetching questions");
        })
        .catch(err => {
            next(err);
        })
    } 
    },
}