import express from 'express';
import { jwtStrategy } from '../../../middleware/strategy';
import simulationController from './simulation.controller';
import { sanitize } from '../../../middleware/sanitizer';
import { userPermission } from '../../../middleware/userPermission';

export const simulationRouter = express.Router();
const rateLimit = require("express-rate-limit");
const apiLimiter = rateLimit({
    windowMs: 1 * 60 * 1000, // 15 minutes
    max: 10, 
    message: "Too many accounts created from this IP, please try again after an hour"
  });
simulationRouter.route('/').post(sanitize(), apiLimiter,/* validateBody(schemas.simulationOneSchema), */  jwtStrategy,  userPermission('campaign-write'), simulationController.createSimulation);
simulationRouter.route('/:campaignId').post(sanitize(),apiLimiter, jwtStrategy, userPermission('campaign-write'),simulationController.saveSettings);
simulationRouter.route('/').get(sanitize(), simulationController.dailyCron);