import request from 'request';
import config from '../config';
import data from '../../package.json';
var parser = require('xml-js');


export default {
    createMeeting: async (parameters) => {
        return new Promise((resolve, reject) => {
            request.get({
                url: config.bigblue.url + '/api/create?'+parameters,
                method: 'GET',
                headers: { 'User-Agent': config.app.name+'/'+data.version }
            },
            function (error, response, body){
                body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
                if (!error && response.statusCode == 200) resolve(body);
                else  reject({ 'body': body?body.RestException:null });
            });
        })
    },

    joinMeetingModerator: async (parameters) => {
        return config.bigblue.url + '/api/join?'+parameters;
        // return new Promise((resolve, reject) => {
        //     request.get({
        //         url: config.bigblue.url + '/api/join?'+parameters,
        //         method: 'GET',
        //         headers: { 'User-Agent': config.app.name+'/'+data.version }
        //     },
        //     function (error, response, body){
        //         console.log(body);
        //         body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
        //         if (!error && response.statusCode == 200) resolve(body);
        //         else  reject({ 'body': body?body.RestException:null });
        //     });
        // })
    },

    joinMeetingUser: async (parameters) => {
        return config.bigblue.url + '/api/join?'+parameters;
        // return new Promise((resolve, reject) => {
        //     request.get({
        //         url: config.bigblue.url + '/api/join?'+parameters,
        //         method: 'GET',
        //         headers: { 'User-Agent': config.app.name+'/'+data.version }
        //     },
        //     function (error, response, body){
        //         console.log(body);
        //         body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
        //         if (!error && response.statusCode == 200) resolve(body);
        //         else  reject({ 'body': body?body.RestException:null });
        //     });
        // })
    },

    isRunning: async (parameters) => {
        return new Promise((resolve, reject) => {
            request.get({
                url: config.bigblue.url + '/api/isMeetingRunning?'+parameters,
                method: 'GET',
                headers: { 'User-Agent': config.app.name+'/'+data.version }
            },
            function (error, response, body){
                body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
                if (!error && response.statusCode == 200) resolve(body);
                else  reject({ 'body': body?body.RestException:null });
            });
        })
    },

    allMeetingInfo: async (parameters) => {
        return new Promise((resolve, reject) => {
            request.get({
                url: config.bigblue.url + '/api/getMeetingInfo?'+parameters,
                method: 'GET',
                headers: { 'User-Agent': config.app.name+'/'+data.version }
            },
            function (error, response, body){
                body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
                if (!error && response.statusCode == 200) resolve(body);
                else  reject({ 'body': body?body.RestException:null });
            });
        })
    },

    allMeetings: async (parameters) => {
        return new Promise((resolve, reject) => {
            request.get({
                url: config.bigblue.url + '/api/getMeetings?'+parameters,
                method: 'GET',
                headers: { 'User-Agent': config.app.name+'/'+data.version }
            },
            function (error, response, body){
                body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
                if (!error && response.statusCode == 200) resolve(body);
                else  reject({ 'body': body?body.RestException:null });
            });
        })
    },

    endMeeting: async (parameters) => {
        return new Promise((resolve, reject) => {
            request.get({
                url: config.bigblue.url + '/api/end?'+parameters,
                method: 'GET',
                headers: { 'User-Agent': config.app.name+'/'+data.version }
            },
            function (error, response, body){
                body = JSON.parse(parser.xml2json(body, {compact: true, spaces: 4}));
                if (!error && response.statusCode == 200) resolve(body);
                else  reject({ 'body': body?body.RestException:null });
            });
        })
    },
   
}