import { db } from '../models';
import config from '../config';
import fs from 'fs'; 
import stringifyCSV from 'csv-stringify';
import mailer from '../mailer';
import { json } from 'body-parser';
import simulation from './simulation';

var checkSessionMemberCourse = (sessions, quizzes, courses, type, coursesQuizzes) => {
    return new Promise((resolve, reject) => {
        var memberIds = [];
        var obj = new Object();
        for(var m = 0; m < sessions.length; m++)
            memberIds.push(sessions[m].memberId);
        if(type == 'course')
            var condition = { courseId: { in: courses }, memberId: { in: memberIds } };
        if(type == 'quiz')
            var condition = { quizId: { in: quizzes }, memberId: { in: memberIds } };
        db.MemberCourse.findAll({ where : condition, attributes:['memberId', 'courseId', 'quizId'] })
        .then(r => {
            var d = new Object();
            var memberIdPush = [];
            if(type == 'course'){
                for(var j = 0; j < courses.length; j++){
                    for(var i = 0;i < r.length; i++){
                        if(courses[j] == r[i].courseId)
                            memberIdPush.push(r[i].memberId);
                    }
                    d[courses[j]] = memberIdPush;
                }
            }else if(type == 'quiz'){
                for(var j = 0; j < quizzes.length; j++){
                    for(var i = 0;i < r.length; i++){
                        if(quizzes[j] == r[i].quizId)
                            memberIdPush.push(r[i].memberId);
                    }
                    d[quizzes[j]] = memberIdPush;
                }
            }
            return d;
        })
        .then(alreadyMemberId => {
            var createMemberCourse = [];
            for(var a = 0; a < sessions.length; a++){
                for(var i = 0; i < coursesQuizzes.length; i++){
                    if(Object.keys(alreadyMemberId).length > 0 && alreadyMemberId[coursesQuizzes[i].id].length > 0){
                        var checkMember = alreadyMemberId[coursesQuizzes[i].id];
                        if(!checkMember.includes(sessions[a].memberId))
                            createMemberCourse.push({ courseId: (type == 'course' ? coursesQuizzes[i].id : null), quizId: (type == 'quiz' ? coursesQuizzes[i].id : null), memberId: sessions[a].memberId, sessionId: sessions[a].id, percent: '0.00' })
                    }else
                        createMemberCourse.push({ courseId: (type == 'course' ? coursesQuizzes[i].id : null), quizId: (type == 'quiz' ? coursesQuizzes[i].id : null), memberId: sessions[a].memberId, sessionId: sessions[a].id, percent: '0.00' })
                    if(Object.keys(obj).indexOf(sessions[a].email) == -1){
                        obj[sessions[a].email] = {
                            memberId: sessions[a].memberId,
                            sessionId: sessions[a].id,
                            sessionKey: sessions[a].sessionKey,
                            firstName: sessions[a].Member.firstName,
                            lastName: sessions[a].Member.lastName,
                            email: sessions[a].Member.email,
                            subscribe: (type == 'course' ? sessions[a].Member.courseMails : sessions[a].Member.assessmentMails),
                            code:  sessions[a].Member.code,
                            type: type,
                            courseOrQuiz: [ {id: coursesQuizzes[i].id,  name: coursesQuizzes[i].name, image: coursesQuizzes[i].logo }]
                        }
                    }else{
                        var data = obj[sessions[a].email].courseOrQuiz;
                        data.push({id: coursesQuizzes[i].id, name: coursesQuizzes[i].name, image: coursesQuizzes[i].logo });
                        obj[sessions[a].email].courseOrQuiz = data;
                    }
                }
            }
            return db.MemberCourse.bulkCreate(createMemberCourse, {returning: true}).then(r => obj);
        })
        .then(obj => {
            return resolve(obj);
        })
        .catch(err =>{
            console.log(err);
            reject(err);
        })
    });
}

function createManagerCSV(mailData, items, mEmail, i, simulationId){
    return new Promise((resolve, reject) => {
        stringifyCSV(items, function (err, output) {
            if (err) reject(err);
            let fileName = Date.now()+ i;
            fs.writeFile(appRoot + '/public/managermails/' + fileName + '.csv', output, function (err) {
                if (err){ reject(err); throw err; };
                mailer.sendMailToManagerForRemainingCourseReminder(mailData, mEmail, fileName + '.csv', simulationId);
                resolve(fileName + '.csv');
            });
        })
    })
}

var counter = 0;
var membersData = (mailData, members, groups, simulationId) =>{
    if(members && members.length > 0){
        var da = {};
        for(var i = 0; i < members.length; i++){
            if(!da[members[i].groupId])
                da[members[i].groupId] = [];
            da[members[i].groupId].push(members[i]);  
        }
        var l = Object.keys(da);
        for(var z = 0; z < l.length; z++){
            var data = [];
            data.push(['firstName', 'lastName', 'email', 'percentage']);
            for(var j = 0; j < da[l[z]].length; j++){
                data.push([ 
                    da[l[z]][j].firstName,
                    da[l[z]][j].lastName,
                    da[l[z]][j].email,
                    da[l[z]][j].percentage
                ]);
            }
            createManagerCSV(mailData, data, groups[l[z]], counter++, simulationId);
        }
    }else
        mailer.sendMailToManagerForCompleteCourseReminder(mailData, groups, simulationId);
}

process.on('message', async (data) => {
    simulation.executeSimulationById(data.simulationId, data.campaignId, data.quizzes, data.courses, data.offset, data.limit, data.type, data.companyId, data.resultCount)
    .then(r => {
        process.send({ error: false})
    })
    .catch(e => {
        process.send({ error: true })
    })
});

export default {
    createSimulation: (data) => {
        var obj = {};
        // if(data.type == "quiz"){
        //     return db.Quiz.findAll({ where: { id: { in: data.quizzes} }  })
        //     .then(quizDataSetting =>{
        //         for(var i = 0; i < quizDataSetting.length; i++){
        //             var settings =JSON.parse(quizDataSetting[i].settings)
        //             settings.totalMarks =quizDataSetting[i].totalMarks;
        //             settings.totalQuestions=quizDataSetting[i].totalQuestions;
        //             obj[quizDataSetting[i].id]=settings
        //         }
        //         return db.Simulation.create({ campaignId: data.campaignId, type: data.type, settings:JSON.stringify(obj) })
        //     }) 
        // }else{
        //     // return db.Course.findAll({ where: { id: { in: data.courses } }  })
        //     // .then(quizDataSetting =>{
        //     //     for(var i = 0; i < quizDataSetting.length; i++){
        //     //         obj[quizDataSetting[i].id] = quizDataSetting[i].setting;
        //     //     }
        //         return db.Simulation.create({ campaignId: data.campaignId, type: data.type })
        //     // }) 
        // }
        return db.Simulation.create({ campaignId: data.campaignId, type: data.type })
    },

    executeSimulationById: (simulationId, campaignId, quizzes, courses, offset, limit, type, companyId, resultCount) => {
        return new Promise((resolve, reject) => {
            db.Session.findAll({
                attributes:['id', 'memberId', 'simulationId', 'firstName', 'lastName', 'email', 'sessionKey', 'status'],
                where: { simulationId: simulationId, companyId: companyId},
                include:[{ model: db.Member}],
                limit: parseInt(limit), offset: parseInt(offset),
            })
            .then(sessions => {
                if(sessions && sessions.length > 0){
                    if(courses)
                        return db.Course.findAll({ where: { id: { in: courses }, companyId: companyId}  }).then(r => [r, sessions])  
                    if(quizzes)
                        return db.Quiz.findAll({ where: { id: { in: quizzes }, companyId: companyId}  }).then(r => [r, sessions])  
                } 
            })
            .then(([all, sessions]) => {
                return checkSessionMemberCourse(sessions, quizzes, courses, type, all).then(r => [r, sessions])
            })
            .then(([mailData, sessions]) =>{
                return mailer.sendEnrollLink(mailData, simulationId, companyId, type).then(r => sessions.length)
            })
            .then(sessionCounts => {
                var tot = parseInt(offset) + parseInt(sessionCounts);
                if(tot == parseInt(resultCount))
                    db.Campaign.update({status: 'Completed' }, { where: {id: campaignId, companyId: companyId},returning : true })
                resolve(true);
            })
            .catch(err => {
                console.log(err)
                if(err && err.name && err.name == 'SequelizeDatabaseError')
                    err = { "name": "Database Error", "message": "Please contact administration" };
                err = JSON.parse(JSON.stringify(err))
                err.batchOffset = offset;
                db.Campaign.update({status: 'Error'}, { where: {id: campaignId} });
                db.CampaignError.create({
                    campaignId: simulationId,
                    error: JSON.stringify(err)
                });
                console.log(err);
                reject(err)
            });
        })
    },

    prepareManagerMailData: (data, groups, simulationId) => {
        return new Promise((resolve, reject) => {
            if(data && data.length > 0){
                for(var i = 0; i < data.length; i++){
                    var mailData = {
                       'type': data[i].type,
                       'percent': data[i].percent,
                       'scheduledAt': data[i].scheduledAt,
                       'courseName': data[i].courseName,
                    }
                    membersData(mailData, data[i].members, groups, simulationId);
                }
            }
        })
    }
}