var sanitizeObj = function(obj, ignore, req){
    if(obj != null && typeof obj === 'object'){
        for(var i=0;i<Object.keys(obj).length;i++){
            if(ignore.indexOf(Object.keys(obj)[i]) == -1)
                obj[Object.keys(obj)[i]] = sanitizeObj(obj[Object.keys(obj)[i]], ignore, req);
        }
    }else if(obj != null  && typeof obj === 'array'){
        for(var i=0;i<obj.length;i++){
            if(ignore.indexOf(obj[i]) == -1)
                obj[i] = sanitizeObj(obj[i], ignore, req);
        }
    }else if(obj != null && typeof obj == 'string' && obj != ''){
        if(ignore.indexOf(obj) == -1)
            obj = req.sanitize(obj).trim();
    }
    return obj;
}

export var sanitize = function(ignore=[]){
    return (req, res, next) => {
        var data = [];
        if(req.body){
            req.body = sanitizeObj(req.body, ignore, req);
        }
        if(req.params){
            req.params = sanitizeObj(req.params, ignore, req);
        }
        if(req.query){
            req.query = sanitizeObj(req.query, ignore, req);
        } 
        next();
    }
};
