'use strict';
module.exports = (sequelize, DataTypes) => {
  const Campaign = sequelize.define('Campaign', {
    name: DataTypes.STRING,
    url: DataTypes.STRING,
    status: DataTypes.STRING,
    memberCount: DataTypes.INTEGER,
    departmentCount: DataTypes.INTEGER,
    courseCount: DataTypes.INTEGER,
    quizCount: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER,
    isManager: DataTypes.INTEGER,
    deletedAt: DataTypes.DATE
  }, {
    timestamps: true,
    paranoid: true,
  });
  Campaign.associate = function(models) {
    models.Campaign.hasMany(models.Simulation, {foreignKey: 'campaignId'});
    models.Campaign.hasMany(models.CampaignCourse, {foreignKey: 'campaignId'});
    models.Campaign.hasMany(models.CampaignQuiz, {foreignKey: 'campaignId'});
    models.Campaign.hasMany(models.CampaignGroup, {foreignKey: 'campaignId'});
  };
  return Campaign;
};