'use strict';
module.exports = (sequelize, DataTypes) => {
  const CampaignQuiz = sequelize.define('CampaignQuiz', {
    campaignId: DataTypes.INTEGER,
    quizId: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true
  });
  CampaignQuiz.associate = function(models) {
    models.CampaignQuiz.belongsTo(models.Campaign, {foreignKey: 'campaignId'});
    models.CampaignQuiz.belongsTo(models.Quiz, {foreignKey: 'quizId'});
    models.CampaignQuiz.belongsTo(models.Simulation, {foreignKey: 'campaignId'});
    models.CampaignQuiz.hasMany(models.SimulationReminder, {foreignKey: 'campaignQuizId'});
  };
  return CampaignQuiz;
};