'use strict';
module.exports = (sequelize, DataTypes) => {
  const CourseUserQuizAnswer = sequelize.define('CourseUserQuizAnswer', {
    courseSectionLectureId: DataTypes.INTEGER,
    courseQuizQuestionId: DataTypes.INTEGER,
    courseQuizQuestionOptionId: DataTypes.INTEGER,
    sessionId: DataTypes.INTEGER,
    courseId: DataTypes.INTEGER,
    marks: DataTypes.INTEGER,
    isCorrect: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  CourseUserQuizAnswer.associate = function(models) {
    models.CourseUserQuizAnswer.belongsTo(models.CourseSectionLecture, { foreignKey: 'courseSectionLectureId'});
    models.CourseUserQuizAnswer.belongsTo(models.CourseQuizQuestion, { foreignKey: 'courseQuizQuestionId'});
    models.CourseUserQuizAnswer.belongsTo(models.CourseQuizQuestionOption, { foreignKey: 'courseQuizQuestionOptionId'});
    models.CourseUserQuizAnswer.belongsTo(models.Session, { foreignKey: 'sessionId'});
    models.CourseUserQuizAnswer.belongsTo(models.Course, { foreignKey: 'courseId'});
  };
  return CourseUserQuizAnswer;
};