'use strict';
module.exports = (sequelize, DataTypes) => {
  const Group = sequelize.define('Group', {
    name: DataTypes.STRING,
    parentId: DataTypes.INTEGER,
    userCount: DataTypes.INTEGER,
    rootId: DataTypes.INTEGER,
    companyId: DataTypes.INTEGER,
    managerId: DataTypes.INTEGER,
    status: DataTypes.ENUM('pending', 'failed', 'completed'),
    ad: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  Group.associate = function(models) {
    models.Group.belongsTo(models.Member, {foreignKey: 'managerId'});
    models.Group.hasMany(models.GroupMember, {foreignKey: 'groupId'});
    models.Group.belongsTo(models.Company, {foreignKey: 'companyId'});
    models.Group.hasMany(models.Session, {foreignKey: 'groupId'});
    models.Group.hasMany(models.CampaignGroup, {foreignKey: 'groupId'});
    models.Group.hasMany(models.GroupSkill, {foreignKey: 'groupId'});
  };
  return Group;
};