
export default (sequelize, DataTypes) => {
  const Member = sequelize.define('Member', {
    firstName: DataTypes.STRING,
    lastName: DataTypes.STRING,
    email: DataTypes.STRING,
    phone: DataTypes.STRING,
    designation: DataTypes.STRING,
    code:DataTypes.TEXT,
    courseMails:DataTypes.BOOLEAN,
    assessmentMails:DataTypes.BOOLEAN,
    reminderMails:DataTypes.BOOLEAN,
    announcementMails:DataTypes.BOOLEAN,
  }, {
    timestamps: true,
    paranoid: true,
  });

  Member.associate = function (models) {
    models.Member.hasMany(models.Group, { foreignKey: 'managerId' });
    models.Member.hasMany(models.GroupMember, { foreignKey: 'memberId' });
    models.Member.hasMany(models.Session, { foreignKey: 'memberId' });
    models.Member.hasMany(models.UserPolicy, { foreignKey: 'userId' });
    models.Member.hasMany(models.MemberCourse, { foreignKey: 'memberId' });
    models.Member.hasMany(models.MetaAuth, {foreignKey: 'memberId'});

  };

  return Member;
};