'use strict';
module.exports = (sequelize, DataTypes) => {
  const Quiz = sequelize.define('Quiz', {
    name: DataTypes.STRING,
    logo: DataTypes.STRING,
    description:  DataTypes.STRING,
    totalMarks: DataTypes.INTEGER,
    languageId: DataTypes.INTEGER,
    totalQuestions: DataTypes.INTEGER,
    status: DataTypes.STRING,
    companyId: DataTypes.INTEGER,
    settings: DataTypes.STRING
  }, {
    timestamps: true,
    paranoid: true,
  });
  Quiz.associate = function(models) {
    models.Quiz.hasMany( models.MemberCourse ,{ forigenKey: 'quizId' });
    models.Quiz.hasMany( models.QuizSecctionTracking ,{ forigenKey: 'quizId' });
    models.Quiz.hasMany(models.CampaignQuiz, { foreignKey: 'quizId'});
    models.Quiz.belongsTo(models.Language, { foreignKey: 'languageId'});
    models.Quiz.hasMany(models.QuizQuestion, { foreignKey: 'quizId'});
    models.Quiz.hasMany(models.QuizUserDetail, { foreignKey: 'quizId'});
    models.Quiz.belongsTo(models.Company, { foreignKey: 'companyId'});
    models.Quiz.hasMany(models.AssessmentSkill, { foreignKey: 'quizId'});
  };
  return Quiz;
};