'use strict';
module.exports = (sequelize, DataTypes) => {
  const QuizSecctionTracking = sequelize.define('QuizSecctionTracking', {
    quizId: DataTypes.INTEGER,
    quizQuestionId: DataTypes.INTEGER,
    answerId: DataTypes.INTEGER,
    sessionId: DataTypes.INTEGER,
    marks: DataTypes.INTEGER,
    isCorrect: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  QuizSecctionTracking.associate = function(models) {
    models.QuizSecctionTracking.belongsTo(models.Quiz, { foreignKey: 'quizId'});
    models.QuizSecctionTracking.belongsTo(models.QuizQuestion, { foreignKey: 'quizQuestionId'});
    models.QuizSecctionTracking.belongsTo(models.QuizQuestionOption, { foreignKey: 'answerId'});
    models.QuizSecctionTracking.belongsTo(models.Session, { foreignKey: 'sessionId'});
  };
  return QuizSecctionTracking;
};