'use strict';
module.exports = (sequelize, DataTypes) => {
  const SessionCourseLectureTracking = sequelize.define('SessionCourseLectureTracking', {
    sessionId: DataTypes.INTEGER,
    courseSectionLectureId: DataTypes.INTEGER,
    duration: DataTypes.INTEGER,
    percent: DataTypes.INTEGER
  }, {
    timestamps: true,
    paranoid: true,
  });
  SessionCourseLectureTracking.associate = function(models) {
    // associations can be defined here
    models.SessionCourseLectureTracking.belongsTo(models.CourseSectionLecture , { foreignKey: 'courseSectionLectureId'});
    models.SessionCourseLectureTracking.belongsTo(models.Session , { foreignKey: 'sessionId'});
  };
  return SessionCourseLectureTracking;
};