'use strict';
module.exports = (sequelize, DataTypes) => {
  const SimulationReminder = sequelize.define('SimulationReminder', {
    simulationId: DataTypes.INTEGER,
    campaignCourseId: DataTypes.INTEGER,
    campaignQuizId: DataTypes.INTEGER,
    type: DataTypes.STRING,
    percent: DataTypes.INTEGER,
    scheduledAt: DataTypes.STRING,
    executedAt: DataTypes.DATE
  }, {
    timestamps: true,
    paranoid: true
  });
  SimulationReminder.associate = function(models) {
    models.SimulationReminder.belongsTo(models.CampaignCourse, {foreignKey: 'campaignCourseId'});
    models.SimulationReminder.belongsTo(models.Simulation, {foreignKey: 'simulationId'});
    models.SimulationReminder.belongsTo(models.CampaignQuiz, {foreignKey: 'campaignQuizId'});
  };
  return SimulationReminder;
};