'use strict';
module.exports = (sequelize, DataTypes) => {
  const userPolicy = sequelize.define('UserPolicy', {
    policyId: DataTypes.INTEGER,
    memberId: DataTypes.INTEGER,
    userId: DataTypes.INTEGER,
    type: DataTypes.STRING,
    deletedAt: DataTypes.DATE
  }, {});
  userPolicy.associate = function(models) {
    models.UserPolicy.belongsTo(models.Policy, { foreignKey: 'policyId' });
    models.UserPolicy.belongsTo(models.Employee, { foreignKey: 'userId' });
    models.UserPolicy.belongsTo(models.Member, { foreignKey: 'memberId' });
  };
  return userPolicy;
};