var searchQuery = null;
var sortBy = 'recent';
var fromDate = null, toDate = null;
var lastApi = null;
var count = 0;
var select = true;
var campaignStatus = null;
var statuses = {
    'In Progress': {
        color: '#007bff'
    },
    'Completed': {
        color: '#118e09'
    },
    'Error': {
        color: '#e02525'
    },
    'Scheduled': {
        color: '#FFC300'
    },
}



var validate = function(){    
    clearErrors();
    var data = new Object();
    data.search = $('#searchBar').val();
    if(data.search.length < 3){
        data.search = undefined;
    }
    data.sort = sortBy;
    if(campaignStatus) data.status = campaignStatus;
    data.page = getPageNo();
    if(fromDate != null && toDate != null){
        data.fromDate = fromDate;
        data.toDate = toDate;
    }
    data.limit = getLimit();
    hasError() && showErrors();
    return data;
}

var statusFilter = function(status)  {
    campaignStatus = status;
    load();
}

var sort = function(type){
    sortBy = type;
    load();
}

var clearCampaign = function(){
    $('#campaign').html('');  
    $('#pagecount').html('');  
    $('#pagination').html('');  
    $('#gotopage').html('');
}

var deleteItem = function(itemId){
    swal({
        title: "Warning!",
        type: "warning",
        text: "Are you sure",
        showCancelButton: true,
    })
    .then(function(){
        api.campaignId.delete(itemId, undefined, function(success) {
            load();
        })
    })
    
}

var addCampaign = function (detail) {
    if (detail.name) {
        var progressBar = '<td class="text-center"> <div style="color:white; color:' + statuses[detail.status]['color'] + '">' + detail.status + '</div>  </td>';
        var name = detail.name;
        var departmentCount = detail.departmentCount;
        var memberCount = detail.memberCount;
        var courseCount = detail.courseCount;
        var createdAt = new Date(detail.createdAt).toString('dS MMM yyyy h:mm tt').substr(0,25);
        $('#campaign').append('<tr data-href="/campaign/'+detail.id+'"> <td style="width: 80px;"><img src="/static/assets/images/img/campaign-icon.png"></td> <td> <a href="/campaign/'+detail.id+'"><h5>' + name + '</h5><p> ' + createdAt + '</p></a> </td> <td > <i class="feather icon-users"></i> <h5> <span>' + (memberCount ? memberCount : 0) + '</span> Users</h5> </td> <td> <i class="feather icon-package"></i> <h5> <span>' + departmentCount + '</span> Departments</h5> </td> ' + progressBar + '<td> <div class="btn-group mr-2"> <div class="dropdown"> <button class="btn btn-link" type="button" id="CustomdropdownMenuButton8" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i class="feather icon-more-horizontal-"></i></button> <div class="dropdown-menu" aria-labelledby="CustomdropdownMenuButton8" x-placement="bottom-start"> <a class="dropdown-item" href="/campaign/'+detail.id+'"><i class="feather icon-eye mr-2"></i>View</a> <a class="dropdown-item" href="#" onClick="deleteItem('+detail.id+')"><i class="feather icon-trash-2 mr-2"></i>Delete</a> </div> </div> </div> </td> <td> <div class="custom-control custom-checkbox"> <input type="checkbox" class="custom-control-input" id="campaign-'+ ++count +'" value="'+detail.id+'"> <label class="custom-control-label" for="campaign-'+ count +'"></label> </div> </td> </tr>');
    }
}

var load = function() {
    var data = validate();
    !hasError(); 
    if(lastApi){
        lastApi.abort();
        lastApi = null;
    }
    lastApi = api.campaign.list(data, function(success) {
        clearCampaign();
        if(success && success.campaigns.length > 0){
            count = 0; select = true;
            success.campaigns.forEach(function(campaign)  {
                addCampaign(campaign);
            });
            lastApi = null;
        }else $('#campaign').html('<tr><td colspan="2">No Campaign Added</td></tr>');
        if(success.pages && success.count)
            addPagination(success.pages, success.count);
    }, function(error) {})
}

var reloadList = function() {
    load();
}

var searchQuery = function() {
    setPage(1);
    load();
}

var openPage = function(id) {
	window.open('/campaigns/'+id, '_blank');
}

var dateFilterInit = function(){
    var currentDate = new Date();
    var prevDate = new Date();
    prevDate.setMonth(prevDate.getMonth() - 3);
    fromDate = prevDate.toString('yyyy/MM/dd');
    toDate = currentDate.toString('yyyy/MM/dd');
    $('input[name="date-range"]').daterangepicker({
        opens: 'left',
        startDate: prevDate,
        endDate: currentDate 
    }, function(start, end, label) {
        fromDate = start.format('YYYY/MM/DD');
        toDate = end.format('YYYY/MM/DD');
        load();
    });
}

var paginationData = function(count) {
    setLimit(count);
    setPage(1);
    load();
}

var deleteCampaign = function() {
    var data = [];
    for(var i=1; i<=count; i++){
        if($('#campaign-'+i).is(":checked")){
            data.push($('#campaign-'+i).val());
        }
    }
    if(data && data.length > 0){
        swal({
            title: "Warning!",
            type: "warning",
            text: "Are you sure you want to delete all campaigns",
            showCancelButton: true,
            // closeOnConfirm: true,
        })
        .then(function(input)  {
            if(input){
               
                if(data && data.length > 0){
                    api.campaign.delete(data, function(success) {
                        // setPage(1);
                        load();
                    })
                } else {
                    addError(null, 'Select atleat 1 campaign');
                    showErrors();
                }
            }
        })
    }else swal({
        title: "Warning!",
        type: "warning",
        text: "Campaign is not selected",
    })
}

var selectAll = function() {
    if(select){
        for(var i=1; i<=count; i++){
            $('#campaign-'+i).prop("checked", "checked");
        }
    } else {
        for(var i=1; i<=count; i++){
            $('#campaign-'+i).prop("checked", null);
        }
    } select = !select;
}

$(document).ready(function(){
    dateFilterInit();
    load();
    $(".clickable-row").click(function () {
        window.location = $(this).data("href");
    });
});