let campaignId = 0;
var filterBy = 'all';
var statuses = {
    'Pending': {
        color: '#FFA500'
    },
    'Email Sent': {
        color: '#118e09'
    },
    'Email Opened': {
        color: '#7D99FF'
    },
    'Link Clicked': {
        color: '#EEB0F5'
    },
    'Error': {
        color: '#e02525'
    },
    'Unsubscribed': {
        color: '#797980'
    },
}

function setGroups(groups){
    groups.forEach(function(group) {
        $('#group ul').append("<li>"+group.Group.name+"</li>");
    })
}

function setCourses(courses){
    courses.forEach(function(course)  {
        $('#course ul').append("<li>"+course.Course.name+"</li>");
    })
}

function setQuizzes(quizzes){
    quizzes.forEach(function(quiz)  {
        $('#course ul').append("<li>"+quiz.Quiz.name+"</li>");
    })
}

function clearSideSliderData(){
    $('#group ul').html('');
    $('#course ul').html('');
    $('#campaign-name').html('');
    $('#campaignname').html('');
    $('#url').html('');
    $('#manager').html('');
}

function setCampaignData(campaign){
    clearSideSliderData();
    setGroups(campaign.CampaignGroups);
    if(campaign.CampaignCourses.length > 0){
        setCourses(campaign.CampaignCourses);
        $("#update_name").text("Course(s)")
   }
   if(campaign.CampaignQuizzes.length > 0){
        setQuizzes(campaign.CampaignQuizzes);
        $("#update_name").text("Assessment(s)")
    }
    $('#campaign-name').html(campaign.name);
    $('#campaignname').html(campaign.name);
    var d = new Date(campaign.createdAt).toUTCString();
    var createdDate = d.split(' ').slice(0,5).join(' ');
    $('#createdDate').html(createdDate);
    $('#manager').html((campaign.isManager == 1 ? 'Yes' : 'No'));
    if(campaign.scheduledAt)
        $('#schedule').html(campaign.scheduledAt);
    else
        $('#schedule-div').hide();
}

var searchQuery = function() {
    setPage(1);
    load();
}

var reloadList = function() {
    load();
}

var download = function(content, fileName, mimeType) {
    var a = document.createElement('a');
    mimeType = mimeType || 'application/octet-stream';
  
    if (navigator.msSaveBlob) { // IE10
      navigator.msSaveBlob(new Blob([content], {
        type: mimeType
      }), fileName);
    } else if (URL && 'download' in a) { //html5 A[download]
      a.href = URL.createObjectURL(new Blob([content], {
        type: mimeType
      }));
      a.setAttribute('download', fileName);
      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
    } else {
      location.href = 'data:application/octet-stream,' + encodeURIComponent(content); // only this mime type is supported
    }
}

var setDetails = function(data) {
    var items = [];
    items.push([
        'Id',
        'Name',
        'Email',
        'Phone',
        'Position',
        'Status',
    ]);
    var count = 1;
    for(var i=0; i<data.length;i++){
        items.push([
            count++,
            (data[i].Member.firstName ? data[i].Member.firstName : '') +' '+(data[i].Member.lastName ?data[i].Member.lastName : ''),
            (data[i].Member.email ? data[i].Member.email : '-'),
           (data[i].Member.phone ?  data[i].Member.phone : '-'),
            (data[i].Member.designation ? data[i].Member.designation : '-'),
            (data[i].status ? data[i].status : '-')
        ]);
     }
    var csvContent = '';
    items.forEach(function(infoArray, index) {
        dataString = infoArray.join(',');
        csvContent += index < items.length ? dataString + '\n' : dataString;
    })
    download(csvContent, 'campaign-result.csv', 'text/csv;encoding:utf-8');
}


function exportUsers(){
    var data = {};
    data.campaignId = page.campaignId;
    data.filterBy = filterBy;
    data.type = 'CSV';
    api.campaign.result(data,function(success){
        if(success && success.memberList && success.memberList.length > 0){  
                setDetails(success.memberList);                      
        }
    })
}

function filter(type){
    filterBy = type;
    load();
}

var paginationData = function(count) {
    setLimit(count);
    setPage(1);
    load()
}

function setList(session){
    $('#members tbody').append('<tr> <th scope="row">'+session.Member.firstName+' '+(session.Member.lastName ? session.Member.lastName : '')+'</th> <td>'+session.Member.email+'</td> <td>'+(session.Member.phone ? session.Member.phone : '---')+'</td> <td>'+(session.Member.designation ? session.Member.designation : '---')+'</td> <td><h5 style="color:'+statuses[session.status].color+'">'+session.status+'</h5></td> </tr>')
}

function threeCount(total, data){
    if(data[2] > 0){
        $('#resolve_error').show();
    }else{
        $('#resolve_error').hide();
    }
    $('#apex-pie-chart').html('');
    var options = {
        chart: {
            type: 'donut',
            width: 290,
            
        },
        plotOptions: {
            pie: {
              donut: {
                size: '70%',
              
                background: 'transparent',
                labels: {
                enabled: false,
                  show: true,
                  total: {
                    show: true,
                    label: 'Total',
                    fontSize: 50,
                    color: 'rgb(43, 87, 130)',
                    formatter: function (w) {
                        return total
                    }
                  }
                }
              },       
            }
          },
     
        colors: ['#FFA500','#18d26b','#ff0000', '#797980'],
        series: data,
        labels: ['Pending', 'Email Sent', 'Error', 'Unsubscribed'],
        legend: {
            show: true,
            position: 'bottom'
        },
    }
    var chart = new ApexCharts(
        document.querySelector("#apex-pie-chart"),
        options
    );        
    chart.render();
}

function openClickCircleCount(total, open, click){
    var maxopen = Math.round(220* (1- ((open*100)/total)/100))
    var maxclick = Math.round(220* (1- ((click*100)/total)/100))
    $('#email-opened').attr('data-progress', open);
    $('#email-opened-value').text(open);
    $('#email-opened-fill').css({"stroke-dashoffset" : "-"+maxopen});
    $('#link-clicked').attr('data-progress', click);
    $('#link-clicked-value').text(click);
    $('#link-clicked-fill').css({"stroke-dashoffset" : "-"+maxclick});
}

function circleCount(data){
    api.campaign.resultCount(data,function(success){
        let data = [];
        if(success && success.success && success.data){
            if(success.data.hasOwnProperty('Error')){
                $('#error_occured').html(success.data.Error);
            }
            if(success.data.hasOwnProperty('Total')){
                $('#Total_occured').html(success.data.Total);
            }
            let total = (success.data && success.data['Total'] ? success.data['Total'] : 0 );
            data.push((success.data && success.data['Pending'] ? (filterBy == 'all' ? success.data['Pending'] : ( filterBy == 'Pending' ? success.data['Pending'] : 0 ) ) : 0 ));
            data.push((success.data && success.data['Email Sent'] ? (filterBy == 'all' ? success.data['Email Sent'] : ( filterBy == 'Email Sent' ? success.data['Email Sent'] : 0 ) ) : 0 ));
            data.push((success.data && success.data['Error'] ? (filterBy == 'all' ? success.data['Error'] : ( filterBy == 'Error' ? success.data['Error'] : 0 ) ) : 0 ));
            data.push((success.data && success.data['Unsubscribed'] ? (filterBy == 'all' ? success.data['Unsubscribed'] : ( filterBy == 'Unsubscribed' ? success.data['Unsubscribed'] : 0 ) ) : 0 ));
            threeCount(total, data);
            openClickCircleCount(total, (success.data && success.data['Email Opened'] ? success.data['Email Opened'] : 0 ), (success.data && success.data['Link Clicked'] ? success.data['Link Clicked'] : 0 ));
        }
    })
}

var saveReminder = function(id, campaignType){
    clearErrors()
    var data = new Object(), arr = [];
    data.id = id;
    data.campaignType = campaignType;
    var currentDate = differentDateFormat(5);

    if($('#mile-1-'+id).val().length > 0){
        if(new Date(yearMonthDate($('#mile-1-'+id).val())) <=  new Date(currentDate)){
            if(!parseInt($('#mile-1-'+id).attr('executed')))
                addError('mile-1-'+id, 'Enter a coming date for reminder 1');
        }else arr.push({ scheduledAt: addedHis($('#mile-1-'+id).val()), percent: $('#mile-per-1-'+id).val(), type: 'r1' });
    }

    if($('#mile-2-'+id).val().length > 0){
        if(new Date(yearMonthDate($('#mile-2-'+id).val())) <=  new Date(currentDate)){
            if(!parseInt($('#mile-2-'+id).attr('executed')))
                addError('mile-2-'+id, 'Enter a coming date for reminder 2');
        }else arr.push({ scheduledAt: addedHis($('#mile-2-'+id).val()), percent: $('#mile-per-2-'+id).val(), type: 'r2' });
    }

    if($('#mile-3-'+id).val().length > 0){
        if(new Date(yearMonthDate($('#mile-3-'+id).val())) <=  new Date(currentDate)){
            if(!parseInt($('#mile-3-'+id).attr('executed')))
                addError('mile-3-'+id, 'Enter a coming date for reminder 3');
        }else arr.push({ scheduledAt: addedHis($('#mile-3-'+id).val()), percent: $('#mile-per-3-'+id).val(), type: 'r3' });
    }

    if($('#mile-4-'+id).val().length > 0){
        if(new Date(yearMonthDate($('#mile-4-'+id).val())) <=  new Date(currentDate)){
            if(!parseInt($('#mile-4-'+id).attr('executed')))
                addError('mile-4-'+id, 'Enter a coming date for reminder 4');
        }else arr.push({ scheduledAt: addedHis($('#mile-4-'+id).val()), percent: $('#mile-per-4-'+id).val(), type: 'r4' });
    }

    hasError() && showErrors();
    data['reminders'] = arr;
    !hasError() && arr.length > 0 && api.simulation.post(page.campaignId, data, function(success){
        if(success && success.success){
            showSuccess('Reminder is set successfully');
        }
    });
}

var setReminderHtml = function(id, name, i, campaignType, data){
    var r1 = '',r2 = '',r3 = '',r4 = ''; var p2 = 0,p3 = 0; var e1 = 0, e2 = 0, e3 = 0, e4 =0;
    if(data.length > 0){
        for(var j = 0; j < data.length; ++j){
            if(data[j].type == 'r1'){
                e1 = (data[j].executedAt != null ? 1 : 0);
                r1 = splitToChangeDateFormat(data[j].scheduledAt);
            }
            if(data[j].type == 'r2'){
                e2 = (data[j].executedAt != null ? 1 : 0);
                r2 = splitToChangeDateFormat(data[j].scheduledAt);
                p2 = data[j].percent;
            }
            if(data[j].type == 'r3'){
                e3 = (data[j].executedAt != null ? 1 : 0);
                r3 = splitToChangeDateFormat(data[j].scheduledAt);
                p3 = data[j].percent;
            }
            if(data[j].type == 'r4'){
                e4 = (data[j].executedAt != null ? 1 : 0);
                r4 = splitToChangeDateFormat(data[j].scheduledAt);
            }
        }
    }
    $('#accordionoutline').append('<div class="card"> <div class="card-header" id="headingOneoutline-'+id+'"> <h2 class="mb-0"> <button class="btn btn-link " type="button" data-toggle="collapse" data-target="#collapseOneoutline-'+id+'" aria-expanded="false" aria-controls="collapseOneoutline"><i class="feather icon-award mr-2"></i>'+(name ? name : 'NA')+'</button> </h2> </div> <div id="collapseOneoutline-'+id+'" class="collapse '+(i == 1 ? 'show': "")+'" aria-labelledby="headingOneoutline" data-parent="#accordionoutline" style=""> <div class="card-body"> <div class="row mb-4"> <div class="col-sm-4"> <div class="date_initial"> <div class="form-group"> <label>Reminder 1</label> <div class="input-group"> <input type="text" class="datepicker-here form-control default-date" placeholder="dd-mm-yyyy" value="'+r1+'" executed='+e1+' id="mile-1-'+id+'" aria-describedby="basic-addon2" /> <div class="input-group-append"> <span class="input-group-text" id="basic-addon2"><i class="feather icon-calendar"></i></span> </div> </div> </div> </div> </div> <div class="col-sm-8"> <label>Students Course Percentage</label> <input class="range-slider-basic" id="mile-per-1-'+id+'"> </div> </div> <div class="row mb-4"> <div class="col-sm-4"> <div class="date_initial"> <div class="form-group"> <label>Reminder 2</label> <div class="input-group"> <input type="text"  class="datepicker-here form-control default-date" placeholder="dd-mm-yyyy" value="'+r2+'" executed='+e2+' id="mile-2-'+id+'" aria-describedby="basic-addon2" /> <div class="input-group-append"> <span class="input-group-text" id="basic-addon2"><i class="feather icon-calendar"></i></span> </div> </div> </div> </div> </div> <div class="col-sm-8"> <label>Students Course Percentage</label> <input  id="mile-per-2-'+id+'"> </div> </div> <div class="row mb-4"> <div class="col-sm-4"> <div class="date_initial"> <div class="form-group"> <label>Reminder 3</label> <div class="input-group"> <input type="text"  class="datepicker-here form-control default-date" placeholder="dd-mm-yyyy" value="'+r3+'" executed='+e3+' id="mile-3-'+id+'" aria-describedby="basic-addon2" /> <div class="input-group-append"> <span class="input-group-text" id="basic-addon2"><i class="feather icon-calendar"></i></span> </div> </div> </div> </div> </div> <div class="col-sm-8"> <label>Students Course Percentage</label> <input id="mile-per-3-'+id+'"> </div> </div> <div class="row mb-4"> <div class="col-sm-4"> <div class="date_initial"> <div class="form-group"> <label>Reminder 4</label> <div class="input-group"> <input type="text" class="datepicker-here form-control default-date" placeholder="dd-mm-yyyy" value="'+r4+'" executed='+e4+' id="mile-4-'+id+'" aria-describedby="basic-addon2" /> <div class="input-group-append"> <span class="input-group-text" id="basic-addon2"><i class="feather icon-calendar"></i></span> </div> </div> </div> </div> </div> <div class="col-sm-8"> <label>Students Course Percentage</label> <input class="range-slider-basic4" id="mile-per-4-'+id+'"> </div> </div> <button type="button" class="btn btn-primary" onclick="saveReminder('+id+', \''+campaignType+'\')">Save</button> </div> </div> </div>');
    $("#mile-per-2-"+id).ionRangeSlider({ type: "single", grid: true, min: 0, max: 99, from: p2 , to: 0 });
    $("#mile-per-3-"+id).ionRangeSlider({ type: "single", grid: true, min: 0, max: 99, from: p3 , to: 0 });
}

var setDatePercentRangeJS = function(){
    var date = new Date();
    var currentMonth = date.getMonth();
    var currentDate = date.getDate() + 1;
    var currentYear = date.getFullYear();
    $('.default-date').datepicker({ language: 'en', dateFormat: 'dd-mm-yyyy', autoClose:"true", minDate:new Date(currentYear, currentMonth, currentDate), offset:-90, });
    $(".range-slider-basic").ionRangeSlider({  type: "single", grid: true, min: 0, max: 99, from: 0, to: 0, disable: "rangeDisable",  });
    $(".range-slider-basic4").ionRangeSlider({ type: "single", grid: true, min: 0, max: 99, from: 99,to: 0, disable: "rangeDisable", });
}



function load(){
    var data = {};
    data.campaignId = page.campaignId;
    circleCount(data);
    data.limit = getLimit();
    data.page = getPageNo();
    data.search = $('#searchBar').val();
    data.filterBy = filterBy;
    if(data.search.length < 3){
        data.search = undefined;
    }
    api.campaign.result(data,function(success){
        $('#members tbody').html('');
        $('#no_assessment_reminder').show();
        if(success.data && success.data.hasOwnProperty('name')){
          campaignId = success.data.id;  
        $('#campaign_name').html(success.data.name)}
        if(success && success.memberList && success.memberList.length > 0){  
            success.memberList.forEach(function(session) {
                setList(session);            
            });              
        }
        if(success.count > 0){
            $('#export_button').css('display','block');
            $('.pagination-wrapper').css('display','block');            
            addPagination(success.pages, success.count);
        }else{
            $('#export_button').css('display','none');
            $('#members tbody').append('<tr> <td>No Data Found</td> </tr>')
            $('.pagination-wrapper').css('display','none');
        }
        setCampaignData(success.data);
        $('#accordionoutline').html('');
        if(success.data && success.data.CampaignCourses.length > 0){
            $('#no_assessment_reminder').show();
            var i = 1;
            success.data.CampaignCourses.forEach(function(campCourse){
                var data = (campCourse.SimulationReminders ? campCourse.SimulationReminders : []);
                setReminderHtml(campCourse.id, campCourse.Course.name, i,( success.data.Simulations ? success.data.Simulations[0].type : ''), data);
                ++i;
            });
            setDatePercentRangeJS();
        }else $('#no_assessment_reminder').hide();
    })
}

function resolveError(){
    api.campaign.fetcherrordetails(campaignId,undefined,function(success){
        if(success && success.success){
            $('#resolveError').modal('hide');
            // load();
            $('#resolve_error').hide();
        }
    })
}

$(document).ready(function(){
    load();
});