var courseId = page.courseId;
var lid = 0;
var sid = 0;
var sessionIds = [];
var studentCount = 0;

function setStatics(MemberCourses){
    var deparmentCount = 0;
    var totalDuration = 0;
    MemberCourses.forEach(function(member) {
        if(member.Session)
            studentCount++;
        if(member.Session.Group){
            if($.inArray(member.Session.Group.id, sessionIds) == -1){
                sessionIds.push(member.Session.Group.id)
                deparmentCount++;
            }
        }
        member.Session.SessionCourseLectureTrackings.forEach(function(duration) {
            totalDuration = totalDuration + duration.duration;
        })
    })
    var minutes = Math.floor(totalDuration/60);
    $('#minute').text((minutes ? minutes : 0));
    $('#student').text(studentCount);
    $('#department').text(deparmentCount);  
}

function getLectureStatic(lecture){
    var lectureDuration = lecture.totalDuration;
    var watchCount = 0;
    var durationWatchedCount = 0;
    var watchedPercentCount = 0;
    watchCount = lecture.SessionCourseLectureTrackings.length;
    lecture.SessionCourseLectureTrackings.forEach(function(sessionData) {
        if(sessionData.duration > 0){
            durationWatchedCount =  durationWatchedCount + sessionData.duration;
        }
        if(sessionData.percent != 0 && sessionData.percent != 100){
            watchedPercentCount++;
        }
    })
    if(lecture.type == 'quiz'){
        $('#show-see-results').show();
        
    }
    lectureDuration = lectureDuration * studentCount;
    var amountWatched = Math.round(durationWatchedCount / lectureDuration * 100);
    var droppedPercent = Math.round(watchedPercentCount / watchCount * 100);
    var data = JSON.stringify({'watchCount': watchCount, 'amountWatched' : (amountWatched >= 100 ? 100 : amountWatched), 'droppedPercent' : (droppedPercent >= 100 ? 100 : droppedPercent)});
    return data;
}

function appendLecturesDetail(sectionId,lecture){
    var data = JSON.parse(getLectureStatic(lecture));
    ++lid;
    $('#section_'+sectionId).append('<tr> <th scope="row">'+lid+'</th> <td>'+lecture.name+'</td> <td>'+(data.watchCount ? data.watchCount : '0')+' Learners </td> <td>'+(data.droppedPercent ? data.droppedPercent : 0)+' %</td> <td><div class="progressbar-list"> <div class="progress"> <div class="progress-bar" role="progressbar" style="width: '+(data.amountWatched ? data.amountWatched : 0)+'%;" aria-valuenow="'+(data.amountWatched ? data.amountWatched : 0)+'" aria-valuemin="0" aria-valuemax="100">'+(data.amountWatched ? data.amountWatched : 0)+'%</div> </div> </div></td> </tr>');
}
 
function setSectionDetail(section){
    if(section.CourseSectionLectures.length > 0){
        $('#accordionwithicon').append('<div class="card"> <div class="card-header" id="heading-'+section.id+'"> <h2 class="mb-0"> <button class="btn btn-link collapsed" type="button" data-toggle="collapse" data-target="#collapse-'+section.id+'" aria-expanded="false" aria-controls="collapse-'+section.id+'">Section : '+section.name+'</button> </h2> </div> <div id="collapse-'+section.id+'" class="collapse '+(sid == 1 ? 'show' : '')+'" aria-labelledby="heading-'+section.id+'" data-parent="#accordionwithicon"> <div class="card-body"> <div class="table-responsive"> <table class="table"> <thead class="thead-light"> <tr> <th scope="col">#</th> <th scope="col">Lecture</th> <th scope="col" >Watched <i class="fa fa-question-circle-o ml-1" data-tooltip="tooltip" data-placement="top" title="" data-original-title="This is the number of learners who’ve watched a lecture."></i></th> <th scope="col">Dropped <i class="fa fa-question-circle-o ml-1" data-tooltip="tooltip" data-placement="top" title="" data-original-title="This is the percentage of learners who started the lecture and then stopped watching."></i></th> <th scope="col">Amount Watched <i class="fa fa-question-circle-o ml-1" data-tooltip="tooltip" data-placement="top" title="" data-original-title=" This is the amount of the lecture that learners, on average, completed watching."></i></th> </tr> </thead> <tbody id="section_'+section.id+'"> </tbody> </table> </div> </div> </div> </div> ');
        $('[data-tooltip="tooltip"]').tooltip();
        $('#section_'+section.id).html('');

        lid = 0;
        $('#show-see-results').hide();
        section.CourseSectionLectures.forEach(function(lecture) {
            if(lecture.type)
                appendLecturesDetail(section.id,lecture)
        })
    }
}

function setCourseData(){
    api.analytic.courseDetail({courseId : courseId},function(success){
        if(success && success.memberCourse){
            $('#accordionwithicon').html('');
            setStatics(success.memberCourse);
            success.course.CourseSections.forEach(function(section) {
                sid++;
                setSectionDetail(section);   
            });
        }
       });
}

function setCourseList(){
    api.analytic.list(undefined,function(success){
        if(success && success.course){
            success.course.forEach(function(coursename) {
                if(coursename.id == courseId)
                    $('#courseName').text(coursename.name);
                $('#published-course').append('<a class="dropdown-item" '+(coursename.id == courseId ? 'selected' : '')+' href="/analytic/'+coursename.id+'">'+coursename.name+'</a>');
            })
        }
       });
}

function loadCourseGraph(){
    api.analytic.courseGraph({courseId : courseId},function(success){
        var months = []; var data = [];
        var tempDate = new Date();
        tempDate.setMonth(tempDate.getMonth()-6);
        for(var i=0;i<7;i++){
            var monthString = moment(tempDate).format("MMM");
            months.push(monthString);
            if(success.graph[monthString]) data.push(Math.round(success.graph[monthString] / 60));
            else data.push(0);
            tempDate.setMonth(tempDate.getMonth()+1);
        }
         renderChart(data, months);
    });
}

function renderChart(data, months){
    var options = {
        chart: {
            height: 362,
            type: 'bar',
            toolbar: {
                show: false
            },
        },
        plotOptions: {
            bar: {
                horizontal: false,
                columnWidth: '25%',
                endingShape: 'rounded'  
            },
        },
        dataLabels: {
            enabled: false
        },
        stroke: {
            show: true,
            width: 2,
            colors: ['transparent']
        },
        colors: ['#0080ff', '#d4d8de'],
        series: [{
            name: 'Course Minutes',
            data: data
        }],
        legend: {
            show: false,
        },
        xaxis: {
            categories: months,
            axisBorder: {
                show: true, 
                color: 'rgba(0,0,0,0.05)'
            },
            axisTicks: {
                show: true, 
                color: 'rgba(0,0,0,0.05)'
            }
        }
    }
    var chart = new ApexCharts(
        document.querySelector("#apex-bar-chart"),
        options
    );
    chart.render();

}  

$(document).ready(function(){
    setCourseList();
    setCourseData();
    loadCourseGraph();
});