var targets = {};
var savedTargets = {};
var errorStatus = false;
var dbSkills = [];

var reloadList = function() {
    loadTargets();
}

var searchQuery = function() {
    setPage(1);
    loadTargets(false)
}

var paginationData = function(count) {
    setLimit(count);
    setPage(1);
    loadTargets();
}

var validateFile = function() {
    errorStatus = false;
    var filename = $('input[name="fileupload"]').prop('files')[0];
    ext = filename.name.split('.').pop();
    if(ext == 'csv'){
        $('#fileshow').show();
        $('#fileerror').hide();
        $('#filetitle').html(filename.name + " " + "File Uploaded Successfully. Please save the department now.");
        // setTimeout(function(){
        //     $('#fileshow').hide();
        // }, 5000);
        getAsText(filename)
    }else{
        $('#myModal2').modal('hide');
        $('#csv-users').hide();
        $('#errortitle').html("Please choose csv file format");
        $('#fileshow').hide();
        $('#fileerror').show();
    }
}

function getAsText(fileToRead) {
    var reader = new FileReader();     
    reader.readAsText(fileToRead);
    reader.onload = loadHandler;
    reader.onerror = errorHandler;
}

function loadHandler(event) {
    var csv = event.target.result;
    processData(csv);
}

var showFileError = function() {
    errorStatus = true;
    var filename = $('input[name="fileupload"]').prop('files')[0];
    $('#fileerror').show();
    $('#fileshow').hide();
    $('#errortitle').html(filename.name + " " +"Invalid CSV Format, Please Download sample CSV file");
    // setTimeout(function(){
    //     $('#fileshow').hide();
    // }, 5000);
    // errorStatus = true;
    // addError(null, error);
    // showErrors();
}

var csvLength = 0;

function processData(csv) {
    var allTextLines = csv.split(/\r\n|\n/);
    csvLength = parseInt(allTextLines.length) - 1;
    var lines = allTextLines[0].split(',');
    // var noManager = false;
    // for(var j = 1; j < allTextLines.length; j++){
    //     var da = allTextLines[j].split(',');
    //     console.log(da, da[5]);
    //     if(da[5] != undefined && da[5].toLowerCase() == 'yes')
    //         noManager = true;
    // }
    // console.log(noManager);
    var goodUsers = ["firstName", "lastName", "email", "phone", "designation", "isManager"];
    for(var i=0; i<lines.length; i++){
        if(goodUsers.indexOf(lines[i]) == -1) {
            showFileError('CSV data not match to sample data');
            break;
        }
    }
    if(allTextLines.length <= 1){
        showFileError('CSV file doesn\'t have data.')
    }
}

function errorHandler(evt) {
    if(evt.target.error.name == "NotReadableError") {
        showFileError('Select only csv file.');
    }
}

var clearTargetFields = function(){
    $('#firstName').val('');
    $('#lastName').val('');
    $('#email').val('').prop("disabled", false);
    $('#phone').val('');
    $('#designation').val('');
    $('#manager-show-hide').show();
    $("#noManager").prop("checked", true);
    Object.values(targets).forEach(function(target) {
        if(target.isManager === 'true')
            $('#manager-show-hide').hide();
    });
    Object.values(savedTargets).forEach(function(starget) {
        if(starget.isManager === 'true')
            $('#manager-show-hide').hide();
    });
    $('#button').html('<button class="btn btn-success mr-2 py-2" onclick="addNewTarget(validateTarget(), true, false)" ><i class="feather icon-check"></i> Save</button>');
    $('#button').append('<button type="button" class="btn btn-success add_user  py-2"  onclick="addNewTarget(validateTarget(), true, true)"> <i class="feather icon-check"></i> Save &  add another </button>');
}

var clearTargets = function(){
    $('#targets tbody').html('');
    $('#paginate').hide();
}

var revertTarget = function(targetEmail){
    var id = (!isNaN(targetEmail) ? targetEmail : targetEmail.replace(/@/g, '-').replace(/\./g, '-'))
    $('#target_'+id).css({"background-color":"", "color":""});
    $('#remove_'+id).html('<button type="button" data-toggle="modal" data-target="#myModal2" class="btn btn-primary" onclick="editUserTarget(\'' + targetEmail + '\', \'single\')"> <i class="feather icon-edit"></i><button type="button" class="btn btn-primary" onclick="deleteTarget(\'' + targetEmail + '\')"> <i class="feather icon-trash"></i>');
    delete targets[targetEmail];
}

var deleteTarget = function(targetId){
    var id = (!isNaN(targetId) ? targetId : targetId.replace(/@/g, '-').replace(/\./g, '-'));
    // if(targets[targetId].isManager === 'true')
    //     $('#manager-show-hide').show();
    if(page.groupId == 0){
        delete targets[targetId];
        $('#target_'+id).remove();
    }else if(Object.keys(targets).indexOf(targetId) > -1 && targets[targetId].mode != 'delete'){
        delete targets[targetId];
        $('#target_'+id).remove();
    }else{
        addTarget(savedTargets[targetId], true, 'delete');
        $('#target_'+id).css({"background-color":"#d42727", "color":"white"});
        $('#remove_'+id).html('<button type="button" class="btn btn-primary" onclick="revertTarget(\'' + targetId + '\')"> <i class="feather icon-rotate-ccw"></i> </button>');
    }
}

var editUserTarget = function(targetEmail, type){
    editTarget = {};
    selectUploadOption(type);
    if(Object.keys(targets).indexOf(targetEmail) > -1){
        editTarget[targetEmail] = targets[targetEmail];
        Object.values(targets).forEach(function(target) {
            if(target.isManager === 'true')
                $('#manager-show-hide').hide();
        });
    }else if(Object.keys(savedTargets).indexOf(targetEmail) > -1){
        editTarget[targetEmail] = savedTargets[targetEmail];
        Object.values(savedTargets).forEach(function(starget) {
            if(starget.isManager === 'true')
                $('#manager-show-hide').hide();
        });
    }
    $('#firstName').val(editTarget[targetEmail].firstName);
    $('#lastName').val(editTarget[targetEmail].lastName);
    $('#email').val(editTarget[targetEmail].email);
    $('#phone').val(editTarget[targetEmail].phone);
    $('#designation').val(editTarget[targetEmail].designation);
    if(editTarget[targetEmail].isManager === 'true'){
        $('#manager-show-hide').show();
        $('#yesManager').prop("checked", true);
    }
    $('#button').html('<button class="btn btn-success py-2" onclick="updateTarget(editTarget, \''+targetEmail+'\')"> <i class="feather icon-check"></i> Update</button>')
    $('html, body').animate({scrollTop:0},500);
}

var validateUpdateTarget = function(editTarget, tEmail){
    clearErrors(); 
    email = /* $('#email').val() */tEmail;
    var data = editTarget[email];
    if(page.groupId > 0)
        data.groupId = page.groupId;
    data.firstName = sanitize($('#firstName').val().trim());
    if(data.firstName.length == 0){
        addError('firstName', 'First name is required field');
    }
    data.lastName = sanitize($('#lastName').val().trim());
    if(data.lastName.length == 0){
        data.lastName = undefined;
    }
    data.email = $('#email').val();
    if(data.email.length == 0){
        addError('email', 'Email Id is required field');
    }else if(!validateEmail(data.email)){
        addError('email', 'Email Id is not valid');
    }
    data.phone = sanitize($('#phone').val());
    if(data.phone.length == 0){
        data.phone = undefined;
    }
    data.designation = sanitize($('#designation').val());
    if(data.designation.length == 0){
        data.designation = undefined;
    }
    data.isManager = $("input[name='manager']:checked").val();
    hasError() && showErrors();
    return data;
}

var updateTarget = function(editTarget, tEmail){
    var data = validateUpdateTarget(editTarget, tEmail);
    if(!hasError()){
        if(Object.keys(targets).indexOf(tEmail) > -1 ){
            targets[tEmail] = data;
        }else{
            targets[tEmail] = {id: data.id, firstName:data.firstName, lastName:data.lastName, email:data.email, groupId:data.groupId, phone:data.phone, designation:data.designation};
            targets[tEmail].isManager = data.isManager;
            targets[tEmail].mode = 'update';
        }
        var id = (!isNaN(tEmail) ? tEmail : tEmail.replace(/@/g, '-').replace(/\./g, '-')) ;
        if(data.isManager === 'true'){
            $('#target_'+id).remove();
            if($('#targets tbody').has('tr').length > 0)
                $('#targets tbody > tr:first').before('<tr id="target_' +id+ '"><td>' + data.firstName + '</td><td>' + ((data.lastName == null) ? '---' : data.lastName) + '</td><td class="'+(data.isManager === 'true' ? 'add-manager-class': '')+'">' + data.email + (data.isManager === 'true' ? '<b style="color:green;"> (Manager)</b>' : '')+ '</td><td>' + ((data.phone == null) ? '---' : data.phone) + '</td><td>' + ((data.designation == null) ? '---' : data.designation) + '</td><td id="remove_' +id+ '"> <button type="button" data-toggle="modal" data-target="#myModal2" class="btn btn-primary" onclick="editUserTarget(\'' + tEmail + '\', \'single\')"> <i class="feather icon-edit"></i> </button> <button type="button" class="btn btn-primary" onclick="deleteTarget(\'' + tEmail + '\')"> <i id="remove_' +id+ '" class="feather icon-trash"></i> </button> </td></tr>');
            else 
                $('#targets tbody').html('<tr id="target_' +id+ '"><td>' + data.firstName + '</td><td>' + ((data.lastName == null) ? '---' : data.lastName) + '</td><td class="'+(data.isManager === 'true' ? 'add-manager-class': '')+'">' + data.email + (data.isManager === 'true' ? '<b style="color:green;"> (Manager)</b>' : '')+ '</td><td>' + ((data.phone == null) ? '---' : data.phone) + '</td><td>' + ((data.designation == null) ? '---' : data.designation) + '</td><td id="remove_' +id+ '"> <button type="button" data-toggle="modal" data-target="#myModal2"  class="btn btn-primary" onclick="editUserTarget(\'' + tEmail + '\', \'single\')"> <i class="feather icon-edit"></i> </button> <button type="button" class="btn btn-primary" onclick="deleteTarget(\'' + tEmail + '\')" > <i id="remove_' +id+ '" class="feather icon-trash"></i> </button> </td></tr>');
        }else
            $('#target_'+id).html('<td>' + data.firstName + '</td><td>' + ((data.lastName == null) ? '---' : data.lastName) + '</td><td class="'+(data.isManager === 'true' ? 'add-manager-class': '')+'">' + data.email + (data.isManager === 'true' ? '<b style="color:green;"> (Manager)</b>' : '')+ '</td><td>' + ((data.phone == null) ? '---' : data.phone) + '</td><td>' + ((data.designation == null) ? '---' : data.designation) + '</td><td id="remove_' +id+ '"> <button type="button" data-toggle="modal" data-target="#myModal2"  class="btn btn-primary" onclick="editUserTarget(\'' + tEmail + '\', \'single\')"> <i class="feather icon-edit"></i> </button> <button type="button" class="btn btn-primary" onclick="deleteTarget(\'' + tEmail + '\')"> <i id="remove_' +id+ '" class="feather icon-trash"></i> </button> </td>');
        clearTargetFields();
        $('#myModal2').modal('hide');
        showSuccess('User Updated!');
    }
}
var tCount = 1;
var addTarget = function(target, newData, mode, t){
    if(newData){
        targets[tCount] = (target.id === undefined ? target: { id:target.id, firstName:target.firstName, email:target.email});
        targets[tCount].mode = mode;
    }else{
        savedTargets[target.email] = target;
    }
    if(mode != 'delete'){
        var id = (t == 'db' ? target.email.replace(/@/g, '-').replace(/\./g, '-') : tCount);
        if($('#targets tbody > tr:first').length > 0 && target.isManager === 'true'){
            $('#targets tbody > tr:first').before('<tr id="target_' +id+ '"><td>' + target.firstName + '</td><td>' + ((target.lastName == null) ? '---' : target.lastName) + '</td><td class="'+(target.isManager === 'true' ? 'add-manager-class': '')+'">' + target.email + (target.isManager === 'true' ? '<b style="color:green;"> (Manager)</b>' : '')+ '</td><td>' + ((target.phone == null) ? '---' : target.phone) + '</td><td>' + ((target.designation == null) ? '---' : target.designation) + '</td><td id="remove_' +id+ '"> <button type="button" data-toggle="modal" data-target="#myModal2" class="btn btn-primary" onclick="editUserTarget(\'' + (t == 'db' ? target.email :tCount) + '\', \'single\')"> <i class="feather icon-edit"></i> </button> <button type="button" class="btn btn-primary" onclick="deleteTarget(\'' + (t == 'db' ? target.email :tCount) + '\')"> <i id="remove_' +id+ '" class="feather icon-trash"></i> </button> </td></tr>');
        } else
            $('#targets tbody').append('<tr id="target_' +id+ '"><td>' + target.firstName + '</td><td>' + ((target.lastName == null) ? '---' : target.lastName) + '</td><td class="'+(target.isManager === 'true' ? 'add-manager-class': '')+'">' + target.email + (target.isManager === 'true' ? '<b style="color:green;"> (Manager)</b>' : '')+ '</td><td>' + ((target.phone == null) ? '---' : target.phone) + '</td><td>' + ((target.designation == null) ? '---' : target.designation) + '</td><td id="remove_' +id+ '"> <button type="button" data-toggle="modal" data-target="#myModal2"  class="btn btn-primary" onclick="editUserTarget(\'' + (t == 'db' ? target.email :tCount) + '\', \'single\')" > <i class="feather icon-edit"></i> </button> <button type="button" class="btn btn-primary" onclick="deleteTarget(\'' + (t == 'db' ? target.email :tCount) + '\')" > <i id="remove_' +id+ '" class="feather icon-trash"></i> </button> </td></tr>');
    }
}

var showTargets = function(){
    $('#emptyState').hide();
    $('#fullState').show();
}

var validateTarget = function(){
    clearErrors();
    var data = new Object();
    if(page.groupId > 0)
        data.groupId = page.groupId;
    data.firstName = sanitize($('#firstName').val().trim());
    if(data.firstName.length == 0){
        addError('firstName', 'First name is required field');
    }
    data.lastName = sanitize($('#lastName').val().trim());
    if(data.lastName.length == 0){
        data.lastName = undefined;
    }
    data.email = $('#email').val();
    if(data.email.length == 0){
        addError('email', 'Email Id is required field');
    }else if(!validateEmail(data.email)){
        addError('email', 'Email Id is not valid');
    }
    data.phone = sanitize($('#phone').val());
    if(data.phone.length == 0){
        data.phone = undefined;
    }
    data.designation = sanitize($('#designation').val());
    if(data.designation.length == 0){
        data.designation = undefined;
    }
    if(Object.keys(targets).indexOf(tCount) > -1 | Object.keys(savedTargets).indexOf(data.email) > -1){
        addError('email', data.email+' is already added');
    }
    data.isManager = $("input[name='manager']:checked").val();
    hasError() && showErrors();
    return data;
}

var addNewTarget = function(data, type, b) {
    if(!hasError() && page.groupId == 0){
        if(Object.keys(targets).length == 0)
            clearTargets();
        addTarget(data, true, 'add');
        ++tCount;
        clearTargetFields();
    }else{
        if(!hasError()){
            if($('#targets tbody tr td').html() == "No Users Found")
                clearTargets();
            addTarget(data, true, 'add');
            ++tCount;
            clearTargetFields();
        }
    }
    if(!hasError() && type){
        if(!b) $('#myModal2').modal('hide');
        showSuccess('New User Added!');
    }
}


var loadTargets = function(noloader = true) {
    var data = new Object();
    data.groupId = page.groupId;
    data.page = getPageNo();
    data.search = $('#searchBar').val();
    data.limit = getLimit();  
    if(data.search.length < 3){
        data.search = undefined;
    }
    api.member.get(data, function(success) {
        clearTargets();
        success.targets.forEach(function(target) {
            if(Object.keys(targets).indexOf(target.Member.email) > -1){
                target.Member = targets[target.Member.email];
            }
            target.Member.isManager = (target.isManager == 1 ? 'true' : 'false');
            addTarget(target.Member, false, '', 'db');
        }); 
        Object.values(targets).forEach(function(target) {
            if(target.mode === 'delete'){
                var id = target.email.replace(/@/g, '-').replace(/\./g, '-');
                $('#target_'+id).css({"background-color":"#d42727", "color":"white"});
                $('#remove_'+id).html('<button type="button" class="btn btn-primary" onclick="revertTarget(\'' + target.email + '\')"> <i class="fas fa-undo"></i> </button>');
            }else if(target.mode === 'add'){
                addTarget(target,true,'add', 'db');
            }
        })
        showTargets();
        if(success.targets.length > 0){
            addPagination(success.pages, success.count);
            $('#paginate').show();
        }else{
            $('#targets tbody').html('<tr><td colspan="2">No Users Found</td></tr>');
        }
    }, function(error) {}, noloader)
}

var validateGroup = function() {
    clearErrors();
    var data = new FormData();
    data.append('csvLength', csvLength);
    var name = sanitize($('#groupName').val());
    if(name.length == 0){
        addError('groupName', 'Department Name is a required field');
    }
    data.append('name', name);
    if($("input[name='group']:checked").attr('id') != undefined){
        var splitedData = $("input[name='group']:checked").attr('id').split("-");
        data.append('parentId', splitedData[2]);
    }else data.append('parentId', 0);
    data.append('members', JSON.stringify(Object.values(targets)));
    var allSkills = $('.group-radio:checkbox:checked').map(function () {
        return this.id;
    }).get().join(",");
    if (allSkills == ''){
        addError('skills', 'Skill field is required');
    }
    data.append('skills', allSkills);
    var attachment = $('input[name=fileupload]').val();
    if (attachment != "") {
        if($('input[name=fileupload]').prop('files')[0]) {
            if(!errorStatus){
                data.append('file', $('input[name=fileupload]').prop('files')[0]);
            } else {
                addError('null', 'Select valid csv file');
            }
        }
    }else{
        if($('#targets tbody tr td').html() != "No Users Found"){
            if(!$('#targets tbody tr td').hasClass('add-manager-class'))
                addError('manager', 'Please assign one manager!');
        }
    }
    // if((!attachment && !Object.keys(targets).length) && !Object.keys(savedTargets).length){
    //     addError(null, 'Add atleast one User or File');
    // }
    hasError() && showErrors();
    return data;
}

var checkPermission = function(){
    var data = validateGroup();
    !hasError() && api.group.check(data, function(success) {
        if(success && success.success)
            saveGroup(data);
    });
}

var saveGroup = function(data) {
    if(page.groupId == 0){
        !hasError() && api.group.post(data, function(success) {
            showSuccess('New Department has been created!');
            setTimeout(function() {
                window.location = '/department/list';
            }, 1000);
        });
    }else{
        !hasError() && api.groupId.patch(page.groupId, data, function(success) {
            if(success){
                showSuccess('Department is updated!');
                loadTargets();
                targets = {};
                setTimeout(function() {
                    window.location = '/department/list';
                }, 1000);
            }
        })
    }
}

var loadGroup = function() {
    api.groupId.get(page.groupId, undefined, function(success) {
        $('#groupName').val(success.group.name);
        if(success && success.parentGroup){
            setExistingGroupName(success.parentGroup.name);
            $('#radio-group-'+success.parentGroup.id).prop('checked', true);
        }
        if(success.group.status != "pending"){
            toggleLoadingView();
        } 
        success.group.GroupSkills.forEach(function(skill){
            dbSkills.push(skill.skillId);
        })
        loadSkills();
        // if(success.group.errorFile){
        //     $('#invalidDetails').show();
        //     $("#invalidDetails").attr("href", '/static/groupscsv/'+success.group.errorFile);
        // }
    });

    api.groupId.count(page.groupId, undefined, function(success) {
        if(success && success.groups && success.groups.length > 0){
            $('#show-sub-group').show();
            success.groups.forEach(function(group) {
                addChildGroupsAndCount(group);
            })
        }else  $('#show-sub-group').hide();
    });
}

var toggleLoadingView = function() {
    $('#loading-view').hide();
}

var clearExistingGroup = function() {
    $('ul #existing-group').html('');
    $('#department-exist').show();
}

function revomeExistingGroup(){
    $(".group-radio").prop("checked", false);
    $('#exist-group').html('<i class="fa fa-lg fa-tasks"></i> Select Department</a></h3>');
}

var setExistingGroupName = function(name) {
    $('#exist-group').html('').html('<i class="fa fa-lg fa-tasks"></i>  <span>'+name+'  <i class="feather icon-x" onclick="revomeExistingGroup()"></i></span>');
    var link =   $("#accordian a");
    var closest_ul = link.closest("ul");
    var parallel_active_links = closest_ul.find(".active")
    closest_ul.find("ul").slideUp(function () {
        if (closest_ul.find("ul").length)
            parallel_active_links.removeClass("active");
    });
}

var childDepartments = function(group){
    if(!$('#existing-group-'+group.parentId).has('ul').length);
        $('#existing-group-'+group.parentId).append('<ul></ul>');
    $('#existing-group-'+group.parentId+' > ul').append('<li id="existing-group-'+group.id+'"><a><input type="radio"  id="radio-group-'+group.id+'" class="group-radio" name="group" onclick="setExistingGroupName(\''+group.name+'\')"> <label for="radio-group-'+group.id+'">'+group.name+'</label> </a></li>')
}

var addExistingGroup = function(group) {
    $('#existing-group').append('<li id="existing-group-'+group.id+'"><a><input type="radio" id="radio-group-'+group.id+'" name="group" class="group-radio" onclick="setExistingGroupName(\''+group.name+'\')">  <label for="radio-group-'+group.id+'">'+group.name+'</label></a></li>');
}

var addChildGroupsAndCount = function(group) {
    $('#child-group-list').append('<div class="col-sm-3"> <a href="'+group.id+'"><div class="media"><img src="/static/images/svg-icon/user.svg"> <div class="media-body"> <p class="mb-0">'+group.name+'</p> <h5 class="mb-0">'+group.members+' Users</h5> </div> </div> </a> </div>');
}

var groupHierarchyRender = function(){
    $("#accordian a").click(function () {
        var link = $(this);
        var closest_ul = link.closest("ul");
        var parallel_active_links = closest_ul.find(".active")
        var closest_li = link.closest("li");
        var link_status = closest_li.hasClass("active");
        var count = 0;
        closest_ul.find("ul").slideUp(function () {
            if (++count == closest_ul.find("ul").length)
                parallel_active_links.removeClass("active");
        });
        if (!link_status) {
            closest_li.children("ul").slideDown();
            closest_li.addClass("active");
        }
    });
}

var skillsHierarchyRender = function(){
    $("#accordianSet a").click(function () {
        var link = $(this);
        var closest_ul = link.closest("ul");
        var parallel_active_links = closest_ul.find(".active")
        var closest_li = link.closest("li");
        var link_status = closest_li.hasClass("active");
        var count = 0;
        closest_ul.find("ul").slideUp(function () {
            if (++count == closest_ul.find("ul").length)
                parallel_active_links.removeClass("active");
        });
        if (!link_status) {
            closest_li.children("ul").slideDown();
            closest_li.addClass("active");
        }
    });
}

function setSelectedSkill() {
    $('#added-skills').html('').html('  <i class="fa fa-lg fa-tasks"></i>');
    var checkedVals = $('.group-radio:checkbox:checked').map(function () {
        return $('#added-skills').append('<span id="grp-'+this.id+'">' + this.value + '<i class="feather icon-x" onclick="removeSkill('+this.id+')"></i></span>');
    }).get();
    if(checkedVals.length == 0)
        $('#added-skills').html('<i class="fa fa-lg fa-tasks"></i> Select Skill Type');
}

function removeSkill(skillId) {
    var count = 0;
    var checkedVals = $('.group-radio:checkbox:checked').map(function () {
        ++count;
    }).get();
    if(count == 1) $('#added-skills').html('<i class="fa fa-lg fa-tasks"></i> Select Skill Type');
    $("#grp-"+skillId+"").remove(); 
    $("#"+skillId+"").prop('checked', false);   
}

function appendSkills(group) {
    if(group != undefined){
        if (group.parentId == 0) {
            $('#skills_append').append('<li id="skills_append-' + group.id + '"><a><input type="checkbox" id="' + group.id + '" value="' + group.name + '" '+(dbSkills.includes(group.id) ? 'checked' : '')+' name="skills[]" class="group-radio" onclick="setSelectedSkill()"> <label for="'+ group.id + '"> ' + group.name + '</label> </a></li>');
        } else {
            if (!$('#skills_append-' + group.parentId).has('ul').length)
                $('#skills_append-' + group.parentId).append('<ul></ul>');
            $('#skills_append-' + group.parentId + ' > ul').append('<li id="skills_append-' + group.id + '"><a><input type="checkbox"  id="' + group.id + '" class="group-radio" '+(dbSkills.includes(group.id) ? 'checked' : '')+' name="skills[]" value="' + group.name + '"  onclick="setSelectedSkill()"><label for="'+ group.id + '">' + group.name + '</label>  </a></li>')
        }
    }else{
        $('#skills_append').append('<li >No Skill Found.</li>');
    }
}

var a = function(){
    $(document).click(function (e) {
        var container = $("#existing-group");
        if ($(e.target).is('#accordian a') || $(e.target).is('#accordian a i') || $(e.target).is('#accordian a input')) 
            container.show();
        else container.hide();
    });
}

var b = function(){
    $(document).click(function (e) {
        var container1 = $("#skills_append");
        if ($(e.target).is('#accordianSet a') || $(e.target).is('#accordianSet a i') || $(e.target).is('#accordianSet a input')) 
        container1.show();
    else container1.hide();
    });
}



var load = function() {
    api.group.existing({id:page.groupId}, function(success) {
        if(success && success.groups.length > 0){
            clearExistingGroup();
            var i = 0; var arr = {};
            success.groups.forEach(function(group) {
                if(group.parentId == 0) addExistingGroup(group);
                else arr[group.parentId] = group;
                ++i;
            });
            if(success.groups.length == i){
                Object.keys(arr).forEach(function(g){
                    childDepartments(arr[g]);
                });
            }
            a();
            groupHierarchyRender();
        }else
            $('#department-exist').hide();
    });
}

var loadSkills = function(){
    var type = "DESC";
    api.skill.skillsByParent({ type: type }, function (success) {
        $('#skills_append').html('');
        if(success && success.skills && success.skills.length > 0){
            success.skills.forEach(function(skill) {
                appendSkills(skill);
            });
            setSelectedSkill();
            b();
            skillsHierarchyRender();
        }
    });
}

function hideAllSelectUploadOption(){
    $('#csv-users').hide();
    $('#single-users').hide();
    $('#self-users').hide();
    $('#setImportOption').html('');
    $('.uploadlogo').val('');
    $('#error-set').html('Upload File');
}

function validateSeletedOption(error){
    $('.hell').removeAttr('data-target data-toggle');
    if($("#groupName").val() == ""){
        errorStatus = true;
        addError('depa', 'Please enter department name first!');
        hasError() && showErrors();
        return false;
    }
    $('.hell').attr({"data-target":"#myModal2" , "data-toggle":"modal"});
    return true;
}

function selectUploadOption(type){
    hideAllSelectUploadOption();
    clearTargetFields();
    var data = validateSeletedOption();
    if(data){
        if(type == 'csv')
            $('#setImportOption').html('Upload a CSV');
        else if(type == 'single')
            $('#setImportOption').html('Single User');
        else
            $('#setImportOption').html('Self Registration');
        $('#'+type+'-users').show();
    }
}

function readURL(input) {
    var url = input.value;
    var ext = url.substring(url.lastIndexOf('.') + 1).toLowerCase();
    if (input.files && input.files[0] && ext == "csv") {
        var path = $(input).val();
        var filename = path.replace(/^.*\\/, "");
        $('#myModal2').modal('hide');
        return "Uploaded file : "+filename;
    }else{
        $(input).val("");
        return "Only CSV formats are allowed!";
    }
  }

$(document).ready(function(){    
    $('#openfileupload').click(function(){
	    $('#fileupload').trigger('click'); 
    });  
    load();
    if(page.groupId > 0){
        loadGroup();
        loadTargets();
    }else {
        loadSkills();
    }
    toggleLoadingView();

    $(".uploadlogo").change(function() {
        var filename = readURL(this);
        $(this).parent().children('span').html(filename);
    });
});