var correctQuestions = 0;
var wrongQuestions = 0;

var validateResult = function () {
    clearErrors();
    var data = new Object();
    if (page.lId && page.sKey) {
        data.lId = page.lId;
        data.sKey = page.sKey;
        data.ac = page.ac;
    } else addError('result', 'Invalid Learner');
    hasError() && showError();
    return data;
}

var setQuesstionOptions = function (qId, data, ac) {
    let spandata = '';
    let length_data = '';
    if (ac == 'Y291cnNl5') {
        length_data = data.CourseUserQuizAnswers.length;
    } else {
        length_data = data.QuizSecctionTrackings.length;
    }
    if (length_data > 0) {
        if (ac == 'Y291cnNl5') {
            if (data.CourseUserQuizAnswers[0].isCorrect) {
                ++correctQuestions;
                spandata = '<span class="check_right"><i class="fa fa-check"></i></span> <span style="color:#8bc34a;">Correct Answer</span>';
            } else {
                ++wrongQuestions;
                spandata = '<span class="check_wrong"><i class="fa fa-close"></i></span> <span style="color:#ed3833;">Wrong Answer</span>';
            }
        } else {
            if (data.QuizSecctionTrackings[0].isCorrect == 1) {
                ++correctQuestions;
                spandata = '<span class="check_right"><i class="fa fa-check"></i></span> <span style="color:#8bc34a;">Correct Answer</span>';
            } else {
                ++wrongQuestions;
                spandata = '<span class="check_wrong"><i class="fa fa-close"></i></span> <span style="color:#ed3833;">Wrong Answer</span>';
            }
        }
    }
    $('#question-' + qId).append('<li>' + data.title + spandata + '</li>');
}

var setQuestions = function (i, data, ac) {
    let arr = [];
    let str = `Question ${i} (Unanswered)`;
    if (ac == 'Y291cnNl5') {
        data.CourseQuizQuestionOptions.forEach(ele=>{
            if(ele.CourseUserQuizAnswers.length > 0)
            arr.push(ele.CourseUserQuizAnswers.length);
        })
        if(arr.length > 0){
            str = `Question ${i}`
        }
    }else{
    data.QuizQuestionOptions.forEach(ele=>{
        if(ele.QuizSecctionTrackings.length > 0)
        arr.push(ele.QuizSecctionTrackings.length);
    })
    if(arr.length > 0){
        str = `Question ${i}`
    }
}
    $('#question_cyber').append('<div class="cyber_question_all"> <h4>'+str+'</h4> <h5 class="question_name">' + data.title + '</h5> <ol class="question_list_cyber" id="question-' + data.id + '">  </ol> </div>');
    if (ac == 'Y291cnNl5') {
        data.CourseQuizQuestionOptions.forEach(function (opt) {
            setQuesstionOptions(data.id, opt, ac);
        })
    } else {
        data.QuizQuestionOptions.forEach(function (opt) {
            setQuesstionOptions(data.id, opt, ac);
        })
    }
}

var clearHtmls = function () {
    $('#lecture-name').html('');
    $('#question_cyber').html('');
    $('#total_questions').html(0);
    $('#correct_questions').html(0);
    $('#wrong_questions').html(0);
    $('#written_dateTime').html('');
}

var semiCircle = function (percent) {
    var bar = new ProgressBar.SemiCircle(container, {
        strokeWidth: 6,
        color: '#2c5882',
        trailColor: '#eee',
        trailWidth: 6,
        easing: 'easeInOut',
        duration: 1400,
        svgStyle: null,
        text: {
            value: '',
            alignToBottom: false
        },
        // Set default step function for all animate calls
        step: function (state, bar) {
            bar.path.setAttribute('stroke', state.color);
            var value = Math.round(bar.value() * 100);
            if (value === 0) {
                bar.setText(0 + "%");
            } else {
                bar.setText(value + "%");
            }
            bar.text.style.color = state.color;
        }
    });
    bar.text.style.fontSize = '2rem';
    bar.animate((percent ? percent / 100 : 0.00));  // Number from 0.0 to 1.0
}

var load = function () {
    var data = validateResult();
    !hasError() && api.learner.courseQuizResult(data, function (success) {
        console.log(success)
        let i = 1;
        if (success && success.success && success.result) {
            clearHtmls();
            if (data.ac == 'Y291cnNl5') {
                $('#lecture-name').html('Lecture Name:- ' + success.result.name);
                $('#total_questions').html(success.result.CourseLectureQuestions.length);
                success.result.CourseLectureQuestions.forEach(function (lectQ) {
                    setQuestions(i, lectQ.CourseQuizQuestion, data.ac);
                    ++i;
                }); 
                $('#correct_questions').html(correctQuestions);
                $('#wrong_questions').html(wrongQuestions);
                if (success.result.CourseUserQuizDetails.length > 0) {
                    semiCircle(success.result.CourseUserQuizDetails[0].percent);
                    let now = new Date(success.result.CourseUserQuizDetails[0].updatedAt);
                    let options = {
                        weekday: 'short',
                        year: 'numeric',
                        month: 'short',
                        day: 'numeric',
                        hour: '2-digit',
                        minute: '2-digit'
                    };
                    $('#written_dateTime').html('Written:- ' + now.toLocaleString('en-US', options));
                }
            } else {
                $('#lecture-name').html('Assessment Name:- ' + success.result.name);
                $('#total_questions').html(success.result.QuizQuestions.length);
                success.result.QuizQuestions.forEach(function (lectQ) {
                    setQuestions(i, lectQ, data.ac);
                    ++i;
                });
                $('#correct_questions').html(correctQuestions);
                $('#wrong_questions').html(wrongQuestions);
                if (success.result.QuizUserDetails.length > 0) {
                    semiCircle(success.result.QuizUserDetails[0].percent);
                    let now = new Date(success.result.QuizUserDetails[0].updatedAt);
                    let options = {
                        weekday: 'short',
                        year: 'numeric',
                        month: 'short',
                        day: 'numeric',
                        hour: '2-digit',
                        minute: '2-digit'
                    };
                    $('#written_dateTime').html('Written:- ' + now.toLocaleString('en-US', options));
                }
            }
        }
    })
}

$(document).ready(function () {
    load();
})