var type= "";
function clearFields(){
    $('#campaign_name').val('');
    $('#campaign_url').val('');
    $('.campaign_group').val('');
    $('input[name="manager_status"]:checked').val('');
}

function validateCampaign() {
    clearErrors();
    var data = {};
    var campaign_course_array = [];
    var campaign_quiz_array = [];
    data.name = sanitize($('#campaign_name').val());
    if (data.name == "")
        addError('nameEr', "Campaign Name is required field.");
    if(type == 'course'){
        $.each($(".campaign_course:checked"), function () {
            campaign_course_array.push($(this).val());
        });
        data.courses = campaign_course_array;
        if (campaign_course_array.length == 0)
            addError('courseEr', "Please select atleast one Course.");
    }
    if(type == 'quiz'){
        $.each($(".campaign_quiz:checked"), function () {
            campaign_quiz_array.push($(this).val());
        });
        data.quizzes = campaign_quiz_array;
        if (campaign_quiz_array.length == 0)
            addError('courseEr', "Please select atleast one Quiz.");
    }
   
    var campaign_group = $('.campaign_group:checkbox:checked').map(function () {
        return this.id;
    }).get();
    data.groups = campaign_group;
    if (campaign_group.length == 0)
        addError('groupEr', "Please select atleast one Department.");

    if($('#default-date').val() != "")
        data.scheduleAt = $('#default-date').val();

    data.isManager = $('input[name="manager_status"]:checked').val();
    if (data.isManager == "")
        addError('managerEr', "Manager Required");

    data.type = (type ? type : "");
    // var regex = /(http|https):\/\/(\w+:{0,1}\w*)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%!\-\/]))?/;
    // if (data.url == "")
    //     addError('urlEr', "URL Required");
    // if (!regex.test(data.url) && data.url != '')
    //     addError('url', 'Please enter valid URL');
    hasError() && showErrors();
    return data;
}

function setSelectedGroup() {
    $('#existing-groups').html('').html('<i class="fa fa-lg fa-tasks"></i>');
    var groups = $('.campaign_group:checkbox:checked').map(function () {
        return $('#existing-groups').append('<span id="grp-'+this.id+'">' + this.value + '<i class="feather icon-x" onclick="removeGroup('+this.id+')"></i></span>');
    }).get().join(",");
}

function removeGroup(grpId) {
    $("#grp-"+grpId+"").remove(); 
    $("#"+grpId+"").prop('checked', false);   
}

function saveCourseCampaign() {
    var data = validateCampaign();
    !hasError() && api.campaign.post(data,function(success){
        clearFields();
        if(success && success.campaignId)
            window.location.replace('/campaign/'+ success.campaignId);
    });
}

function groupHierarchyRender() {
    $("#accordian a").click(function () {
        var link = $(this);
        var closest_ul = link.closest("ul");
        var parallel_active_links = closest_ul.find(".active")
        var closest_li = link.closest("li");
        var link_status = closest_li.hasClass("active");
        var count = 0;
            closest_ul.find("ul").slideUp(function () {
                if (++count == closest_ul.find("ul").length)
                    parallel_active_links.removeClass("active");
            });
        if (!link_status) {
            closest_li.children("ul").slideDown();
            closest_li.addClass("active");
        }
    })
}

$(document).click(function (e) {
    var container = $("#append_groups");
    if ($(e.target).is('#accordian a') || $(e.target).is('#accordian a i') || $(e.target).is('#accordian a input')) {
        container.show();
    }
    else {
        container.hide();
    }

});

function clearExistingGroups() {
    $('ul #append_groups').html('');
}

var childDepartments = function(group){
    if (!$('#append_groups_' + group.parentId).has('ul').length)
        $('#append_groups_' + group.parentId).append('<ul></ul>');
    $('#append_groups_' + group.parentId + ' > ul').append('<li id="append_groups_' + group.id + '"><a><input type="checkbox"  id="' + group.id + '" class="campaign_group" name="groups[]" value="' + group.name + '" onclick="setSelectedGroup()">  ' + group.name + ' ('+group.userCount+' Users)</a></li>')
}


function setGroups(group) {
        $('#append_groups').append('<li id="append_groups_'+group.id+'"><a><input type="checkbox" id="' + group.id + '" value="' + group.name + '" name="groups[]" class="campaign_group" onclick="setSelectedGroup()">  ' + group.name + ' ('+group.userCount+' Users)</a></li>');
}

function getGroups() {
    api.group.existing({id:0}, function (success) {
        console.log(success)
        if (success && success.groups && success.groups.length > 0) {
            clearExistingGroups();
            let i = 0; let arr = {};
            success.groups.forEach(function(group) {
                if(group.parentId == 0) setGroups(group);
                else arr[group.id] = group;
                ++i;
            });
            if(success.groups.length == i){
                Object.keys(arr).forEach(function(g) {
                    childDepartments(arr[g]);
                });
            }
        }
        groupHierarchyRender();
    });
}

function setCourses(courses) {
    $('#campaign_course').html('');
    courses.forEach(function(c) {
        $('#campaign_course').append("<option class='campaign_course' value=" + c.id + ">" + c.name + " - "+capitalizeFirstLetter(c.courseType)+"</option>");
    });
    $('.selectpicker').selectpicker();
}

function setQuizzes(quizzes) {
    $('#campaign_quiz').html('');
    quizzes.forEach(function(q) {
        $('#campaign_quiz').append("<option class='campaign_quiz' value=" + q.id + ">" + q.name + "</option>");
    });
    $('.selectpicker').selectpicker();
}

function getQuizzes(){
    api.campaign.quizList(undefined, function (success) {
        if (success && success.quizzes && success.quizzes.length > 0) {
            $('#select_courses').html(' <label>Assessments</label> <select class="selectpicker form-control" multiple data-actions-box="true" data-live-search="true" name="campaign_quiz" id="campaign_quiz" > </select>')
            setQuizzes(success.quizzes);
        }else {
            $('#select_courses').html('<label>Assessments</label> <select class="selectpicker form-control" data-live-search="true" name="campaign_quiz" id="campaign_quiz" style="display:block !important;" ><option>No Assessment Found</option> </select>');
        }

    });
}

function getCourses() {
    api.campaign.courseList(undefined, function (success) {
        if (success && success.course && success.course.length > 0) {
            $('#select_courses').html(' <label>Courses</label> <select class="selectpicker form-control" multiple data-actions-box="true" data-live-search="true" name="campaign_course" id="campaign_course" > </select>')
            setCourses(success.course);
        }else $('#select_courses').html('<label>Courses</label> <select class="selectpicker form-control" data-live-search="true" name="campaign_course"  style="display:block !important;" id="campaign_course" ><option>No Course Found</option> </select>')
    });
}

function queryString(){
    var queryString = window.location.search.substring(1);
    var varArray = queryString.split("=");
    var param = varArray[1];
    return param;
}

$(document).ready(function () {
    type = queryString();    
    $('input[name="datetimes"]').daterangepicker({
        timePicker: true,
        startDate: moment().startOf('hour'),
        endDate: moment().startOf('hour').add(32, 'hour'),
        locale: {
            format: 'M/DD hh:mm A'
        }
    });
    // $('#campaign_url').val(window.location.origin);
    getGroups();
    if(type == 'quiz')
        getQuizzes()
    if(type == 'course')
        getCourses();
});


