var courseId = page.courseId;
var sortBy = 'recent';
var sortByPer = {};
var sessionValue = 0;
var items1 = []

var searchQuery = function () {
    setPage(1);
    setStudentList(false);
}

var sort = function (type) {
    sortBy = type;
    setStudentList(true);
}

var sortByPercentage = function (start, end) {
    sortByPer.start = start;
    sortByPer.end = end;
    if (start == '' && end == '')
        sortByPer = {};
    setStudentList(true);
}


function setList(memberData) {
    $("#exportId").css("display", "block");
    var member = memberData.Member;
    $('#members tbody').append('<tr><td  style="cursor: pointer;"><a href="javascript:void(0)" onclick="userTracking(' + memberData.sessionId + ',' + memberData.CourseId + ')" data-target=".user_tracking_list" data-toggle="modal">' + member.firstName + ' ' + (member.lastName ? member.lastName : '') + '<!--</a>--></td> <td>' + member.email + '</td><td>' + (memberData.createdAt ? memberData.createdAt.substr(0, 10) : '-') + '</td> <td>' + (memberData.updatedAt > memberData.createdAt ? memberData.updatedAt.substr(0, 10) : '-') + '</td> <td>' + parseFloat(memberData.percent) + '%</td> </tr>')
}

function paginationData(count) {
    setLimit(count);
    setPage(1);
    setStudentList(true)
}

function clearUserList() {
    $('#members tbody').html('');
    $('#pagecount').html('');
    $('#pagination').html('');
    $('#gotopage').html('');
}

var validate = function () {
    var data = new Object();
    data.courseId = courseId;
    data.search = $('#searchBar').val();
    if (data.search.length < 3)
        data.search = undefined;
    data.sort = sortBy;
    if (Object.keys(sortByPer).length > 0)
        data.percentage = sortByPer;
    data.page = getPageNo();
    data.limit = getLimit();
    return data;
}


function setStudentList(noloader) {
    var data = validate();
    api.analytic.studentList(data, function (success) {
        // console.log(success)
        clearUserList();
        if (success && success.courseMembers.length > 0) {
            success.courseMembers.forEach(function (member) {
                setList(member);
            })
            if (success.pages && success.count)
                addPagination(success.pages, success.count);
        } else $('#members tbody').html('<td>No Student Found</td>');
    }, function (error) {
        $('#members tbody').html('<td> No Student Found</td>');
    }, noloader);
}

var reloadList = function () {
    setStudentList(true);
}

var download = function (content, fileName, mimeType) {
    var a = document.createElement('a');
    mimeType = mimeType || 'application/octet-stream';

    if (navigator.msSaveBlob) { // IE10
        navigator.msSaveBlob(new Blob([content], {
            type: mimeType
        }), fileName);
    } else if (URL && 'download' in a) { //html5 A[download]
        a.href = URL.createObjectURL(new Blob([content], {
            type: mimeType
        }));
        a.setAttribute('download', fileName);
        document.body.appendChild(a);
        a.click();
        document.body.removeChild(a);
    } else {
        location.href = 'data:application/octet-stream,' + encodeURIComponent(content); // only this mime type is supported
    }
}

var setDetails = function (data) {
    var items = [];
    items.push([
        'Sr No.',
        'Name',
        'Email',
        'Enrolled',
        'Last Visited',
        'Progress',
    ]);
    var count = 1;
    for (var i = 0; i < data.length; i++) {
        items.push([
            count++,
            (data[i].Member.firstName ? data[i].Member.firstName : '') + ' ' + (data[i].Member.lastName ? data[i].Member.lastName : ''),
            (data[i].Member.email ? data[i].Member.email : '-'),
            (data[i].createdAt ? data[i].createdAt.substr(0, 10) : '-'),
            (data[i].updatedAt > data[i].createdAt ? data[i].updatedAt.substr(0, 10) : '-'),
            (data[i].percent ? parseFloat(data[i].percent) + '%' : '-')
        ]);
    }
    // console.log(items)
    var csvContent = '';
    items.forEach(function (infoArray, index) {
        dataString = infoArray.join(',');
        csvContent += index < items.length ? dataString + '\n' : dataString;
    })
    // console.log(csvContent)
    download(csvContent, 'student.csv', 'text/csv;encoding:utf-8');
}

function exportStudentCSV() {
    var data = {};
    data.courseId = courseId;
    if (Object.keys(sortByPer).length > 0)
        data.percentage = sortByPer;
    data.type = 'CSV';
    data.sort = sortBy
    api.analytic.studentList(data, function (success) {
        if (success) {
            setDetails(success.courseMembers);
        }
    });
}

function clearStudents() {
    $('#accordionExample').html('')
}

function userTracking(sessionId, cId, noloader) {
    sessionValue = sessionId;
    var data = new Object();
    data.courseId = cId;
    data.sessionId = sessionId;
    api.analytic.userTrackingList(data, function (success) {
        // console.log(success)
        if (success && Object.keys(success.finalresult).length > 0) {
            $("#exportStudent").css("display", "block");
            clearStudents();
            let quiz_percentage = 0;
            quiz_percentage = JSON.parse(success.finalresult.setting).quiz_passing_percentage;
            success.finalresult.CourseSections.forEach(function (element, i) {
                setStudent(element, i, quiz_percentage);
            })
        } else $('#accordionExample').html('<td>No Student Found</td>');
    }, function (error) {
        $('#accordionExample').html('<td> No Student Found</td>');
    }, noloader);
}

function setStudent(studentData, index, quiz_percentage) {
    let data = '', status = '', color = '';
    let collapsedshow = 'collapsed', showcollapse = '';
    let temp_arr = [];
    studentData.CourseSectionLectures.forEach((element, i) => {
        if (element.CourseUserQuizDetails.length > 0 && element.SessionCourseLectureTrackings.length > 0) {
            element.CourseUserQuizDetails.forEach(ele => {
                element.SessionCourseLectureTrackings.forEach(ele1 => {
                    if (parseInt(quiz_percentage) <= Math.round(ele.percent)) {
                        status = 'PASS';
                        color = 'green';
                    } else {
                        status = 'FAIL';
                        color = 'red';
                    }
                    temp_arr.push([
                        (element.name ? element.name : '-'),
                        ele1.percent,
                        ele.maxMarks,
                        ele.obtainedMarks,
                        ele.attempts,
                        ele.percent,
                        status,
                        color
                    ])
                })
            })
        } else if (element.CourseUserQuizDetails.length > 0) {
            element.CourseUserQuizDetails.forEach(ele => {
                if (parseInt(quiz_percentage) <= Math.round(ele.percent)) {
                    status = 'PASS';
                    color = 'green';
                } else {
                    status = 'FAIL';
                    color = 'red';
                }
                temp_arr.push([
                    (element.name ? element.name : '-'),
                    0,
                    ele.maxMarks,
                    ele.obtainedMarks,
                    ele.attempts,
                    ele.percent,
                    status,
                    color
                ])
            })
        } else if (element.SessionCourseLectureTrackings.length > 0) {
            element.SessionCourseLectureTrackings.forEach(ele => {
                status = '-'
                temp_arr.push([
                    (element.name ? element.name : '-'),
                    ele.percent,
                    '-',
                    '-',
                    '-',
                    '-',
                    status,
                    color
                ])
            })
        }
        else {
            status = '-'
            temp_arr.push([
                (element.name ? element.name : '-'),
                0,
                '-',
                '-',
                '-',
                '-',
                status,
                color
            ])
        }
    })
    if (index == 0) {
        collapsedshow = '';
        showcollapse = 'show'
    }
    temp_arr.forEach((finalval, i) => {
        let value = `${finalval[5].split('.')[0]}%`
        if (value == '-%')
            value = '-';
        data += `<tr><td>${i + 1}</td><td style="width:30%">${finalval[0]}</td><td style="width:20%"><div class="progress"><div class="progress-bar" role="progressbar" style="width:${finalval[1]}%" aria-valuenow="0"aria-valuemin="0" aria-valuemax="100">${finalval[1]}%</div></div></td><td>${finalval[2]}</td><td>${finalval[3]}</td><td>${finalval[4]}</td><td>${value}</td><td><b style="color:${finalval[7]}">${finalval[6]}</b></td></tr>`
    })
    $('#accordionExample').append(`<div class="card"><div class="card-header" id="headingOne"><h2 class="mb-0"><button class="btn btn-link ${collapsedshow}" type="button" data-toggle="collapse" data-target="#collapseOne${studentData.id}" aria-expanded="false" aria-controls="collapseOne">${studentData.name}</button></h2></div><div id="collapseOne${studentData.id}" class="collapse ${showcollapse}" aria-labelledby="headingOne" data-parent="#accordionExample"style=""><div class="card-body"><div class="table-responsive"><table class="table" id="students_list"><thead class="thead-light"><tr><th scope="col">#</th><th scope="col">Lecture Name</th><th scope="col">Lecture Progress</th> <th scope="col">Max Marks</th> <th scope="col">Marks Obtained</th><th scope="col">Attempts</th><th scope="col">Score(%)</th><th scope="col">Status</th></tr></thead><tbody>${data}</tbody></table></div></div></div></div>`)
}

function exportStudentTrackingCSV() {
    var data = {};
    data.courseId = courseId;
    data.sessionId = sessionValue;
    data.type = 'CSV';
    api.analytic.userTrackingList(data, function (success) {
        if (success) {
            let quiz_percentage = 0;
            quiz_percentage = JSON.parse(success.finalresult.setting).quiz_passing_percentage;
            success.finalresult.CourseSections.forEach(function (element) {
                setStudentCSV(element,quiz_percentage);
            })
        }
    });
}

function setStudentCSV(data,quiz_percentage) {
    let status = '';
    items1.push([
        'Sr No.',
        'Section Name',
        'Lecture Name',
        'Lecture Progress',
        'Max Marks',
        'Marks Obtained',
        'Attempts',
        'Score(%)',
        'Status'
    ]);
    data.CourseSectionLectures.forEach((element, i) => {
        if (element.CourseUserQuizDetails.length > 0 && element.SessionCourseLectureTrackings.length > 0) {
            element.CourseUserQuizDetails.forEach(ele => {
                element.SessionCourseLectureTrackings.forEach(ele1 => {
                    if (parseInt(quiz_percentage) <= Math.round(ele.percent)) {
                        status = 'PASS';
                    } else {
                        status = 'FAIL';
                    }
                    items1.push([
                        ++i,
                        (data.name ? data.name : ''),
                        (element.name ? element.name : '-'),
                        ele1.percent,
                        ele.maxMarks,
                        ele.obtainedMarks,
                        ele.attempts,
                        ele.percent,
                        status
                    ])
                })
            })
        } else if (element.CourseUserQuizDetails.length > 0) {
            element.CourseUserQuizDetails.forEach(ele => {
                if (parseInt(quiz_percentage) <= Math.round(ele.percent)) {
                    status = 'PASS';
                } else {
                    status = 'FAIL';
                }
                items1.push([
                    ++i,
                    (data.name ? data.name : ''),
                    (element.name ? element.name : '-'),
                    'NA',
                    ele.maxMarks,
                    ele.obtainedMarks,
                    ele.attempts,
                    ele.percent,
                    status
                ])
            })
        } else if (element.SessionCourseLectureTrackings.length > 0) {
            element.SessionCourseLectureTrackings.forEach(ele => {
                items1.push([
                    ++i,
                    (data.name ? data.name : ''),
                    (element.name ? element.name : '-'),
                    ele.percent,
                    'N/A',
                    'N/A',
                    'N/A',
                    'N/A',
                    'N/A'
                ])
            })
        }
        else {
            items1.push([
                ++i,
                (data.name ? data.name : ''),
                (element.name ? element.name : '-'),
                'N/A',
                'N/A',
                'N/A',
                'N/A',
                'N/A',
                'N/A'
            ])
        }
    })
    let csvContent = '';
    let dataString1 = '';
    // console.log(items1)
    items1.forEach(function (infoArray, index) {
        dataString1 = infoArray.join(',');
        csvContent += index < items1.length ? dataString1 + '\n' : dataString1;
    })
    download(csvContent, 'studentTracking.csv', 'text/csv;encoding:utf-8');
}

$(document).on('hide.bs.modal', '.user_tracking_list', function (e) {
    $('#accordionExample').html('')
    items1 = [];
});

$(document).ready(function () {
    setStudentList(true);
});