var lectureId = page.lectureId;
var sortBy = 'recent';
var courseId;
var sortByPer = { };

var resendFailureReminder = function(){
    swal({ title: "Warning", type: "warning", text: "Are you sure you want to resend the failure reminder?", showCancelButton: true })
    .then(function(r){
        var data = new Object();
        data.lId = parseInt(lectureId);
        data.cId = courseId;
        api.analytic.resend(data,function (success){
            // console.log(success)
            if(success && success.success && success.hasOwnProperty('members') && success.members == false){
                clearErrors();
                addError('resend', 'No failed student found.')
                hasError() && showErrors();
            } else  showSuccess('Resend failure reminder mail is succussfully send.');
        })
    })
}

var searchQuery = function(){
    setPage(1);
    setStudentList(false);
}

var sort = function(type){
    sortBy = type;
    setStudentList(true);
}

var sortByPercentage = function(start, end){
    sortByPer.start = start;
    sortByPer.end = end;
    if(start == '' && end == '')
        sortByPer = { };
    setStudentList(true);
}


function setList(memberData, quiz_percentage,maxMarks) {
    $("#exportId").css("display","block");
    let member = memberData.Member;
    let length_data = memberData.Session.CourseUserQuizDetails.length;
    let status = '',obtainedMarks=0,percentage='',attempts=0;
    if(length_data == 0){
        obtainedMarks = 0;
        percentage = '0%';
        attempts = 0;
    }else{
        memberData.Session.CourseUserQuizDetails.forEach(ele=>{
            obtainedMarks = ele.obtainedMarks;
            percentage = ele.percent;
            attempts = ele.attempts;
        })
    }
    if (length_data == 0) {
        status = 'Not attempted';
        color = 'orange';
    }else if(parseInt(quiz_percentage) <= Math.round(memberData.percent)){
        status = 'PASS';
        color = 'green';
    }else{
        status = 'FAIL';
        color = 'red';
        $('#resend_failure').show();
    }
    $('#members tbody').append('<tr> <td>' + member.firstName + ' ' + (member.lastName ? member.lastName : '') + '</td> <td>'+member.email+'</td><td>' + maxMarks + '</td> <td>' + obtainedMarks + '</td> <td>'+parseFloat(percentage)+'%</td> <td>'+attempts+'</td> <td><b style="color:'+color+'">'+status+'</b></td><td><a style="cursor: pointer;color: #0080ff;" onclick="showSwal(\'' + status + '\')" '+(length_data != 0 ? 'href="/quiz-results?lId='+lectureId+'&sKey='+memberData.Session.sessionKey+'&ac=Y291cnNl5"' : '')+' title="View Result" target="_blank"><i class="fa fa-list-alt" aria-hidden="true"></i> View</a></td></tr>')
}

function showSwal(status){
    if(status == 'Not attempted') swal({ title: "Warning", type: "warning", text: "Quiz is not attempted, please try another result" })
}

function paginationData(count){
    setLimit(count);
    setPage(1);
    setStudentList(true)
}

function clearUserList(){
    $('#members tbody').html('');
    $('#pagecount').html('');  
    $('#pagination').html('');  
    $('#gotopage').html('');
}

var validate = function(){    
    var data = new Object();
    data.lectureId = lectureId;
    data.search = $('#searchBar').val();
    if(data.search.length < 3)
        data.search = undefined;
    data.sort = sortBy;
    if(Object.keys(sortByPer).length > 0)
        data.percentage = sortByPer;
    data.page = getPageNo();
    data.limit = getLimit();
    return data;
}

function setStudentList(noloader) {
    var data = validate();
    api.analytic.studentQuizResult(data, function (success) {
        clearUserList();
        if(success && success.course){
            courseId = success.course.CourseSection.Course.id;
            var quiz_percentage = 0;
            if(success.course && success.course.CourseSection &&  success.course.CourseSection.Course && success.course.CourseSection.Course.setting)
                quiz_percentage = JSON.parse(success.course.CourseSection.Course.setting).quiz_passing_percentage;
        }
        if (success && success.courseMembers.length > 0) {
            success.courseMembers.forEach(function(member) {
                setList(member, quiz_percentage,success.maxMarks);
            })
            if(success.pages && success.count)
                addPagination(success.pages, success.count);    
        }else $('#members tbody').html('<td>No Student Found</td>');
       
    }, function(error) {
        $('#members tbody').html('<td> No Student Found</td>');
    }, noloader);
}

var reloadList = function() {
    setStudentList(true);
}

var download = function(content, fileName, mimeType) {
    var a = document.createElement('a');
    mimeType = mimeType || 'application/octet-stream';
  
    if (navigator.msSaveBlob) { // IE10
      navigator.msSaveBlob(new Blob([content], {
        type: mimeType
      }), fileName);
    } else if (URL && 'download' in a) { //html5 A[download]
      a.href = URL.createObjectURL(new Blob([content], {
        type: mimeType
      }));
      a.setAttribute('download', fileName);
      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
    } else {
      location.href = 'data:application/octet-stream,' + encodeURIComponent(content); // only this mime type is supported
    }
}

var setDetails = function(data, quiz_percentage,maxMarks) {
    let status = '';
    let items = [];
    let count = 1;
    let obtainedMarks = 0,percentage='',attempts=0,len=0;
    if(data.length > 0){
        items.push([
            'Sr No.',
            'Name',
            'Email',
            'Max Marks',
            'Mark Obtained',
            'Percentage',
            'Attempts',
            'Status'
        ]);
        data.forEach(ele=>{
            len = ele.Session.CourseUserQuizDetails.length;
            // console.log(len)
            if(len == 1){
                ele.Session.CourseUserQuizDetails.forEach(ele1=>{
                    obtainedMarks = ele1.obtainedMarks;
                    percentage = ele1.percent;
                    attempts = ele1.attempts;
                })
            }else{
                obtainedMarks = 0;
                percentage = 0;
                attempts = 0;
            }
            if(len == 0) status = 'NOT ATTEMPTED';
            else if(parseInt(quiz_percentage) <= Math.round(percentage)) status = 'PASS';
            else status = 'FAIL';
            items.push([
                count++,
                (ele.Member.firstName ? ele.Member.firstName : '') +' '+(ele.Member.lastName ?ele.Member.lastName : ''),
                (ele.Member.email ? ele.Member.email : '-'),
                (maxMarks ?  maxMarks : 0),
                (obtainedMarks ? obtainedMarks : 0),
                (percentage ? parseFloat(percentage)+'%' : '-'),
                (attempts ?  attempts : 0),
                (status != '' ? status : status)
            ]);
        });
        // console.log(items)
        var csvContent = '';
        items.forEach(function(infoArray, index) {
            dataString = infoArray.join(',');
            csvContent += index < items.length ? dataString + '\n' : dataString;
        })
        download(csvContent, 'student.csv', 'text/csv;encoding:utf-8');
    }else {
        addError('eree', 'No Data Found.')
        hasError() && showErrors();
    }
}

function exportStudentCSV(){
        var data = {};
        data.lectureId = lectureId;
        if(Object.keys(sortByPer).length > 0)
            data.percentage = sortByPer;
        data.type = 'CSV';
        api.analytic.studentQuizResult(data, function (success) {
            if (success) {
                if(success.course){
                    var quiz_percentage = 0;
                    if(success.course && success.course.CourseSection &&  success.course.CourseSection.Course && success.course.CourseSection.Course.setting)
                        quiz_percentage = JSON.parse(success.course.CourseSection.Course.setting).quiz_passing_percentage;
                }
                setDetails(success.courseMembers, quiz_percentage,success.maxMarks);
            }
        });
}

$(document).ready(function () {
    setStudentList(true);
});