import { db } from './models';
import nodeScheduler from 'node-schedule';
import { queue } from './kue';

var scheduler = {
    init: () => {
        // db.Simulation.findAll({
        //     where: {
        //         isScheduled: 1
        //     }
        // })
        // .then(simulations => {
        //     simulations = JSON.parse(JSON.stringify(simulations));
        //     simulations.forEach((simulation) => {
        //         scheduler.scheduleSimulation(simulation.id, simulation.scheduledAt);
        //     });
        // });
    },
    scheduleSimulation: (simulationId, scheduledAt, data, companyId) => {
        if(typeof scheduledAt === 'string'){
            scheduledAt = new Date(scheduledAt);
        }
        if(scheduledAt <= new Date()){
            return db.Simulation.update({ launchedAt: new Date()  }, { where: { id: simulationId }})
            .then(r => {
                return queue.create('simulation', {
                    simulationId: simulationId,
                    campaignId: data.campaignId,
                    courses:  (data.courses ? data.courses : null),
                    quizzes:  (data.quizzes ?data.quizzes : null),
                    type: data.type,
                    companyId: companyId
                }).save();
            })
        }
        // else{
        //     nodeScheduler.scheduleJob(scheduledAt, function(simulationId){
        //         db.Simulation.update({
        //             launchedAt: new Date()
        //         }, { where: { id: simulationId }});
        //         queue.create('simulation', {
        //             simulationId: simulationId,
        //             campaignId: data.campaignId,
        //             courses:  (data.courses ? data.courses : null),
        //             quizzes:  (data.quizzes ?data.quizzes : null),
        //             type: data.type,
        //             companyId: companyId
        //         }).save();
        //     }.bind(null, simulationId));
        // }
    },

    // expiredSimulation: (simulationId, scheduledAt) => { 
    //     nodeScheduler.scheduleJob(scheduledAt, function(simulationId){
    //         db.simulation.update({
    //             completedAt: new Date()
    //         }, { where: { id: simulationId }});
    //     }.bind(null, simulationId));
    // }
}

export default scheduler;