import { db } from "../../../../models";

export default {
    async register(req, res) {
        res.render('register', {layout: 'auth'});
    },

    async free_trial(req, res) {
        res.render('free-trial', {layout: 'auth'});
        
    },

    async login(req, res) {
        if(req.query && req.query.sKey){
            db.Session.findOne({ 
                where: { sessionKey: req.query.sKey }, 
                include: [{ model: db.Member }] 
            })
            .then(session =>{ 
                if(session)
                    res.render('login', {layout: 'auth', etXe35a: session.Member.email});
                else res.status(500).send('Invalid data received.!');
            })            
        }else  res.render('login', {layout: 'auth', etXe35a: null});
    },

    async logout(req, res) {
        var type= '';
        if(req.user){
            req.user.update({loggedOutAt: new Date()});
        }
        res.clearCookie("XSRF-token");
        return res.redirect('/'+type+'login');
    },

    async verifyMessage(req, res) {
        res.render('verify', {layout: 'auth'});
    },

    async unPublished(req, res) {
        res.render('unpublished', {layout: 'auth'});
    },

    async verify(req, res) {
        if(req.params.email && req.params.token){
            db.MetaAuth.findOne({ where: { email: req.params.email} })
            .then(meta => {
                if(meta) return  db.MetaAuth.findOne({ where: { email: req.params.email, verf_key: req.params.token} })
                else  throw { name: 'PRAException',  msg: 'Invalid Email received.!' }
            })
            .then(meta => {
                if(meta && meta != 'null' || meta != null) return db.MetaAuth.update( {valid : 1, verf_key: null}, { where: { email : req.params.email}, returning:true })
                else throw { name: 'PRAException',  msg: 'Invalid Token received.!' }
            })
            .then(result => {
                if(result) return res.render('verifySuccess', {layout: 'auth', message: "Email Verified Successfully"});
                else throw { name: 'PRAException',  msg: 'Error Verification!' }
            })
            .catch(err => {
                console.log(err);
                if(err && err.name && err.name == 'PRAException') return res.status(403).send(err.msg);
                else return res.status(500).send('Error!');
            })
        }else res.status(500).send('Invalid data received.!');
    },

    async sendReset(req, res) {
        res.render('sendReset', {layout: 'auth'});
    },

    async reset(req, res) {
        if(req.params.email && req.params.token){
            db.MetaAuth.findOne({ where: { email: req.params.email} })
            .then(meta => {
                if(meta) return db.MetaAuth.findOne({where: {email: req.params.email, verf_key: req.params.token  }})
                else  throw { name: 'PRAException',  msg: 'Invalid Email received.!' }
            })
            .then(meta => {
                if(meta)  return res.render('reset', {email: req.params.email, verf_key: req.params.token, layout: 'auth'});
                else throw {  name: 'PRAException',  msg: 'Invalid Token received.!'  }
            })
            .catch(err => {
                console.log(err);
                if(err && err.name && err.name == 'PRAException') return res.status(403).send(err.msg);
                else return res.status(500).send('Error!');
            })
        }else res.status(500).send('Invalid data received.!');
    },

    async changepassword(req,res){
        res.render('change-password');
    },

    async notFound(req, res) {
        res.render('404', {layout: 'auth'});
    },

};