import express from 'express';
import { jwtLogoutStrategy, jwtStrategy , } from '../../../../middleware/strategy';
import authController from './auth.controller';
import { loginCheck } from '../../../../middleware/auth';
import { userImplant } from '../../../../middleware/auth';

export const authRouter = express.Router();
authRouter.route('/r-lms-krademy').get(loginCheck(), authController.register);
authRouter.route('/free-trial').get(authController.free_trial);
authRouter.route('/login').get(loginCheck(), authController.login);
authRouter.route('/logout').get(jwtLogoutStrategy, authController.logout);
authRouter.route('/verify').get(authController.verifyMessage);
authRouter.route('/unpublished').get(authController.unPublished);
authRouter.route('/verify/:email/:token').get(authController.verify);
authRouter.route('/reset').get(authController.sendReset);
authRouter.route('/reset/:email/:token').get(authController.reset);
authRouter.route('/change-password/').get(jwtStrategy, userImplant, authController.changepassword);
authRouter.route('/404').get(authController.notFound);
 