import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import courseController from './course.controller';
import { userPermission} from '../../../../middleware/userPermission';
import { userImplant } from '../../../../middleware/auth';

export const courseRouter = express.Router();
courseRouter.route('/course/list').get(jwtStrategy , userImplant, userPermission('course-list'),courseController.index);
courseRouter.route('/course/create').get(jwtStrategy , userImplant, userPermission('course-write'),courseController.add);
// courseRouter.route('/course/course-setting').get(jwtStrategy, userImplant, userPermission('course-setting-read'),courseController.courseSetting);
courseRouter.route('/course/create/:id').get(jwtStrategy, userImplant, userPermission('course-write'),  courseController.edit);
courseRouter.route('/get-url').get(courseController.get_url);