import { db } from "../../../../models";

export default {
    async index(req, res, next) {
        return res.render('course-analytic');
    },

    async courseSingle(req, res, next) {
        db.Course.findOne({ where :{ id: req.params.id, courseType: 'streaming', status: 'Published', companyId: req.user.companyId }})
        .then(r => {
            if(r) return res.render('course-analytic-list', {id: req.params.id });
            else  return res.render('404'); 
        })
    },

    async studentList(req, res, next) {
        db.Course.findOne({ where :{ id: req.params.id, courseType: 'streaming', status: 'Published', companyId: req.user.companyId }})
        .then(r => {
            if(r) return res.render('student-list', {id: req.params.id});
            else  return res.render('404'); 
        })
    },

    async lectureList(req, res, next) {
        db.Course.findOne({ where :{ id: req.params.id, courseType: 'streaming', status: 'Published', companyId: req.user.companyId }})
        .then(r => {
            if(r) return res.render('lecture-list', {id: req.params.id});
            else  return res.render('404'); 
        })
    },

    async studentQuizResult(req, res, next) {
        db.CourseSectionLecture.findOne({ where :{ id: req.params.id }, include:[{ model: db.CourseSection, include:[{ model:db.Course, where: { courseType: 'streaming', status: 'Published', companyId: req.user.companyId} }] }] })
        .then(r => {
            if(r) return res.render('student-quiz-result', {id: req.params.id});
            else  return res.render('404'); 
        })
    },

    async singleStudent(req, res, next) {
        return res.render('single-student');
    },

    async department(req, res, next) {
        return res.render('departments-list');
    },
};