import { db } from "../../../../models";
const fs = require("fs");
import config from '../../../../config';
import { queue } from '../../../../kue';

var getDetail = function(req){
    var detail = {}, ip = req.headers["x-real-ip"] || req.ip;
    detail.user_agent = req.headers['user-agent'];
    detail.systemDetail = req.headers['user-agent'];
    detail.ip = ip;
    return detail;
}

export default {
    async index(req, res, next) {
        return res.render('learner-course');
    },

    async courseAuth(req, res, next) {
        if(req.query && req.query.sKey && req.query.rmId){
            var id = decrypt(req.query.rmId); var condition;
            if(req.query.t == 1) condition =  { courseId: id, memberId: req.user.memberId };
            else condition = { quizId: id, memberId: req.user.memberId }
            queue.create('session-link-clicked', { sKey: req.query.sKey, metaData: JSON.stringify(getDetail(req)) }).removeOnComplete(true).save();
            db.MemberCourse.findOne({ where: condition })
            .then(result =>{
                return db.Session.findOne({ where:{ id: result.sessionId} }).then(r => [r.sessionKey, result])
            })
            .then(([sessionKey, result]) =>{
                if(result && result.courseId != null && req.query.t == 1)
                   return res.redirect('course/'+id+'/'+sessionKey);
                else{
                    if(result.completedAt != null)
                        return res.redirect('my-assessments/result/'+id+'/'+sessionKey);
                    else  return res.redirect('my-assessments/guidelines/'+id+'/'+sessionKey);
                } 
            })
            .catch(err => {
                console.log(err);
            })
        }else res.status(500).send('Invalid data received.!');
    },

    async setPassword(req, res, next) {
        if(req && req.query.token && req.query.redirectTo && req.query.sKey){
            db.MetaAuth.findOne({ where: { verf_key: req.query.token } })
            .then(meta => {
                if(meta) return res.render('set-password', {layout: 'auth', token: req.query.token, redirectTo: encodeURIComponent(req.query.redirectTo+'&t='+req.query.t+'&sKey='+req.query.sKey)});
                else return res.render('404');
            })
            .catch(err => {
                console.log(err);
                res.status(500).send('Invalid data received.!');
            })
        }else{
            res.status(403).send('Invalid data received.!');
        }
        
    },
    async quizleaderBoard(req, res, next) {
        return res.render('quiz-learner-board');
    },
    async quizStart(req, res, next) {
        return res.render('startquiz', {layout:'startquiz', 'id':req.params.id, 'sKey':req.params.sKey });
    },

    async previewCourse(req, res, next) {
        if(req.params.id > 0){ 
            db.Course.findOne({where: {id: req.params.id},attributes:['name', 'description', 'courseType', 'instructorDetail']})
            .then(course => {
                if(course){
                    return res.render('learner-reader', {'id': req.params.id, pv: true, 'type': course.courseType  });
                }else{
                    throw 'Course not found';
                }
            })
        }else{
            res.status(500).send('Invalid Data Received.!');
        }
    },
    async edit(req, res, next) {
        if(req.params.id > 0 && req.params.sKey){ 
            db.Course.findOne({where: {id: req.params.id}, attributes:['id', 'name', 'description', 'courseType', 'status','instructorDetail' ]})
            .then(course => {
                if(course){
                    if(course.status == 'Published')
                        return db.Session.findOne({ where : { sessionKey: req.params.sKey } }).then(r => [r, course, false])
                    else return [false, false, true]
                }else{
                    throw 'Course not found';
                }
            })
            .then(([session, course, check]) => {
                if(!check){
                    if(session){
                       return db.MemberCourse.findOne({ where : { memberId: req.user.memberId, courseId: course.id } }).then(r => [r, session, course, check])
                    }else throw 'Invalid token received';
                }else return [false, false, false, check];
            })
            .then(([memberCourse, session, course, check]) => {
                if(!check){
                    if(memberCourse){
                        if(course.courseType == 'instructor' && course.instructorDetail){
                            var fullName = session.firstName+(session.lastName ? "+"+session.lastName : '');
                            var meet_meta = JSON.parse(course.instructorDetail);
                            var data = "fullName="+fullName+"&meetingID="+meet_meta.meetingId+"&password=ap&redirect=true";
                            var checksum = createChecksum('join', data);
                        }
                        return res.render('learner-reader', {'id': req.params.id, 'rmId': (session.companyId == 132 ?  encrypt(req.params.id): ''), 'sKey': req.params.sKey, pv: false, 'type': course.courseType , urlKey: (course.courseType == 'instructor' ? checksum : ''), 'qWE34sT': memberCourse.percent });
                    }else throw 'Invalid learner received.!';
                }else return res.render('unpublished');
            })
            .catch(err => {
                console.log(err)
                res.status(500).send('Course doesn\'t Exists');
            })
        }else{
            res.status(500).send('Invalid Data Received.!');
        }
    },
    async quizInstruction(req, res, next) {
        if(req.params.id > 0 && req.params.sKey){
            db.Quiz.findOne({ where : { id: req.params.id }})
            .then(quiz => {
                if(quiz)
                    return db.Session.findOne({ where : { sessionKey: req.params.sKey } })
                else  throw 'Quiz not found';
            })
            .then(session => {
                if(session)
                    return db.MemberCourse.findOne({ where : { memberId: req.user.memberId, quizId: req.params.id} })
                else throw 'Invalid Quiz received';
            })
            .then(memberCourse => {
                if(memberCourse)
                    return res.render('startquiz-overview', {'id': req.params.id, 'sKey': req.params.sKey });
                else throw 'Invalid Member Test received';
            })
            .catch(err => {
                res.status(500).send('Quiz doesn\'t Exists');
            })
        }else{
            res.status(403).send('Invalid data received.!');
        }
    },

    async logout(req, res) {
        return res.render('bigbluebutton-logout');
    },

    async meetingEnd(req, res) {
        var courseId = req.query.courseId;
        var meetingId = req.query.meetingId;
        db.Course.findOne({where : { id : courseId}})
        .then(course => {
            if(course){
                var instructorData = JSON.parse(course.instructorDetail);
                if(meetingId == instructorData['meetingId']){
                    instructorData['expired'] = 1;
                    return db.Course.update({instructorDetail : JSON.stringify(instructorData)},{where : { id : courseId}});
                }else throw 'Invalid Meeting Id';
            }
        })
        .then(update => {
            if(update)
                res.status(200).send('Update Successfully');
        })
    },

    async streaming(req, res) {
        const options = {}; let start; let end;
        var filePath = appRoot+"/public/course/content/"+req.params.name;
        if(fs.existsSync(config.storage.folder+"/"+config.storage.course_content+"/"+req.params.name))
            filePath = config.storage.folder+"/"+config.storage.course_content+"/"+req.params.name;
        const range = req.headers.range;
        if (range){
            const bytesPrefix = "bytes=";
            if (range.startsWith(bytesPrefix)) {
                const bytesRange = range.substring(bytesPrefix.length);
                const parts = bytesRange.split("-");
                if (parts.length === 2) {
                    const rangeStart = parts[0] && parts[0].trim();
                    if (rangeStart && rangeStart.length > 0) {
                        options.start = start = parseInt(rangeStart);
                    }
                    const rangeEnd = parts[1] && parts[1].trim();
                    if (rangeEnd && rangeEnd.length > 0) {
                        options.end = end = parseInt(rangeEnd);
                    }
                }
            }
        }else{
            return res.status(400).send("You don\'t have permission to access '/video/'"+req.params.name+' on this server.');
        } 
        res.setHeader("content-type", "video/mp4");
        fs.stat(filePath, (err, stat) => {
            if (err) {
                console.error(`File stat error for ${filePath}.`);
                console.error(err);
                res.sendStatus(500);
                return;
            }
            let contentLength = stat.size;
            if (req.method === "HEAD") {
                res.statusCode = 200;
                res.setHeader("accept-ranges", "bytes");
                res.setHeader("content-length", contentLength);
                res.end();
            }else{       
                let retrievedLength;
                if (start !== undefined && end !== undefined)  retrievedLength = (end+1) - start;
                else if (start !== undefined) retrievedLength = contentLength - start;
                else if (end !== undefined) retrievedLength = (end+1);
                else retrievedLength = contentLength;
                res.statusCode = start !== undefined || end !== undefined ? 206 : 200;
                res.setHeader("content-length", retrievedLength);
                if (range !== undefined) {  
                    res.setHeader("content-range", `bytes ${start || 0}-${end || (contentLength-1)}/${contentLength}`);
                    res.setHeader("accept-ranges", "bytes");
                }
                const fileStream = fs.createReadStream(filePath, options);
                fileStream.on("error", error => {
                    console.log(`Error reading file ${filePath}.`);
                    console.log(error);
                    res.sendStatus(500);
                });
                fileStream.pipe(res);
            }
        });
    },

    async pdf(req, res) {
        const type = req.headers['sec-fetch-dest'];
        if(type == 'document')
            return res.status(400).send("You don\'t have permission to access "+ config.app.url+'/pdf/'+req.params.name+' on this server.');
        var readStream = fs.createReadStream(appRoot+"/public/course/content/"+req.params.name);
        res.setHeader('Content-Type', 'application/pdf');
        readStream.pipe(res);
    }, 
    
    async image(req, res) {
        const type = req.headers['sec-fetch-dest'];
        var image = req.params.name;
        if(type == 'document')
            return res.status(400).send("You don\'t have permission to access "+ config.app.url+'/image/'+req.params.name+' on this server.');
        var readStream = fs.createReadStream(appRoot+"/public/course/content/thumbnail/"+req.params.name);
        var ext = image.split('.');
        if(ext.length > 0 && ext[1] == 'jpeg' || ext[1] == 'png' || ext[1] == 'jpg')
            res.setHeader('Content-Type', 'image/'+ext[1]);
        else return res.status(404).send("Invalid Image Format");
        readStream.pipe(res);
    },
    
    async courseQuizResult(req, res) {
        if(req.query.lId && req.query.sKey && req.query.ac){
            if(req.query.ac == 'Y291cnNl5'){
            db.Session.findOne({ where: { sessionKey: req.query.sKey} })
            .then(session => {
                if(session){
                    return db.CourseSectionLecture.findOne({ where: {id: req.query.lId, type:'quiz' }, required:true, include:[{model:db.CourseSection, required:true, include:[{model:db.Course, where:{companyId: session.companyId }, required:true }] }] })
                }else res.status(404).send('Invalid Learner received!'); 
            })
            .then(lecture =>{
                if(lecture)
                    return res.render('quiz-results', { lId:encrypt(req.query.lId), sKey:req.query.sKey,ac:req.query.ac } );
                else res.status(404).send('Invalid Lecture received!'); 
            })
        }else{
            db.Session.findOne({ where: { sessionKey: req.query.sKey} })
            .then(session => {
                if(session){
                    return db.QuizQuestion.findOne({ where: {quizId: req.query.lId }, required:true, include:[{model:db.QuizQuestionOption, required:true, include:[{model:db.QuizSecctionTracking, where:{quizId: req.query.lId }, required:false }] }] })
                }  else res.status(404).send('Invalid assessment received!');   
            })
            .then(assessment=>{
                if(assessment)
                return res.render('quiz-results', { lId:encrypt(req.query.lId), sKey:req.query.sKey,ac:req.query.ac } );
            else res.status(404).send('Invalid assessment!'); 
            })    
        }
    }   
    },
};