import express from 'express';
import { singleLoginStrategy, jwtStrategy } from '../../../../middleware/strategy';
import { userPermission } from '../../../../middleware/userPermission';
import learnerController from './learner.controller';
import { userImplant } from '../../../../middleware/auth';

export const learnerRouter = express.Router();
learnerRouter.route('/my-courses').get(jwtStrategy, userImplant, userPermission('my-courses'),learnerController.index);
learnerRouter.route('/my-assessments').get(jwtStrategy, userImplant,userPermission('my-assessments') ,  learnerController.quizleaderBoard);
learnerRouter.route('/course-auth').get(singleLoginStrategy, learnerController.courseAuth);
learnerRouter.route('/my-assessments/guidelines/:id/:sKey').get(jwtStrategy, userImplant,userPermission('guidelines') , learnerController.quizInstruction);
learnerRouter.route('/assessment/:id/:sKey').get(jwtStrategy, userImplant,userPermission('assessment') , learnerController.quizStart);
learnerRouter.route('/course/preview/:id').get(jwtStrategy, userImplant,userPermission('home-read') , learnerController.previewCourse);
learnerRouter.route('/course/:id/:sKey').get(jwtStrategy, userImplant,userPermission('course') ,learnerController.edit);
learnerRouter.route('/set-password').get(learnerController.setPassword);
learnerRouter.route('/bigbluebutton/sessionExpired').get(learnerController.logout);
learnerRouter.route('/meetingEnd').get(learnerController.meetingEnd);
learnerRouter.route('/video/:name').get(jwtStrategy, learnerController.streaming);
learnerRouter.route('/pdf/:name').get(jwtStrategy, learnerController.pdf);
learnerRouter.route('/image/:name').get(jwtStrategy, learnerController.image);
learnerRouter.route('/quiz-results').get(jwtStrategy , userImplant,/* userPermission('quiz-result-read'), */learnerController.courseQuizResult);