import express from 'express';
import { jwtStrategy } from '../../../../middleware/strategy';
import { userImplant } from '../../../../middleware/auth';
import policyController from './policy.controller';
import { userPermission } from '../../../../middleware/userPermission';


export const policyRouter = express.Router();
policyRouter.route('/policy').get( jwtStrategy,userImplant,userPermission('policy-read'), policyController.index);
policyRouter.route('/users_and_roles').get( jwtStrategy,userImplant,userPermission('policy-read'), policyController.userRoles);
policyRouter.route('/policy/:id').get(jwtStrategy,userImplant,userPermission('policy-read'), policyController.iamPolicyCreate)
